Attribute VB_Name = "DOC_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   DOC_Prozeduren
' Effekt beim Start von Word:
'   Das Modul erstellt in dieser Vorlage beim Aufruf von Word ...
'       1. in der aktiven Menleiste ein Men "PDF".
'       2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration
'          vorgesehen ist.
'   Danach speichert das Modul diese Vorlage, damit der Anwender nicht beim Beenden von Word damit
'   belstigt wird.
'   Wenn all das schon richtig eingestellt war, geschieht nichts.
' Effekt beim Aufruf von PDF > Erzeugen:
'   Das Modul erstellt aus der aktuellen Word-Datei eine PDF-Datei. Dazu erzeugt es eine
'   gleichnamige Postscript-Datei mit der Endung .ps und eine gleichnamige PDF-Datei mit der Endung
'   .pdf. Die Postscript-Datei wird wieder gelscht.
' Effekt beim Aufruf von "PDF > Info":
'   Das Modul zeigt Informationen ber sich an.
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten DOC_sss muss vorhanden sein. Dabei ist sss die
'   Sprache. Die Module GLOB_Prozeduren und GLOB_sss und die UserForm GLOB_UserForm mssen vorhanden
'   sein.
'   Die Vorlage normal.dot muss vorhanden sein.
'   Dieses Add-In darf nicht schreibgeschtzt sein. Es muss "Gs4Wordxxx_vvvsss.dot" heissen.
'   Dabei ist xxx ein beliebiger, optionaler Zusatz ohne Unterstrich "_". vvv ist die Versionsnummer
'   und sss die Sprache. Der genaue Name steht in der ThisDocument.Name.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   30.09.2001 J.W.Schmitz-Hbsch erstellt
'   05.11.2001 geschafft
'   30.12.2001 Erweitert fr Excel
'   06.01.2002 Erweitert fr Powerpoint
'   12.01.2002 Konfiguration funktioniert jetzt, auch wenn mehrere Word-Instanzen laufen.
'   23.01.2002 von allen drei Add-Ins genutzte Funktionen nach PDF_Global.bas ausgelagert
'   16.02.2002 umbenannt in DOC_Erzeugen
'   02.05.2002 Funktion MaxRechnerWartezeit_ermitteln gendert
'   09.05.2002 Erweitert um Lschen der PS-Datei wenn gbPSDateiLoeschenFlag gesetzt ist
'   18.05.2002 Auf UserForm umgestellt , Parametersteuerung je Add-In
'   02.07.2002 Erweitert um Dokumenteigenschaften und Lesezeichen
'   19.07.2002 Komplett umgebaut fr Version 2.40
'   27.08.2002 Erweitert fr Version 2.41
'   07.09.2002 Erweitert fr Version 2.42

' Die folgenden Konstanen steuern die Verarbeitung in der Prozedur fbVorlageAnpassen
'-----------------------------------------------------------------------------------
Private Const sVORLAGE_ACTION_ERZEUGEN As String = "DOC_Prozeduren.ERZEUGEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const sVORLAGE_ACTION_INFO As String = "DOC_Prozeduren.INFO"
    'Modul- und Prozedurname fr die Anzeige der Informationen ber das Add-In.
Private Const sVORLAGE_ACTION_KONFIGURIEREN As String = "GLOB_Prozeduren.KONFIGURIEREN"
    'Modul- und Prozedurname fr das Konfigurieren des Add-In.
Private Const sVORLAGE_ACTION_DOKUMENTATION As String = "GLOB_Prozeduren.DOKUMENTATION"
    'Modul- und Prozedurname fr die Anzeige der Dokumentation des Add-In.
Private Const sVORLAGE_ACTION_MAILTO As String = "GLOB_Prozeduren.MAILEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const lVORLAGE_BUTTON_FACEID As Long = 2144
    'Symbol-ID fr den PDF-Button: 481=Herz, 276=Trauriger Smilie, 2144 = Zahnrder
Private Const lVORLAGE_BUTTON_BEFOREID As Long = 21
    'ID eines Buttons in der Symboleiste Standard. Vor diesem Button wird der PDF-Button eingefgt.
    '2520=Neu, 23=ffnen, 3 = Speichern, 2521=Drucken, 109=Seitenansicht, 2566=Rechtscheibung und
    'Grammatik, '21=Ausschneiden,, ..., 984=Hilfe
    'Wenn die Nummer ungltig oder 0 ist, wird der PDF-Button vor den letzten Button eingefgt.

'===================================================================================================
'Vorlage anpassen beim Start von Word
'===================================================================================================
Sub AutoExec()

    On Error GoTo Fehler_aufgetreten:
    
    Call fbVorlageAnpassen(False)
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & "Fehler # " & Str(Err.Number) & sSPACE & Err.Description _
        & vbCr & "in " & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - AutoExec" _
        , vbExclamation, sTITEL_FEHLER

End Sub

Function fbVorlageAnpassen(bUnbedingtSpeichernFlag) As Boolean
    'Die Prozedur erstellt in dieser Vorlage beim Aufruf ...
    '    1. in der aktiven Menleiste ein Men "PDF".
    '    2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration
    '       vorgesehen ist.
    'Danach speichert die Prozedur diese Vorlage, damit der Anwender nicht beim Beenden von Word
    'damit belstigt wird. Wenn all das schon richtig eingestellt war, und bUnbedingterUpdateFlag =
    'False ist, dann geschieht nichts.
    'Argumente:
    '   bUnbedingterUpdateFlag
    '       Thrue = Die Vorlage wird unbedingt gespeichert.
    '       False = Die Vorlage wird nur dann gespeichert, wenn das Menue oder die Buttons verndert
    '               wurde.
    'Restriktionen:
    '   Die Vorlage normal.dot muss vorhanden sein. Ansonsten werden PDF-Men und -Button erst nach
    '   mehreren Starts von Word angezeigt. In der Vorlage Gs4Word sind sie aber mehrfach vorhanden.
    'Rckgabewert:
    '   True = das Men und ggf. die Symbolleiste "Standard" wurden angepasst. Die Vorlage wurde
    '   gespeichert.
    '   false = Die Vorlage konnte nicht gespeichert werden.
    'Effekt
    '   Entweder wurde Menleiste und ggf. Symbolleiste verndert, diese Vorlagedatei gespeichert
    '   und ein Hinwis angezeigt oder es wurde eine Fehlermeldung angezeigt.
       
    Const sVORLAGE_TAG As String = "Gs4WordDOC20010930"
        'Identifikation der PDF-Mens und -Buttons. Dieser Tag-String darf nie gendert werden.
    
    Dim cbAktiveMenueLeiste As CommandBar
    Dim cbEinControl As CommandBarControl
    Dim cbEinButton As CommandBarButton
    Dim iPosition As Integer
    Dim iZaehler As Integer
    Dim lAnzahlPDFMenues As Long
    Dim lAnzahlPDFButtons As Long
    Dim iFehlerNummer As Integer 'Fehlernumer fr Templates... SaveChanges:=wdSaveChanges
   
    ' (1) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_WORD)
    'um gbButtonFlag zu fllen. Die Konfiguration muss nicht in der Registry stehen.
        
    ' (2) CustomizationContext setzen
    '--------------------------------
    'Das muss vor dem Errechnen der Anzahl Mens und Buttons erfolgen, denn sonst findet Word nicht
    'die vorhanden PDF-Mens und -Buttons.
    Application.CustomizationContext = Templates.Item(ThisDocument.FullName)

    Set cbAktiveMenueLeiste = CommandBars.ActiveMenuBar
    
    ' (3) Prfen, ob Menu oder Button verndert werden muss
    '------------------------------------------------------
    'Prfen ob das PDF-Men schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Mens vorhanden sind!
    lAnzahlPDFMenues = 0
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'ein PDF-Menu gefunden
            lAnzahlPDFMenues = lAnzahlPDFMenues + 1
        End If
    Next cbEinControl
    
    'Prfen ob der PDF-Button schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Buttons vorhanden sind!
    lAnzahlPDFButtons = 0
    For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'einen PDF-Button gefunden
            lAnzahlPDFButtons = lAnzahlPDFButtons + 1
        End If
    Next cbEinControl
    
    'Fertig wenn nicht unbedingt gespeichert werden muss und das PDF-Men schon vorhanden ist und
    'der PDF-Button richtig an oder aus ist.
    If bUnbedingtSpeichernFlag = False _
    And lAnzahlPDFMenues = 1 _
    And ((gbButtonFlag = False And lAnzahlPDFButtons = 0) _
    Or (gbButtonFlag = True And lAnzahlPDFButtons = 1)) Then
        fbVorlageAnpassen = True
        Exit Function 'Sollzustand erreicht -> fertig
    End If
    'Es kann nur dann weitergehen, wenn die Vorlage nicht schreibgeschtzt ist.
    If (GetAttr(ThisDocument.FullName) And vbReadOnly) Then
        MsgBox sMSG_SCHREIBGESCHUETZT _
            & vbCr & "(" & ThisDocument.FullName & ")" _
            , vbExclamation, sTITEL_VORLAGEANPASSEN
        fbVorlageAnpassen = False
        Exit Function
    End If
    
    'Nicht weiter, wenn es nicht die erste Word-Instanz ist.
    'Wenn die Vorlage verndert, aber nicht gespeichert wird, fragt Word beim Beenden, ob die
    'Vorlage gespeichert werden soll. Wenn zwei Word-Tasks A und B vorhanden sind, und die Vorlage
    'wird im Taks A gespeichert, danach dieser Task A beendet wird und die Vorlage danach im Task B
    'gespeichert, fragt Word, ob die Vorlage berschrieben werden soll, weil sie schon in einem
    'anderen Task vendert wurde. In Word 97 kann nicht festgestellt werden, ob eine Vorlage schon
    'von einer anderen Session verwendet wurde oder noch wird. Deshalb wird geprft, ob es die
    'erste Word-Instanz ist.
    If fbVorlageIstAenderbar = False Then  'Mehr als ein Taks
        MsgBox sMSG_VORLAGENICHTVERAENDERBAR _
            & vbCr & "(" & ThisDocument.FullName & ")" _
            , vbInformation, sTITEL_VORLAGEANPASSEN
        fbVorlageAnpassen = False
        Exit Function
    End If

    ' (4) Aktive Menleiste um das PDF-Men erweitern
    '------------------------------------------------
    'Alle ggf. vorhandenen PDF-Mens lschen
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then
            cbEinControl.Delete
        End If
    Next cbEinControl
   
    'Men "PDF" einfgen
    Set cbEinControl = cbAktiveMenueLeiste.Controls.Add(Type:=msoControlPopup, _
        Before:=cbAktiveMenueLeiste.Controls.Count, Temporary:=True)
    With cbEinControl
        .Caption = sVORLAGE_MENU_CAPTION
        .Tag = sVORLAGE_TAG
    End With

    'Befehl "Erzeugen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_ERZEUGEN_CAPTION
        .OnAction = sVORLAGE_ACTION_ERZEUGEN
    End With
    
    'Befehl "Mailen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_MAILTO_CAPTION
        .OnAction = sVORLAGE_ACTION_MAILTO
        If gsMailToSwitch = sMAILTOSWITCH_AUS Then
            .Enabled = False
        End If
    End With
    
    'Befehl "Konfigurieren" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_KONFIGURIEREN_CAPTION
        .OnAction = sVORLAGE_ACTION_KONFIGURIEREN
    End With
        
    'Befehl "Dokumentation" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_DOKUMENTATION_CAPTION
        .OnAction = sVORLAGE_ACTION_DOKUMENTATION
        If gsDokuAufruf = sLEER Then
            .Enabled = False
        End If
    End With
        
    'Befehl "Info" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_INFO_CAPTION
        .OnAction = sVORLAGE_ACTION_INFO
    End With
        
    ' (5) Symbolleiste "Standard" um den PDF-Button erweitern
    '--------------------------------------------------------
    If lAnzahlPDFButtons > 0 Then
        'Alle vorhandenen PDF-Buttons lschen
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            If cbEinControl.Tag = sVORLAGE_TAG Then
                cbEinControl.Delete
            End If
        Next cbEinControl
    End If
    
    If gbButtonFlag = True Then
        'Einen PDF-Button einfgen.
        'Zuerst nach der Position des Buttons suchen, vor dem der PDF-Button stehen soll
        iZaehler = 0
        iPosition = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Count
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            iZaehler = iZaehler + 1
            If cbEinControl.Id = lVORLAGE_BUTTON_BEFOREID Then
                iPosition = iZaehler
                Exit For
            End If
        Next cbEinControl
        Set cbEinControl = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Add(Type:=msoControlButton, _
            Id:=1, Before:=iPosition, Temporary:=True)
        With cbEinControl
            .FaceId = lVORLAGE_BUTTON_FACEID
            '.BeginGroup = True 'wanns scheee maacht
            .Caption = sVORLAGE_BUTTON_CAPTION
            .Style = msoButtonAutomatic
            .Tag = sVORLAGE_TAG
            .TooltipText = sVORLAGE_BUTTON_TOOLTIPTEXT
            .OnAction = sVORLAGE_ACTION_ERZEUGEN
        End With
    End If
       
    ' (6) Vorlage speichern
    '----------------------
    'Wenn die Vorlage schon in einer anderen Word-Session geffnet ist, wird zuerst das Fenster
    '"Speichern unter" angezeigt. Danach gibt es einen Laufzeitfehler. Deshalb eine On Error
    'Klausel.
    On Error Resume Next ' falls das Speichern misslingt
    Templates.Item(ThisDocument.FullName).OpenAsDocument.Close SaveChanges:=wdSaveChanges
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then
        MsgBox sMSG_VORLAGEGESPEICHERT _
            & vbCr & "(" & ThisDocument.FullName & ")" _
            , vbInformation, sTITEL_VORLAGEANPASSEN
        fbVorlageAnpassen = True
    Else
        MsgBox sMSG_VORLAGENICHTGESPEICHERT _
            & vbCr & "(" & ThisDocument.FullName & ")" _
            , vbInformation, sTITEL_VORLAGEANPASSEN
        fbVorlageAnpassen = False
    End If
    
End Function
    
'===================================================================================================
'Men "PDF > Info"
'===================================================================================================
    
Private Sub INFO()
    'Die Prozedur zeigt eine Box mit Informationen ber das Add-In an.
    'Effekt
    '   Die Info-Box wurde angezeigt.

    Call fbInfo_anzeigen(ThisDocument.FullName)
   
End Sub

'===================================================================================================
'Men "PDF > Erzeugen..."
'===================================================================================================

Sub ERZEUGEN()
    'Effekt
    '   Ggf. wurden ein oder zwei Dialoge gefhrt oder eine Fehlermeldung angezeigt.
    '   Ggf. wurde eine Postscript-Datei gelscht.
    '   Ggf. wurde  eine PDF-Datei erzeugt.
    
    On Error GoTo Fehler_aufgetreten:
    
    Dim sPDFDateiName As String 'Name der PDF-Datei mit absolutem Pfad
    Dim sPSDateiName As String 'Name der Postscript-Datei mit absolutem Pfad
    
    gsMailtoDateiName = sLEER
     
    ' (1) Office-Datei prfen
    '------------------------
    If fbOfficeDatei_gespeichert() = False Then
        Exit Sub
    End If
       
    ' (2) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_WORD) 'Dabei auch gsAusgabeMedienListe() fllen
    If fbKonfiguration_testen(sTASKNAME_WORD) = False Then
        MsgBox sMSG_KONFIGUNVOLLSTAENDIG, vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
    
    ' (3) Name der Postscript- und PDF-Datei ermitteln
    '-------------------------------------------------
    gsBasisDateiName = fsBasisDateiName_ermitteln(gsSymbDateiName)
    If gsBasisDateiName = sLEER Then
        Exit Sub
    End If
                    
    ' (4) Einstellungen_waehlen
    '--------------------------
    If fbEinstellungen_waehlen(sTASKNAME_WORD) = False Then
        Exit Sub
    End If
     
    ' (5) Namen der Postscript- und PDF-Dateien prfen und Dateien lschen, wenn vorhanden
    '-------------------------------------------------------------------------------------
    sPSDateiName = gsBasisDateiName & sPS
    sPDFDateiName = gsBasisDateiName & sPDF
    If fbDatei_pruefen_loeschen(sPSDateiName) = False Then
        Exit Sub
    End If
    If fbDatei_pruefen_loeschen(sPDFDateiName) = False Then
        Exit Sub
    End If
    
    ' (6) Postscript-Datei erzeugen
    '------------------------------
    If fbPSDatei_erzeugen(ActiveDocument.FullName, sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (7) Postscript-Datei ergaenzen
    '-------------------------------
    If fbPSDatei_ergaenzen(sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (8) PDF-Datei erzeugen
    '-----------------------
    If fbPDFDatei_erzeugen(sPSDateiName, sPDFDateiName, gsAusgabeMedium) = False Then
        Exit Sub
    End If
    
    ' (9) Postscript-Datei wieder lschen
    '------------------------------------
    If gbPSDateiLoeschenFlag = True Then
        If fbDatei_loeschen(sPSDateiName) = False Then
            Exit Sub
        End If
    End If
    
    ' (10) PDF-Datei anzeigen
    '-----------------------
    Call fbPDFDatei_anzeigen(sPDFDateiName)
    
    ' (11) PDF-Datei zum mailen merken
    '---------------------------------
    gsMailtoDateiName = sPDFDateiName
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - ERZEUGEN" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER
    
End Sub

'===================================================================================================
'Alle Private Funktionen und Subroutinen, die nur von der Subroutine ERZEUGEN verwendet werden.
'===================================================================================================

Private Function fbOfficeDatei_gespeichert() As Boolean
    'Die Funktion prft, ob eine Office-Datei geffnent ist und ob es jemals gespeichert wurde.
    'Global:
    '   ActiveDocument.Path
    '   ActiveDocument.Name
    '   Documents.Count
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   False = Office-Datei ist nicht gespeichert
    '   True = Office-Datei ist gespeichert und hat eine Pfad
    'Effekt
    '   Ggf. wurde eine Fehlermeldung angezeigt.
    
    fbOfficeDatei_gespeichert = False
    
    If Documents.Count < 1 Then  'Es ist keine Office-Datei geffnet
        MsgBox sMSG_KEINEOFFICEDATEI, vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
    
    If ActiveDocument.Name = sLEER _
    Or ActiveDocument.Path = sLEER _
    Or flLetztesVorkommen_suchen(ActiveDocument.Name, ".") <= 0 Then 'Die geffnete Office-Datei ist nicht gespeichert
        MsgBox sMSG_OFFICEDATEINICHTGESPEICHERT _
            & vbCr & "(" & CurDir & gsPathSeparator & ActiveDocument.Name & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
    
    fbOfficeDatei_gespeichert = True

End Function

Private Function fbEinstellungen_waehlen(sTaskName As String) As Boolean
    'Die Funktion zeigt die UserForm fr die nderbaren Einstellungen an.
    'Die genderten Werte werden in den globalen Variablen gespeichert.
    'Falls der BasisDateiName verndert wurde, wird er neu erzeugt und geprft.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus PDF_Global entsprechen.
    'Global:
    '   gbDialogFlag wird gelesen
    '   gsPrintSwitch wird ggf. verndert
    '   gsAusgabeMedium wird ggf. verndert
    '   gsBasisDateiName wird ggf. verndert
    '   giDialogEffekt wird gesetzt
    'Rckgabewert:
    '   False = Die Auswahl der Einstellungen wurde abgebrochen oder der genderte BasisDateiName
    '           ist fehlerhaft
    '   True = Die Einstellungen wurden ausgewhlt
    'Effekt
    
    If gbDialogFlag = True Then 'Einstellungen im Dialog ndern
        GLOB_UserForm.Show
        fbEinstellungen_waehlen = giDialogEffekt
        
        If giDialogEffekt = True Then
            gsBasisDateiName = fsBasisDateiName_ermitteln(gsBasisDateiName)
            If gsBasisDateiName = sLEER Then 'genderter BasisDateiName ist fehlerhaft
                fbEinstellungen_waehlen = False
            End If
        End If
    Else
        fbEinstellungen_waehlen = True
    End If

End Function

Private Function fbPSDatei_erzeugen(sOfficeDateiName As String, sPSDateiName As String) As Boolean
    'Erzeugt aus sOfficeDateiName die Postscriptdatei sPSDateiName. Wenn das nicht mglich ist, wird
    'eine Meldung angezeigt.
    'Global:
    '   gbDateiumleitungsFlag wird gelesen
    '   gsPrintSwitch wird gelesen
    'Argumente:
    '   sOfficeDateiName = Dateiname der aktiven Office-Datei
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht erzeugt werden.
    '   True = Postscript-Datei sPSDateiName wurde erzeugt.
    'Effekt
    '   Entweder wurde eine Postscript-Datei erzeugt
    '   oder eine Fehlermeldung angezeigt.
    
    Dim bPSDateiLocked As Boolean
    Dim sStandardDruckerName As String 'Name des aktuell eingesteller Druckers mit on-Klausel
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    Dim vRange As Variant
    Dim vItem As Variant
    Dim sFrom As String
    Dim sTo As String
    
    sStandardDruckerName = ActivePrinter
    If fbActivePrinterAuf_gsDruckerName_setzen() = False Then
        MsgBox sMSG_PSDRUCKERUNBEKANNT _
            & vbCr & "(" & gsPSDruckerName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End If
    
    'Range ist wdPrintAllDocument, wdPrintCurrentPage, wdPrintFromTo, wdPrintRangeOfPages oder wdPrintSelection
    Select Case gsPrintSwitch
    Case sPRINTSWITCH_WORD_DOKUMENT 'Das ganze Dokument ausgeben
        vItem = wdPrintDocumentContent
        vRange = wdPrintAllDocument
    Case sPRINTSWITCH_WORD_SEITE 'Nur die aktuelle Seite ausgeben
        'vItem = wdPrintDocumentContent
        'vRange = wdPrintCurrentPage 'funktioniert unter Wind 8.0 nicht immer
        vRange = wdPrintFromTo
        sFrom = Selection.Information(wdActiveEndPageNumber)
        sTo = sFrom
    Case sPRINTSWITCH_WORD_MARKIERUNG ' Nur markierte Seiten ausgeben
        vItem = wdPrintDocumentContent
        vRange = wdPrintSelection
    Case sPRINTSWITCH_WORD_EIGENSCHAFT ' = "Dokumenteneingenschaften"
        vItem = wdPrintProperties
        vRange = wdPrintAllDocument
    Case sPRINTSWITCH_WORD_KOMMENTARE ' = "Kommentare"
        If ActiveDocument.Comments.Count = 0 Then
            MsgBox sMSG_KEINEKOMMENTARE _
                , vbExclamation, sTITEL_ERZEUGEN
            fbPSDatei_erzeugen = False
            Exit Function
        End If
        vItem = wdPrintComments
        vRange = wdPrintAllDocument
    Case sPRINTSWITCH_WORD_FORMATVORLAGEN ' = "Formatvorlagen"
        vItem = wdPrintStyles
        vRange = wdPrintAllDocument
    Case sPRINTSWITCH_WORD_AUTOTEXTE ' = "AutoText-Eintrge"
        vItem = wdPrintAutoTextEntries
        vRange = wdPrintAllDocument
    Case sPRINTSWITCH_WORD_TASTENBELEGUNG ' = "Tastenbelegung"
        vItem = wdPrintKeyAssignments
        vRange = wdPrintAllDocument
    Case Else
        MsgBox sMSG_PRINTSWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End Select
    
    'Jetzt drucken. Durch Background=False wird erzwungen, dass das Add-In erst dann weiterluft,
    'wenn die Postscript-Datei vollstndig erzeugt wurde.
    'Unter NT 4.0 bercksichtigt PrintOut das aktuelle Verzeichnis.
    'Unter ME MUSS der Pfad angegeben werden.
    If vRange = wdPrintFromTo Then
        Application.PrintOut FileName:=sOfficeDateiName, OutputFileName:=sPSDateiName, _
            Range:=vRange, From:=sFrom, To:=sTo, PrintToFile:=True, Background:=False
    Else
        Application.PrintOut FileName:=sOfficeDateiName, OutputFileName:=sPSDateiName, _
            Range:=vRange, Item:=vItem, PrintToFile:=True, Background:=False
    End If
    'In Word ist im Druckdialog der Schalter "Ausgabe in Datei umleiten" jetzt angeschaltet (auch
    'wenn wieder der Standard-Drucker aktiviert wurde). Um das abzuschalten drucken wir das
    'Dokument nochmal, aber nicht in eine Datei und nicht nur die Seite "0"!
    If gbDateiumleitungsFlag = True Then
        Application.PrintOut FileName:=sOfficeDateiName, _
            Range:=wdPrintRangeOfPages, Pages:="0", PrintToFile:=False, Background:=False
            'Es funktioniert nicht mit Kyocera FS800
    End If
    
    'Standard-Drucker wieder setzen
    If sStandardDruckerName <> ActivePrinter Then
        On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (na ja)
        ActivePrinter = sStandardDruckerName
        On Error GoTo 0
    End If
    
    If Dir(sPSDateiName, vbNormal) <> sLEER Then
        'Dir liefert den ersten gefundenden Dateinamen oder sLEER
        If FileLen(sPSDateiName) > 0 Then
            fbPSDatei_erzeugen = True
            Exit Function
        End If
    End If
    
    'Ab hier nur noch Fehlerhandling
    If InStr(sPSDateiName, ",") > 0 Then
        MsgBox sMSG_PSDATEIMITKOMMA _
            & vbCr & "(" & gsPSDruckerName & ") - (" & sPSDateiName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    Else
        MsgBox sMSG_PSDATEINICHTERZEUGT _
            & vbCr & "(" & gsPSDruckerName & ") - (" & sPSDateiName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    End If
    
End Function

Private Function fbPSDatei_ergaenzen(sPSDateiName As String) As Boolean
    'Die Funktion ergnzt die Postscriptdatei sPSDateiName um Dokumenteigenschaften und Lesezeichen
    'Global:
    '   gbPdfmarkFlag wird gelesen
    '   gsPdfOutSwitch wird gelesen
    'Argumente:
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    'Effekt
    '   Ggf. wurde die Postscript-Datei verndert
    '   oder eine Fehlermeldung angezeigt.
    
    Dim oEinParagraph As Object
    Dim sAuthor As String
    Dim sCreationDate As String
    Dim sCreator As String
    Dim sTitle As String
    Dim sSubject As String
    Dim sKeywords As String
    Dim sModDate As String
    Dim lTablesOfContents As Long
    Dim bUeberschriften As Boolean
    Dim sPageHeight As Single
    Dim sPageWidth As Single
    Dim iBisEbene As Integer
    
    If gbPdfmarkFlag = False Then
        fbPSDatei_ergaenzen = True
        Exit Function
    End If
    
    Select Case gsPdfOutSwitch
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS1
        iBisEbene = 1
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS2
        iBisEbene = 2
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS3
        iBisEbene = 3
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS4
        iBisEbene = 4
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS5
        iBisEbene = 5
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS6
        iBisEbene = 6
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS7
        iBisEbene = 7
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS8
        iBisEbene = 8
    Case sPDFOUTSWITCH_WORD_ALLEUEBERSCHRIFTEN
         iBisEbene = 9
   Case Else
        iBisEbene = 0
    End Select
    
    
    On Error Resume Next ' falls ein Element nicht definiert ist
    sAuthor = ActiveDocument.BuiltInDocumentProperties("Author")
    sCreationDate = Format(ActiveDocument.BuiltInDocumentProperties("Creation date"), "yyyymmDdhhnnss")
    sCreator = ActiveDocument.BuiltInDocumentProperties("Application name")
    sTitle = ActiveDocument.BuiltInDocumentProperties("Title")
    sSubject = ActiveDocument.BuiltInDocumentProperties("Subject")
    sKeywords = ActiveDocument.BuiltInDocumentProperties("Keywords")
    sModDate = Format(ActiveDocument.BuiltInDocumentProperties("Last save time"), "yyyymmDdhhnnss")
    lTablesOfContents = ActiveDocument.TablesOfContents.Count
    bUeberschriften = fbEinVerzeichnis_erzeugen_ByParagraph(sPSDateiName, sLEER, iBisEbene, False)
    sPageHeight = ActiveDocument.PageSetup.PageHeight
    sPageWidth = ActiveDocument.PageSetup.PageWidth
    On Error GoTo 0
    
    fbPSDatei_ergaenzen = fbPSDateiPdfmark_ergaenzen(sPSDateiName, _
    sAuthor, sCreationDate, sCreator, sTitle, _
    sSubject, sKeywords, sModDate, lTablesOfContents, bUeberschriften, _
    sPageHeight, sPageWidth)
    
    If fbPSDatei_ergaenzen = False Then
        Exit Function
    End If
    
    'Lesezeichen
    '-----------
    Dim oEinVerzeichnis As Object
    Dim sView As String
    
    sView = "/View [ /XYZ null null null ]" 'Default
    ActiveDocument.Bookmarks.ShowHidden = True
    Application.ScreenUpdating = False
    ' Die Bookmarks fr die Kapitel des Inhaltsverzeichnisses sind versteckt
    
    'Alle Inhaltsverzeichnisse
    Select Case gsPdfOutSwitch
    Case sPDFOUTSWITCH_WORD_KEINELESEZEICHEN
        ' nichts tuen
    Case sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS1 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS2 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS3 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS4 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS5 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS6 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS7 _
    , sPDFOUTSWITCH_WORD_UEBERSCHRIFTENBIS8 _
    , sPDFOUTSWITCH_WORD_ALLEUEBERSCHRIFTEN
        If bUeberschriften = True Then
            Call fbEinVerzeichnis_erzeugen_ByParagraph(sPSDateiName, sView, iBisEbene, True)
        End If
    Case sPDFOUTSWITCH_WORD_ALLEVERZEICHNISSE _
    , sPDFOUTSWITCH_WORD_NURINHALTSVERZEICHNIS
        If ActiveDocument.TablesOfContents.Count >= 1 Then
            For Each oEinVerzeichnis In ActiveDocument.TablesOfContents
                Call fbEinVerzeichnis_erzeugen_ByField(sPSDateiName, oEinVerzeichnis, sView, "I")
            Next oEinVerzeichnis
        End If
    Case Else
        MsgBox sMSG_PDFOUTSWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_ergaenzen = False
        Exit Function
    End Select
    
    'Alle Abbildungsverzeichnisse
    If gsPdfOutSwitch = sPDFOUTSWITCH_WORD_ALLEVERZEICHNISSE _
    And ActiveDocument.TablesOfFigures.Count >= 1 Then
        For Each oEinVerzeichnis In ActiveDocument.TablesOfFigures
            Call fbEinVerzeichnis_erzeugen_ByField(sPSDateiName, oEinVerzeichnis, sView, "A")
        Next oEinVerzeichnis
    End If
    ActiveDocument.Bookmarks.ShowHidden = False
    Application.ScreenUpdating = True
        
    fbPSDatei_ergaenzen = True
    
End Function

Private Function fbEinVerzeichnis_erzeugen_ByParagraph(sPSDateiName As String, sView As String, _
iBisEbene As Integer, bErzeugen As Boolean) _
As Boolean
    'Ergnzt die Postscriptdatei sPSDateiName um Lesezeichen fr alle berschriften
    'Argumente:
    '   sPSDateiName = Dateiname der Postscript-Datei
    '   sView = Eintrag fr /VIEW
    '   iBisEbene = Ebene bis zu der Lesezeichen erzeugt werden sollen (1 bis 9)
    '   bErzeugen = Aktion die durchgefhrt werden soll
    '               True = Lesezeichen erzeugen
    '               False = nur prfen, ob Lesezeichen erzeugt wrden
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    'Effekt
    '   Ggf. wurde eine Postscript-Datei verndert
    '   oder eine Fehlermeldung angezeigt.
    
    Dim oEinParagraph As Object
    Dim iUeberschriftZaehler As Integer
    Dim sText As String
    Dim lPos As Long
    Dim iAnzahl As Integer
    Dim lNummer As Integer
    Dim iStufe As Integer
    Dim iStufeAlt As Integer
    Dim iCountTab(9) As Integer 'Hilfstabelle zum Errechnen von iCount()
    Dim sTitle() As String 'Titel je Lesezeichen
    Dim iCount() As Integer 'Je Lesezeichen Anzahl untergeordnete Lesezeichen
    Dim iPage() As Integer 'Seitennummer je Lesezeichen
    
    iAnzahl = ActiveDocument.Paragraphs.Count
    If iAnzahl = 0 Then
        fbEinVerzeichnis_erzeugen_ByParagraph = False
        Exit Function
    End If
    ReDim sTitle(iAnzahl)
    ReDim iLevel(iAnzahl)
    ReDim iCount(iAnzahl)
    ReDim iPage(iAnzahl)
    
    'Dokumentenschutz berprfen
    '   wdNoProtection = -1
    '   wdAllowOnlyRevisions = 0
    '   wdAllowOnlyComments = 1
    '   wdAllowOnlyFormFields = 2
    
    If ActiveDocument.ProtectionType = wdAllowOnlyComments _
    Or ActiveDocument.ProtectionType = wdAllowOnlyFormFields Then
        MsgBox sMSG_SCHUTZZUHOCH, vbInformation, sTITEL_ERZEUGEN
        fbEinVerzeichnis_erzeugen_ByParagraph = False
        Exit Function
    End If
    
    iUeberschriftZaehler = 0
    For Each oEinParagraph In ActiveDocument.Paragraphs
    ' -1 = kein schutz
        If (oEinParagraph.OutlineLevel = wdOutlineLevel1 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel2 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel3 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel4 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel5 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel6 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel7 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel8 _
        Or oEinParagraph.OutlineLevel = wdOutlineLevel9) _
        And oEinParagraph.OutlineLevel <= iBisEbene Then
        'Nicht auf <> wdOutlineLevelBodyText abfragen, falls Microsoft noch weitere OutlineLevel erfindet...
            sText = LTrim(oEinParagraph.Range.ListFormat.ListString & " " _
                & Left(oEinParagraph.Range.Text, Len(oEinParagraph.Range.Text) - 1))
            'jeden Tabulator durch ein Leerzeichen ersetzen
            lPos = InStr(1, sText, Chr(9)) 'Erstes Vorkommen von Tab suchen
            Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. Tab nicht mehr gefunden wurde
              sText = Left(sText, lPos - 1) & sSPACE & Mid(sText, lPos + 1)
              lPos = InStr(lPos, sText, Chr(9))
            Loop
            'Alle anderen Steuerzeichen entfernen
            For lNummer = 0 To 31
                lPos = InStr(1, sText, Chr(lNummer)) 'Erstes Vorkommen von Chr(lNummer) suchen
                Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. das Steuerzeichen nicht mehr gefunden wurde
                  sText = Left(sText, lPos - 1) & Mid(sText, lPos + 1)
                  lPos = InStr(lPos, sText, Chr(lNummer))
                Loop
            Next lNummer
            If sText <> sLEER Then
                'Es wird kein Lesezeichen erzeugt: Wenn bErzeugen nicht True ist, reicht das aus.
                If bErzeugen = False Then
                    fbEinVerzeichnis_erzeugen_ByParagraph = True
                    Exit Function
                End If
                
                sTitle(iUeberschriftZaehler) = sText
                iPage(iUeberschriftZaehler) = oEinParagraph.Range.Information(wdActiveEndPageNumber)
                iStufe = oEinParagraph.OutlineLevel
                iLevel(iUeberschriftZaehler) = iStufe
                'Count
                'Je Lesezeichen wird mit Count eingetragen, wie viele Lesezeichen
                'hierarchisch darunter liegen
                If iStufeAlt < iStufe Then
                    iCountTab(iStufe) = iUeberschriftZaehler - 1
                ElseIf iStufeAlt > iStufe Then
                    For lPos = iStufe + 1 To iStufeAlt
                        iCountTab(lPos) = -1
                    Next lPos
                End If
                For lPos = 1 To iStufe
                    If iStufe <= lPos _
                    And iCountTab(lPos) >= 0 Then
                        iCount(iCountTab(lPos)) = iCount(iCountTab(lPos)) + 1
                    End If
                Next lPos
                'Vorbereitung fr den nchsten Durchlauf
                iStufeAlt = iLevel(iUeberschriftZaehler)
                iUeberschriftZaehler = iUeberschriftZaehler + 1
            End If
        End If
    Next oEinParagraph
    If iUeberschriftZaehler = 0 Then
        fbEinVerzeichnis_erzeugen_ByParagraph = False
        Exit Function
    End If
    
    iAnzahl = iUeberschriftZaehler - 1
    ReDim Preserve sTitle(iAnzahl)
    ReDim Preserve iLevel(iAnzahl)
    ReDim Preserve iCount(iAnzahl)
    ReDim Preserve iPage(iAnzahl)
  
    'OUT
    'Ein Inhaltsverzeichnis an die PS-Datei anhngen
    Open sPSDateiName For Append Access Write Lock Read Write As #1
    For iUeberschriftZaehler = LBound(iLevel) To UBound(iLevel)
        If iCount(iUeberschriftZaehler) = 0 Then
            sText = "[" _
                & " /Page " & iPage(iUeberschriftZaehler) _
                & " /Title (" & fsPostscriptString_erzeugen(sTitle(iUeberschriftZaehler)) & ")" _
                & " " & sView _
                & " /OUT pdfmark"
        Else
            sText = "[" _
                & " /Page " & iPage(iUeberschriftZaehler) _
                & " /Title (" & fsPostscriptString_erzeugen(sTitle(iUeberschriftZaehler)) & ")" _
                & " /Count " & iCount(iUeberschriftZaehler) _
                & " " & sView _
                & " /OUT pdfmark"
        End If
        Print #1, sText

    Next iUeberschriftZaehler
    Close #1
    fbEinVerzeichnis_erzeugen_ByParagraph = True

End Function
Private Function fbEinVerzeichnis_erzeugen_ByField(sPSDateiName As String, _
oEinVerzeichnis As Object, sView As String, sVerzeichnisType As String) As Boolean
    'Ergnzt die Postscriptdatei sPSDateiName um Lesezeichen fr ein Verzeichnis
    'Global:
    'Argumente:
    '   sPSDateiName = Dateiname der Postscript-Datei
    '   oEinVerzeichnis = bjekt mit dem Verzeichnis
    '   sView = Eintrag fr /VIEW
    '   sVerzeichnisType = Type des Verzeichnisses
    '       I = Inhaltsverzeichnis
    '       A = Abbildungsverzeichnis
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    'Effekt
    '   Ggf. wurde eine Postscript-Datei verndert
    '   oder eine Fehlermeldung angezeigt.
            
    Dim oEinBookmark As Object
    Dim oEinSatz As Object
    Dim iSatzZaehler As Integer
    Dim oEinFeld As Object
    Dim iFeldZaehler As Integer
    Dim sFehler As String ' "" = kein Fehler
    Dim sText As String
    Dim lPos As Long
    Dim iAnzahl As Integer
    Dim iStufe As Integer
    Dim iStufeAlt As Integer
    Dim iCountTab(9) As Integer 'Hilfstabelle zum Errechnen von iCount()
    Dim sTitle1() As String 'Teil des Titels vor den ersten Tabulator
    Dim sTitle2() As String 'Teil des Titels zwischen erstem Tabulator und der Zeilennummer
    Dim sTitle() As String 'Titel je Lesezeichen
    Dim iCount() As Integer 'Je Lesezeichen Anzahl untergeordnete Lesezeichen
    Dim iPage() As Integer 'Seitennummer je Lesezeichen
    
    Dim iLevel() As Integer 'Hierarcheebene je Lesezeichen
    'In den Elementen steht der Index fr die Tabellen sTitle, iLevel, iCount und iPage
    'Der Index in iLevel ist der Level:
    '   Beim Verzeichnis mit Hierarchie : (0) = Verzeichnistitel; (1) = berschrift 1; (2) =
    '   berschrift2 ; usw.
    '   Beim Verzeichnis ohne Hierarchie: (0) = Verzeichnistitel; (1) = Eintrge;
    
    iAnzahl = oEinVerzeichnis.Range.Fields.Count - 1 'Das erste Feld ist immer das wdFieldTOC-Feld, _
            'die folgenden Felder sind wdFieldPageRef-Felder
    If iAnzahl = 0 Then
        iAnzahl = 1
    End If
    ReDim sTitle1(iAnzahl)
    ReDim sTitle2(iAnzahl)
    ReDim sTitle(iAnzahl)
    ReDim iLevel(iAnzahl)
    ReDim iCount(iAnzahl)
    ReDim iPage(iAnzahl)
    
    'Alle Stze abklappern. Mehrere Stze knnen einen Titel bilden
    iSatzZaehler = 0
    For Each oEinSatz In oEinVerzeichnis.Range.Sentences
        If Not oEinSatz.Style Is Nothing Then 'Der Satz hat einen Inhalt
            If oEinSatz.Fields.Count = 0 Then 'Der Satz hat kein Feld. Es ist unvollstndig;
                'Nicht als Satz zhlen; Nur Titel merken
                sText = sText & oEinSatz.Text
            Else 'Feld gefunden, Satz ist komplett
                sText = sText & oEinSatz.Text
                If oEinVerzeichnis.IncludePageNumbers = True Then
                    lPos = flLetztesVorkommen_suchen(sText, vbTab)
                    If lPos > 0 Then 'Sonst Fehler
                        sText = Left(sText, lPos - 1)
                    'Else Kein Else, denn der Fall kann vorkommen.
                    '     sFehler = sText
                    End If
                End If
                lPos = InStr(sText, vbTab)
                If lPos > 0 Then
                    sTitle1(iSatzZaehler) = Left(sText, lPos - 1)
                    sTitle2(iSatzZaehler) = Mid(sText, lPos + 1)
                Else
                    sTitle1(iSatzZaehler) = sLEER
                    sTitle2(iSatzZaehler) = sText
                End If
                sText = sLEER
                iSatzZaehler = iSatzZaehler + 1
           End If
        End If
    Next oEinSatz
    
    'Alle Felder abklappern
    iFeldZaehler = 1
    For Each oEinFeld In oEinVerzeichnis.Range.Fields
        'Prfen was fr ein Feld es ist
        '   (a) Das erste Feld enthlt das wdFieldTOC-Feld und alle wdFieldPageRef-Felder
        '   (b) Die anderen Felder enthalten jeweils ein wdFieldPageRef-Feld
        If oEinFeld.Type = wdFieldTOC Then ' Verzeichnisfeld
            If sVerzeichnisType = "I" Then 'Inhaltsverzeichnis
'OFFEN Der deutsche Text wird auch in fremdsprachigen Dokumenten verwendet. Hier ist ein anderes
'Konzept erforderlich!
                sTitle(0) = sTEXT_INHALTSVERZEICHNIS
            Else
                If oEinVerzeichnis.Caption = sLEER Then
                    sTitle(0) = sTEXT_ABBILDUNGSVERZEICHNIS
                Else
                    sTitle(0) = oEinVerzeichnis.Caption
                End If
            End If
            lPos = oEinVerzeichnis.Range.Start
            iPage(0) = _
                ActiveDocument.Range(Start:=lPos, End:=lPos).Information(wdActiveEndPageNumber)
            iLevel(iFeldZaehler) = 0 'Nur der Vollstndigkeit halber; der Wert steht schon da
       ElseIf oEinFeld.Type = wdFieldPageRef Then
            'Bookmark im Dokument ermitteln
            sText = oEinFeld.Code.Text
            lPos = flLetztesVorkommen_suchen(LCase(sText), "_toc")
            If lPos > 0 Then ' Sonst Fehler
                sText = Mid(sText, lPos)
            Else
                sFehler = sText
            End If
            sText = Left(sText, InStr(sText, sSPACE) - 1)
            If ActiveDocument.Bookmarks.Exists(sText) = True Then 'Sonst Fehler
                Set oEinBookmark = ActiveDocument.Bookmarks(sText)
                sText = oEinBookmark.Range.Text
                'jeden Tabulator durch ein Leerzeichen ersetzen
                lPos = InStr(1, sText, Chr(9)) 'Erstes Vorkommen von Tab suchen
                Do While lPos > 0 'Solange suchen bis lPos = 0 ist; dh. Tab nicht mehr gefunden wurde
                  sText = Left(sText, lPos - 1) & sSPACE & Mid(sText, lPos + 1)
                  lPos = InStr(lPos, sText, Chr(9))
                Loop
                sTitle(iFeldZaehler) = sText
                iPage(iFeldZaehler) = oEinBookmark.Range.Information(wdActiveEndPageNumber)
                If sVerzeichnisType = "I" Then 'Inhaltsverzeichnis
                    If Not oEinBookmark.Range.Style Is Nothing Then
                        'Level 1 bis 9
                        Select Case ActiveDocument.Styles(oEinBookmark.Range.Style.NameLocal).ParagraphFormat.OutlineLevel
                        Case wdOutlineLevel1
                            iStufe = 1
                        Case wdOutlineLevel2
                            iStufe = 2
                        Case wdOutlineLevel3
                            iStufe = 3
                        Case wdOutlineLevel4
                            iStufe = 4
                        Case wdOutlineLevel5
                            iStufe = 5
                        Case wdOutlineLevel6
                            iStufe = 6
                        Case wdOutlineLevel7
                            iStufe = 7
                        Case wdOutlineLevel8
                            iStufe = 8
                        Case wdOutlineLevel9
                            iStufe = 9
                        Case Else
                             iStufe = iLevel(iFeldZaehler - 1)
                        End Select
                    Else
                        'Kein Style vorhanden, z.B. bei einer Grafik als berschrift
                        'Es kann kein Level ermittel werden; deshalb Level unverndert
                        'Das kann vorkommen, wenn das Inhaltsverzeichnis nicht aktuell ist,
                        'und deshalb Bookmarks(sText) falsch verweist.
                        iStufe = iLevel(iFeldZaehler - 1)
                    End If
                Else
                    iStufe = 1
                End If
                iLevel(iFeldZaehler) = iStufe
                'Count
                'Je Lesezeichen wird mit Count eingetragen, wie viele Lesezeichen
                'hierarchisch darunter liegen
                If iStufeAlt < iStufe Then
                    iCountTab(iStufe) = iFeldZaehler - 1
                ElseIf iStufeAlt > iStufe Then
                    For lPos = iStufe + 1 To iStufeAlt
                        iCountTab(lPos) = -1
                    Next lPos
                End If
                For lPos = 1 To iStufe
                    If iStufe <= lPos _
                    And iCountTab(lPos) >= 0 Then
                        iCount(iCountTab(lPos)) = iCount(iCountTab(lPos)) + 1
                    End If
                Next lPos
                'Vorbereitung fr den nchsten Durchlauf
                iStufeAlt = iLevel(iFeldZaehler)
                iFeldZaehler = iFeldZaehler + 1
            Else
                sFehler = oEinBookmark.Range.Text
            End If
        End If
    Next oEinFeld
        
    If sFehler = sLEER _
    And iAnzahl > iFeldZaehler - 1 Then
        iAnzahl = iFeldZaehler - 1
        ReDim Preserve sTitle1(iAnzahl)
        ReDim PreservesTitle2(iAnzahl)
        ReDim PreservesTitle(iAnzahl)
        ReDim PreserveiLevel(iAnzahl)
        ReDim PreserveiCount(iAnzahl)
        ReDim PreserveiPage(iAnzahl)
    End If
        
'    If sFehler = sLEER _
'    And iAnzahl <> iFeldZaehler - 1 Then
'       sFehler = iAnzahl & "/" & iFeldZaehler
'    End If
    
    If sFehler = sLEER Then
        'Prfen ob Nummererung vorhanden ist
        If sTitle1(0) <> sLEER _
        And sTitle2(0) = sTitle(1) _
        And sTitle1(iAnzahl - 1) <> sLEER _
        And sTitle2(iAnzahl - 1) = sTitle(iAnzahl) Then
            For iFeldZaehler = 0 To iAnzahl - 1
                sTitle(iFeldZaehler + 1) = sTitle1(iFeldZaehler) & sSPACE & sTitle2(iFeldZaehler)
            Next iFeldZaehler
        ElseIf sTitle1(1) <> sLEER _
        And sTitle2(1) = sTitle(1) _
        And sTitle1(iAnzahl) <> sLEER _
        And sTitle2(iAnzahl) = sTitle(iAnzahl) Then
            For iFeldZaehler = 1 To iAnzahl
                sTitle(iFeldZaehler) = sTitle1(iFeldZaehler) & sSPACE & sTitle2(iFeldZaehler)
            Next iFeldZaehler
        End If
        'OUT
        'Ein Inhaltsverzeichnis an die PS-Datei anhngen
        Open sPSDateiName For Append Access Write Lock Read Write As #1
        For iFeldZaehler = 0 To iAnzahl
            If iCount(iFeldZaehler) = 0 Then
                sText = "[" _
                    & " /Page " & iPage(iFeldZaehler) _
                    & " /Title (" & fsPostscriptString_erzeugen(sTitle(iFeldZaehler)) & ")" _
                    & " " & sView _
                    & " /OUT pdfmark"
            Else
                sText = "[" _
                    & " /Page " & iPage(iFeldZaehler) _
                    & " /Title (" & fsPostscriptString_erzeugen(sTitle(iFeldZaehler)) & ")" _
                    & " /Count " & iCount(iFeldZaehler) _
                    & " " & sView _
                    & " /OUT pdfmark"
            End If
            Print #1, sText
        Next iFeldZaehler
        Close #1
        fbEinVerzeichnis_erzeugen_ByField = True
    Else
        If sVerzeichnisType = "I" Then 'Inhaltsverzeichnis
            MsgBox sMSG_INHALTSVERZEICHNISNICHTERZEUGT _
                & vbCr & "(" & sFehler & ")" _
                , vbExclamation, sTITEL_ERZEUGEN
        Else
            MsgBox sMSG_ABBILDUNGSVERZEICHNISNICHTERZEUGT _
                & vbCr & "(" & sFehler & ")" _
                , vbExclamation, sTITEL_ERZEUGEN
        End If
        fbEinVerzeichnis_erzeugen_ByField = False
    End If
    
End Function

'Private Function fbEinVerzeichnis_erzeugen_BySentence(sPSDateiName As String, _
'oEinVerzeichnis As Object, sView As String, sVerzeichnisType As String) As Boolean
'    'Ergnzt die Postscriptdatei sPSDateiName um Lesezeichen fr ein Verzeichnis
'    'Global:
'    'Argumente:
'    '   sPSDateiName = Dateiname der Postscript-Datei
'    '   oEinVerzeichnis = bjekt mit dem Verzeichnis
'    '   sView = Eintrag fr /VIEW
'    '   sVerzeichnisType = Type des Verzeichnisses
'    '       I = Inhaltsverzeichnis
'    '       A = Abbildungsverzeichnis
'    'Rckgabewert:
'    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
'    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
'    'Effekt
'    '   Ggf. wurde eine Postscript-Datei verndert
'    '   oder eine Fehlermeldung angezeigt.
'
'    Dim oEinSatz As Object
'    Dim oEinFeld As Object
'    Dim sFehler As String ' "" = kein Fehler
'    Dim sText As String
'    Dim sTitel As String
'    Dim sGemerkterTitel As String
'    Dim iFeldNr As Integer
'    Dim lPos As Long
'    Dim iSatzZaehler As Integer
'    Dim iFeldZaehler As Integer
'    Dim iAnzahl As Integer
'    Dim iStufe As Integer
'    Dim iStufeAlt As Integer
'    Dim iCountTab(9) As Integer 'Hilfstabelle zum Errechnen von iCount()
'    Dim sTitle() As String
'    Dim iCount() As Integer
'    Dim iPage() As Integer
'    Dim iLevel() As Integer
'    'In den Elementen steht der Index fr die Tabellen sTitle, iLevel, iCount und iPage
'    'Der Index in iLevel ist der Level:
'    '   Beim Verzeichnis mit Hierarchie : (0) = Verzeichnistitel; (1) = berschrift 1;
'    '       (2) = berschrift2 ; usw.
'    '   Beim Verzeichnis ohne Hierarchie: (0) = Verzeichnistitel; (1) = Eintrge;
'
'    iAnzahl = oEinVerzeichnis.Range.Fields.Count 'Das erste Feld ist immer das wdFieldTOC-Feld,
'        'die folgenden Felder sind wdFieldPageRef-Felder
'    'In diesen Tabellen werden die Informationen fr das Verzeichnis abgelegt
'    ReDim sTitle(iAnzahl)
'    ReDim iLevel(iAnzahl)
'    ReDim iCount(iAnzahl)
'    ReDim iPage(iAnzahl)
'
'    iSatzZaehler = 1
'    For Each oEinSatz In oEinVerzeichnis.Range.Sentences
'        'Prfen was fr ein Satz es ist
'        '   (a) Der erste Satz enthlt das wdFieldTOC-Feld und alle wdFieldPageRef-Felder
'        '   (b) Die anderen Stze enthalten jeweils ein wdFieldPageRef-Feld
'        '   (c) Wenn kein Feld vorhanden ist, handelt es sich um einen Teilsatz. Er gehrt zum
'        '       nchsten Satz mit einem wdFieldTOC-Feld
'        iFeldZaehler = 0
'        iFeldNr = 0
'        For Each oEinFeld In oEinSatz.Fields
'            If oEinFeld.Type = wdFieldTOC Then ' Verzeichnis
'                If sVerzeichnisType = "I" Then 'Inhaltsverzeichnis
'                    sTitle(0) = sTEXT_INHALTSVERZEICHNIS
'                Else
'                    If oEinVerzeichnis.Caption = "" Then
'                        sTitle(0) = oEinVerzeichnis.Caption
'                    Else
'                        sTitle(0) = sTEXT_ABBILDUNGSVERZEICHNIS
'                    End If
'                End If
'                lPos = oEinVerzeichnis.Range.Start
'                iPage(0) = _
'                    ActiveDocument.Range(Start:=lPos, End:=lPos).Information(wdActiveEndPageNumber)
'            End If
'            iFeldZaehler = iFeldZaehler + 1
'            If oEinFeld.Type = wdFieldPageRef Then
'                iFeldNr = iFeldZaehler
'                Exit For
'            End If
'        Next oEinFeld
'        'Wenn der erste Satz keinen Style hat, ist die Kopfzeile des Verzeichnisses leer.
'        'Das ist bei Word 97 der Standardfall. In diesem Satz steht das wdFieldTOC-Feld
'        If Not oEinSatz.Style Is Nothing Then
'            If iFeldNr = 0 Then 'Kein wdFieldPageRef-Feld; Satz ist unvollstndig;
'                'Nicht als Satz zhlen; Nur Titel merken
'                sGemerkterTitel = sGemerkterTitel & oEinSatz.Text
'            Else ' wdFieldTOC-Feld gefunden, Satz ist komplett
'                'Titeltext
'                sTitel = sGemerkterTitel & oEinSatz.Text
'                sGemerkterTitel = ""
'                If oEinVerzeichnis.IncludePageNumbers = True Then
'                    lPos = flLetztesVorkommen_suchen(sTitel, vbTab)
'                    If lPos > 0 Then 'Sonst Fehler
'                        sTitel = Left(sTitel, lPos - 1)
'                    Else
'                        sFehler = sTitel
'                    End If
'                End If
'                sTitle(iSatzZaehler) = sTitel
'                'echte Seitennummer im Dokument ermitteln
'                sText = oEinFeld.Code.Text
'                lPos = flLetztesVorkommen_suchen(sText, "_")
'                If lPos > 0 Then ' Sonst Fehler
'                    sText = Mid(sText, flLetztesVorkommen_suchen(sText, "_"))
'                Else
'                    sFehler = sTitel
'                End If
'                sText = Left(sText, InStr(sText, " ") - 1)
'                iStufe = 1 'Defaultwert der Stufe bei Abbildungsverzeichnissen und Fehlern
'                If ActiveDocument.Bookmarks.Exists(sText) = True Then 'Sonst Fehler
'                    iPage(iSatzZaehler) = _
'                        ActiveDocument.Bookmarks(sText).Range.Information(wdActiveEndPageNumber)
'                    If sVerzeichnisType = "I" Then 'Inhaltsverzeichnis
'                        'Level 1 bis 9
'                        iStufe = ActiveDocument.Styles _
'                            (ActiveDocument.Bookmarks(sText).Range.Style.NameLocal).ListLevelNumber
'                    End If
'                Else
'                    sFehler = sTitel
'                End If
'                iLevel(iSatzZaehler) = iStufe
'                'Count
'                'Je Lesezeichen wird mit Count eingetragen, wie viele Lesezeichen
'                'hierarchisch darunter liegen
'                If iStufeAlt < iStufe Then
'                    iCountTab(iStufe) = iSatzZaehler - 1
'                ElseIf iStufeAlt > iStufe Then
'                    For lPos = iStufe + 1 To iStufeAlt
'                        iCountTab(lPos) = -1
'                    Next lPos
'                End If
'                For lPos = 1 To iStufe
'                    If iStufe <= lPos _
'                    And iCountTab(lPos) >= 0 Then
'                        iCount(iCountTab(lPos)) = iCount(iCountTab(lPos)) + 1
'                    End If
'                Next lPos
'                'Vorbereitung fr den nchsten Durchlauf
'                iStufeAlt = iLevel(iSatzZaehler)
'                iSatzZaehler = iSatzZaehler + 1
'           End If
'        End If
'    Next oEinSatz
'    If iAnzahl + 1 <> iSatzZaehler Then
'       sFehler = iAnzahl & "/" & iSatzZaehler
'    End If
'
'    If sFehler = "" Then
'        'OUT
'        'Ein Inhaltsverzeichnis an die PS-Datei anhngen
'        Open sPSDateiName For Append Access Write Lock Read Write As #1
'        For iSatzZaehler = 0 To iAnzahl
'            If iCount(iSatzZaehler) = 0 Then
'                sText = "[ /Page " & iPage(iSatzZaehler) _
'                    & " /Title (" & sTitle(iSatzZaehler) & ") " & sView & " /OUT pdfmark"
'            Else
'                sText = "[ /Page " & iPage(iSatzZaehler) _
'                    & " /Title (" & sTitle(iSatzZaehler) & ") /Count " & iCount(iSatzZaehler) _
'                    & " " & sView & " /OUT pdfmark"
'            End If
'            Print #1, sText
'        Next iSatzZaehler
'        Close #1
'        fbEinVerzeichnis_erzeugen_BySentence = True
'    Else
'        If sVerzeichnisType = "I" Then 'Inhaltsverzeichnis
'            MsgBox sMSG_INHALTSVERZEICHNISNICHTERZEUGT _
'                & vbCr & "(" & sFehler & ")" _
'                , vbExclamation, sTITEL_ERZEUGEN
'        Else
'            MsgBox sMSG_ABBILDUNGSVERZEICHNISNICHTERZEUGT _
'                & vbCr & "(" & sFehler & ")" _
'                , vbExclamation, sTITEL_ERZEUGEN
'        End If
'        fbEinVerzeichnis_erzeugen_BySentence = False
'    End If
'
'
'End Function

Private Function fbActivePrinterAuf_gsDruckerName_setzen() As Boolean
    'Die Funktion setzt ActivePrinter auf gsDruckerName.
    'In VBA fr Word muss dabei nicht der Port angegeben werden.
    'Global:
    '   gsPSDruckerName wird gelesen
    'Rckgabewert:
    '   True = Der Drucker aus gsDruckerName ist der ActivePrinter.
    '   False = Der Drucker aus gsDruckerName konnte nicht zum ActivePrinter
    '           gemacht werden. Der ActivePronter ist unverndert.
    'Effekt
    '   ActivePrinter verndert
    
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    
    On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (ist reproduzierbar!)
    ActivePrinter = gsPSDruckerName
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then
        fbActivePrinterAuf_gsDruckerName_setzen = True
    Else
        fbActivePrinterAuf_gsDruckerName_setzen = False
    End If

End Function

'===================================================================================================
'Alle Funktionen und Subroutinen, die von der Subroutine ERZEUGEN und von
'ComboBoxEinTeilobjektFlag_Change verwendet werden.
'===================================================================================================

Function fsBasisDateiName_ermitteln(sSymbDateiName As String) As String
    'Die Funktion ermittelt aus sSymbDateiName den BasisDateinamen mit Pfad fr die PS- und die
    'PDF-Datei.
    'Argumente
    '   sSymbDateiName = Symbolischer Dateiname
    'Global:
    '   ActiveDocument.Path = Pfad des aktiven Office-Dokuments
    '   ActiveDocument.Name = Dateiname des aktiven Office-Dokuments
    '   gsPathSeparator wird gelesen
    '   gsPrintSwitch wird gelesen
    'Rckgabewert:
    '   sLEER = Es konnte kein Dateiname erzeugt werden
    '   "xxx...xxx" = BasisDateiname der Datei.
    'Effekt
        
    Dim sErweitererSymbDateiName As String 'Vollstndiger symbolischer Dateiname
    Dim sBasisName As String 'Name des aktiven Office-Dokuments ohne Pfad und Extension
    Dim lLaenge As Long
    Dim sPfadName As String
    Dim sNamenszusatz As String
    
    If Left(sSymbDateiName, 2) = "\\" _
    Or (Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" _
    And Mid(sSymbDateiName, 3, 1) = gsPathSeparator) Then '"\\XXX" und "C:\XXX" unverndert lassen
    'Or (Asc(Lcase ... ersetzt: Or Mid(sSymbDateiName, 2, 2) = ":\" Then '"\\XXX" und "C:\XXX"
    'unverndert lassen
        sErweitererSymbDateiName = sSymbDateiName
    ElseIf Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" Then '"C:XXX" wird zu "C:\aaa\XXX"
    'ElseIf Asc(LCase ... ersetzt: ElseIf Mid(sSymbDateiName, 2, 1) = ":" Then '"C:XXX" wird zu "C:\aaa\XXX"
        sPfadName = CurDir(Left(sSymbDateiName, 2))
        If Right(sPfadName, 1) = gsPathSeparator Then
            sErweitererSymbDateiName = sPfadName & Mid(sSymbDateiName, 3)
        Else
            sErweitererSymbDateiName = sPfadName & gsPathSeparator & Mid(sSymbDateiName, 3)
        End If
    ElseIf Left(sSymbDateiName, 1) = gsPathSeparator Then
        '"\XXX" wird zu "D:\XXX" oder \\server\freigabe\XXX
        If Left(ActiveDocument.Path, 2) = "\\" Then '\\freigabe\server\
            lLaenge = InStr(InStr(3, ActiveDocument.Path, gsPathSeparator) + 1, _
                ActiveDocument.Path, gsPathSeparator) - 1
            If lLaenge < 3 Then 'Auch bei einem Fehler geht es weiter
                lLaenge = 0
            End If
        Else
            lLaenge = 2
        End If
        sErweitererSymbDateiName = Left(ActiveDocument.Path, lLaenge) & sSymbDateiName
    Else '"XXX" wird zu "D:\aaa\XXX"
        sErweitererSymbDateiName = ActiveDocument.Path & gsPathSeparator & sSymbDateiName
    End If

    Select Case gsPrintSwitch
    Case sPRINTSWITCH_WORD_DOKUMENT 'Das ganze Dokument ausgeben
        sNamenszusatz = sLEER
    Case sPRINTSWITCH_WORD_SEITE 'Nur die aktuelle Seite ausgeben
        sNamenszusatz = "_" & Selection.Information(wdActiveEndPageNumber)
    Case sPRINTSWITCH_WORD_MARKIERUNG ' Nur markierte Seiten ausgeben
        sNamenszusatz = sNAMENSZUSATZ_MARKIERUNG
    Case sPRINTSWITCH_WORD_DOKUMENT '" = Dokument"
        sNamenszusatz = sLEER
    Case sPRINTSWITCH_WORD_EIGENSCHAFT ' = "Dokumenteneingenschaften"
        sNamenszusatz = sNAMENSZUSATZ_EIGENSCHAFTEN
    Case sPRINTSWITCH_WORD_KOMMENTARE ' = "Kommentare"
        sNamenszusatz = sNAMENSZUSATZ_KOMMENTARE
    Case sPRINTSWITCH_WORD_FORMATVORLAGEN ' = "Formatvorlagen"
        sNamenszusatz = sNAMENSZUSATZ_FORMATVORLAGEN
    Case sPRINTSWITCH_WORD_AUTOTEXTE ' = "AutoText-Eintrge"
        sNamenszusatz = sNAMENSZUSATZ_AUTOTEXTE
    Case sPRINTSWITCH_WORD_TASTENBELEGUNG ' = "Tastenbelegung"
        sNamenszusatz = sNAMENSZUSATZ_TASTENBELEGUNG
    Case Else
        MsgBox sMSG_PRINTSWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fsBasisDateiName_ermitteln = sLEER
        Exit Function
    End Select

    sBasisName = Left(ActiveDocument.Name, flLetztesVorkommen_suchen(ActiveDocument.Name, ".") - 1) _
        & sNamenszusatz
    fsBasisDateiName_ermitteln = fsSymbDateiName_umsetzen(sErweitererSymbDateiName, sBasisName, sLEER)
    
End Function

'===================================================================================================
'Alle Funktionen, die nur in GLOB_Prozeduren.fbKonfigurieren und DOC_ProzedurenfbVorlageAnpassen
'verwendet werden.
'===================================================================================================

Function fbVorlageIstAenderbar() As Boolean
    'Die Funktion prft in der Word-Task ob die Vorlage gendert werden darf.
    'Dazu prft sie, ob dieser WordTask der erste und einzige Word-Task ist.
    'In Excel und Powerpoint wird immer True zurckgegeben
    'Global:
    '   Application.Tasks wird gelesen
    '   Application.Name wird gelesen
    'Rckgabewert:
    '   False = Die Vorlage darf nicht verndert werden.
    '   True = Die Vorlage darf verndert werden.
    
    Static siTaskAenderbarZustand As Integer
    '        0 = noch nie berprft
    '        1 = Es ist der Task, der beim ersten Aufruf dieser Funktion allein lief oder es ist
    '            kein Word-Task
    '        2 = Es ist ein Task, der beim ersten Aufruf dieser Funktion nicht allein lief.
    
    Dim iAnzahlTasks As Integer
    Dim oEinTask As Object
    
    If UCase(Application.Name) <> sTASKNAME_WORD Then
        siTaskAenderbarZustand = 1
    End If
    
    If siTaskAenderbarZustand = 0 Then 'erster Aufruf der Funktion fbVorlageIstAenderbar
        iAnzahlTasks = 0
        For Each oEinTask In Application.Tasks
            If Left(oEinTask.Name, Len(Application.Name)) = Application.Name _
            Or Right(oEinTask.Name, Len(Application.Name)) = Application.Name Then
                iAnzahlTasks = iAnzahlTasks + 1
            End If
        Next oEinTask
        If iAnzahlTasks < 2 Then
            siTaskAenderbarZustand = 1
            fbVorlageIstAenderbar = True
        Else
            siTaskAenderbarZustand = 2
            fbVorlageIstAenderbar = False
        End If
    ElseIf siTaskAenderbarZustand = 1 Then 'Es ist der Task, der beim ersten Aufruf dieser Funktion
        'allein lief oder es ist kein Word-Task
        fbVorlageIstAenderbar = True
    Else 'Es ist ein Task, der beim ersten Aufruf dieser Funktion nicht allein lief
        fbVorlageIstAenderbar = False
    End If

End Function

'===================================================================================================
'Ende.
'===================================================================================================
