Attribute VB_Name = "INST_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   INST_Prozeduren
' Effekt:
'   Das Modul installiert eine neue Version von Gs4Word.
'   Das Add-In installiert je ein Word-, Excel und Powerpoint-Add-In
'   -   Gs4Word.dot (Word)
'   -   Gs4Word.xla (Excel)
'   -   Gs4Word.ppa (Powerpoint)
'   fr die Office-Versionen
'   -   Office  8.0 = Office 97
'   -   Office  9.0 = Office 2000
'   -   Office 10.0 = Office 2002
'
'   Das Add-In ist noch nicht sprachunabhngig!
'
'   Wenn Sie das Installionsscript fr Ihre eigenen Add-Ins verwenden wollen, mssen Sie u.a.
'   den Inhalt der Konstanten sADDIN_NAME anpassen.
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten INST_sss muss vorhanden sein. Dabei ist sss die
'   Sprache. Die Module GLOB_Prozeduren, GLOB_sss, REG_Prozeduren, TECH_Prozeduren und TECH_sss
'   und die UserForms INST_UF_Installation und INST_UF_Deinstallation mssen vorhanden sein.
'   Unter Word 9.0 und 10.0 muss die Sicherheitsstufe niedrig oder Mittel sein, damit dieses
'   Add-In ausgefhrt werden kann.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   30.06.2002 J.W.Schmitz-Hbsch erstellt
'   19.07.2002 Komplett umgebaut fr Version 2.40
'   23.08.2002 Erweitert fr Version 2.41
'   07.09.2002 Erweitert fr Version 2.42
'   21.09.2002 Erweitert fr Version 2.43

'===================================================================================================
'Deklarationen
'===================================================================================================

' Spezielle Konstante zum Installationsscript
'--------------------------------------------
Public Const sTXT As String = ".txt"
Public Const sINSTLOGBUCH As String = "Installation.txt"
Private Const sVORLAGE_ACTION_INSTALLATION As String = "INST_Prozeduren.INSTALLATION"
Private Const sVORLAGE_ACTION_DEINSTALLATION As String = "INST_Prozeduren.DEINSTALLATION"
Private Const sVORLAGE_ACTION_ALLEADDINSERZEUGEN As String = "INST_Prozeduren.ALLEADDINSERZEUGEN"
Private Const sSECURITYNAME_LEVEL As String = "Level"
Private Const sSECURITYNAME_ACCESSVBOM As String = "AccessVBOM"
Private Const sSECURITYNAME_DONTTRUST As String = "DontTrustInstalledFiles"
Private Const vSECURITYWERT_LEVEL_1 As Variant = "&H00000001" 'niedriger Sicherheitslevel
Private Const vSECURITYWERT_LEVEL_2 As Variant = "&H00000010" 'mittlerer Sicherheitslevel
Private Const vSECURITYWERT_LEVEL_3 As Variant = "&H00000011" 'hoher Sicherheitslevel
Private Const vSECURITYWERT_ACCESSVBOM As Variant = "&H00000001" ' Zugriff auf Visual-Basic-Objekt vertrauen Aktiv (1!)"
Private Const vSECURITYWERT_DONTTRUST As Variant = "&H00000000" 'Allen installieren Add-Ins vertrauen Aktiv (0!)

' Konstante fr die Funktionen fbInstallieren und fbXXXXAddInErzeugen und der beine UserForms
'--------------------------------------------------------------------------------------------
'OFFEN: Diese Konstanten spter bei fbInstallieren() und sAktionen() verwenden
'Public Const iAUFGABE_INITIALISIERE As Integer = 0
'    'gbXXXXxxFlag setzen und in gsAktion beschreiben
'Public Const iAUFGABE_TESTDEINSTALL As Integer = 1
'    'Deinstallation in gsAktion beschreiben
'Public Const iAUFGABE_TESTADDINS As Integer = 2
'    'Wenn ein gsXXXXxxFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
'Public Const iAUFGABE_TESTINSTALL As Integer = 3
'    'Fr alle gesetzten gsXXXXxxFlag Installation in gsAktion beschreiben
'Public Const iAUFGABE_MACHDEINSTALL As Integer = 4
'    'Deinstallation durchfhren und in gsAktion beschreiben
'Public Const iAUFGABE_MACHADDINS As Integer = 5
'    'Wenn ein gsXXXXxxFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
'Public Const iAUFGABE_MACHINSTALL As Integer = 6
'    'Fr alle gesetzten gsXXXXxxFlag Installation durchfhren und in gsAktion beschreiben
'Public Const iAUFGABE_TESTFILES As Integer = 9 'Vollstndigkeit der Installationsdateien prfen'

' Konstante fr die Funktionen fbXXXXAddInErzeugen
'-------------------------------------------------
Private Const bERZEUGE_PRUEFEN As Byte = 0
Private Const bERZEUGE_AUS_SOURCE As Byte = 1
Private Const bERZEUGE_AUS_RUNTIME As Byte = 2



'===================================================================================================
'Alle ffentlichen Variablen fr alle Module
'===================================================================================================
Public gsInstVerzeichnis As String
Public gbWordFlag As Boolean
Public gbExcelFlag As Boolean
Public gbPowerpointFlag As Boolean
Public gbWordSicherheit As Boolean
Public gbExcelSicherheit As Boolean
Public gbPowerpointSicherheit As Boolean
Public gbKonfAddInErzeugenFlag As Boolean
Public gbWordAddInErzeugenFlag As Boolean
Public gbExcelAddInErzeugenFlag As Boolean
Public gbPowerpointAddInErzeugenFlag As Boolean
Public gbKonfAddInErzeugenAenderbar As Boolean
Public gbWordAddInErzeugenAenderbar As Boolean
Public gbExcelAddInErzeugenAenderbar As Boolean
Public gbPowerpointAddInErzeugenAenderbar As Boolean
Public gsAktion As String
Public gsAktionen(6) As String
Public gbDialogEffekt As Boolean
Public gsOfficeName As String
Public gsInstallationsAddIn As String
Public gsKonfigurationAddIn As String
Public gsZipArchiv As String
Public gsWordAddIn As String
Public gsExcelAddIn As String
Public gsPowerpointAddIn As String
Public gsPowerpointAddInRegistryName As String
Public gsAlteWordAddIns As String
Public gsAlteExcelAddIns As String
Public gsAltePowerpointAddIns As String
Public gsLogbuchAufruf As String
Public gsInstallationsMailToSwitch As String
Public gbZielgruppeUser As Boolean
Public gbZielgruppeAenderbar As Boolean
Public gbSicherheitAenderbar As Boolean

Sub INSTALLATION()
    On Error GoTo Fehler_aufgetreten:
        
    INST_UF_Installation.Show
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & "Fehler # " & Str(Err.Number) & sSPACE & Err.Description _
        & vbCr & "in " & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - INSTALLATION" _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

Sub DEINSTALLATION()
    On Error GoTo Fehler_aufgetreten:
        
    INST_UF_Deinstallation.Show
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & "Fehler # " & Str(Err.Number) & sSPACE & Err.Description _
        & vbCr & "in " & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - DEINSTALLATION" _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

Sub ALLEADDINSERZEUGEN()
    'Die Funktion erzeugt alle Add-Ins aus den Sourcen mit allen Kommentaren
    'Sie wird vom Add-In Make.dot aufgerufen
    
    On Error GoTo Fehler_aufgetreten:
    
    Const sSAVDIR As String = "_sav\"
        
    Dim sOfficeVersion As String
    Dim iAntwort As Integer
    Dim bAktion As Byte
    Dim sDateien(4) As String
    Dim sEineDatei As Variant
    Dim sTimeStamp As String
    
    
    If fbInstallieren(0) = False _
    Or fbInstallieren(9) = False Then
        Exit Sub
    End If
    
    sDateien(0) = gsInstallationsAddIn
    sDateien(1) = gsKonfigurationAddIn
    sDateien(2) = gsWordAddIn
    sDateien(3) = gsExcelAddIn
    sDateien(4) = gsPowerpointAddIn
    sTimeStamp = Format(Now, "_yyyymmDd_hhnnss")
    
    If LCase(gsInstVerzeichnis & gsInstallationsAddIn) = _
    LCase(ThisDocument.Path & "\" & ThisDocument.Name) Then
        MsgBox sMSG_KEINEKOPIEDESINSTADDIN _
            & vbCr & "(" & ThisDocument.Path & "\" & ThisDocument.Name & ")" _
            , vbExclamation, sTITEL_INSTALLIEREN
        Exit Sub
    End If

    Select Case Val(Word.Application.Version)
    Case 8
        sOfficeVersion = "8.0"
    Case 9
        sOfficeVersion = "9.0"
    Case 10
        sOfficeVersion = "10.0"
    Case Else
        MsgBox sMSG_OFFICEVERSIONUNBEKANNT _
            & vbCr & "(" & Word.Application.Version & ")" _
            , vbExclamation, sTITEL_INSTALLIEREN
        Exit Sub
    End Select
    
    iAntwort = MsgBox("Sollen die Add-Ins aus den Sourcen mit allen Kommentaren erzeugt werden?" _
        & vbCr & "Wenn Sie mit Ja antworten, werden die Add-Ins mit Kommentaren erzeugt." _
        & vbCr & "Wenn Sie mit Nein antworten, werden die Add-Ins ohne Kommentare erzeugt.", _
         vbYesNoCancel + vbQuestion + vbDefaultButton3, sTITEL_INSTALLIEREN)
    Select Case iAntwort
    Case vbYes
        bAktion = bERZEUGE_AUS_SOURCE
    Case vbNo
        bAktion = bERZEUGE_AUS_RUNTIME
    Case Else
        Exit Sub
    End Select
    
    'Sicherungsverzeichnis anlegen
    If Dir(gsInstVerzeichnis & sSAVDIR, vbDirectory) = sLEER Then
        MkDir (gsInstVerzeichnis & sSAVDIR)
    End If
    
    'Alle Add-Ins sichern
    For Each sEineDatei In sDateien
        If Dir(gsInstVerzeichnis & sEineDatei, vbNormal) <> sLEER Then
            If fbDatei_kopieren(gsInstVerzeichnis & sEineDatei, gsInstVerzeichnis _
            & sSAVDIR & sEineDatei & sTimeStamp) = False Then
                Exit Sub
            End If
        End If
    Next sEineDatei
    
    'Alle Add-Ins lschen
    For Each sEineDatei In sDateien
        If fbDatei_loeschen(gsInstVerzeichnis & sEineDatei) = False Then
            Exit Sub
        End If
    Next sEineDatei
    
    'Alle Add-Ins erzeugen
    If fbInstallationAddInErzeugen(sOfficeVersion, bAktion) = True Then
        If fbKonfigurationAddInErzeugen(sOfficeVersion, bAktion) = True Then
            If fbWordAddInErzeugen(sOfficeVersion, bAktion) = True Then
                If fbExcelAddInErzeugen(sOfficeVersion, bAktion) = True Then
                    If fbPowerpointAddInErzeugen(sOfficeVersion, bAktion) = True Then
                        If bAktion = bERZEUGE_AUS_SOURCE Then
                            MsgBox sALLEADDINSERZEUGT_MIT, vbInformation, sTITEL_INSTALLIEREN
                        Else
                            MsgBox sALLEADDINSERZEUGT_OHNE, vbInformation, sTITEL_INSTALLIEREN
                        End If
                    End If
                End If
            End If
        End If
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & "Fehler # " & Str(Err.Number) & sSPACE & Err.Description _
        & vbCr & "in " & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - ALLEADDINSERZEUGEN" _
        , vbExclamation, sTITEL_FEHLER
        
End Sub

Function fbInstallieren(iAufgabe As Integer) As Boolean
    'Die Funktion installiert in drei Aufrufen alle Add-Ins.
    'Argumente:
    '   iAufgabe
    '       0 = gbXXXXxxFlag setzen und in gsAktion beschreiben
    '       1 = Deinstallation in gsAktion beschreiben
    '       2 = Wenn ein gsXXXXxxFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
    '       3 = Fr alle gesetzten gsXXXXxxFlag Installation in gsAktion beschreiben
    '       4 = Deinstallation durchfhren und in gsAktion beschreiben
    '       5 = Wenn ein gsXXXXxxFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
    '       6 = Fr alle gesetzten gsXXXXxxFlag Installation durchfhren und in gsAktion
    '           beschreiben
    '       9 = Vollstndigkeit der Installationsdateien prfen
    'Global:
    '   siehe fbWord_installieren, fbExcel_installieren und fbPowerpoint_installieren
    
    Dim iZaehler As Integer
    Dim lPos As Long
    Dim sWindowsName As String
     
    Static sOfficeVersion As String
    
    fbInstallieren = False

    gsPathSeparator = Application.PathSeparator 'PathSeparator IMMER neu ermitteln
    
    Select Case iAufgabe
    Case 0 'gbWordFlag setzen und in gsAktion beschreiben
        For iZaehler = LBound(gsAktionen) To UBound(gsAktionen)
            gsAktionen(iZaehler) = sLEER
        Next iZaehler
        
        gsInstVerzeichnis = ThisDocument.Path & gsPathSeparator
        gsLogbuchAufruf = fsVerknuepfung_ermitteln(sTXT, gsInstVerzeichnis & sINSTLOGBUCH)
        
        gsAlteWordAddIns = sADDIN_NAME & "*.dot"
        gsAlteExcelAddIns = sADDIN_NAME & "*.xla"
        gsAltePowerpointAddIns = sADDIN_NAME & "*.ppa"
        gsZipArchiv = sADDIN_NAME & "_" & sADDIN_VERSION & ".zip"
        gsInstallationsAddIn = "Installation.dot"
        gsKonfigurationAddIn = "Konfiguration.dot"
        gsWordAddIn = sADDIN_NAME & ".dot"
        gsExcelAddIn = sADDIN_NAME & ".xla"
        gsPowerpointAddIn = sADDIN_NAME & ".ppa"
        gsPowerpointAddInRegistryName = sADDIN_NAME
        
        Select Case Val(Word.Application.Version)
        Case 8
            sOfficeVersion = "8.0"
            gsOfficeName = "Microsoft Office 97"
            gbZielgruppeUser = False
            gbZielgruppeAenderbar = False
            gbSicherheitAenderbar = False
        Case 9
            sOfficeVersion = "9.0"
            gsOfficeName = "Microsoft Office 2000"
            gbZielgruppeUser = True
            gbZielgruppeAenderbar = True
            gbSicherheitAenderbar = True
        Case 10
            sOfficeVersion = "10.0"
            gsOfficeName = "Microsoft Office 2002"
            gbZielgruppeUser = True
            gbZielgruppeAenderbar = True
            gbSicherheitAenderbar = True
        Case Else
            MsgBox sMSG_OFFICEVERSIONUNBEKANNT _
                & vbCr & "(" & Word.Application.Version & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End Select
        
        gsAktion = String(120, "-") _
            & vbCr & Format(Date, "Long Date") & " " & Format(Time, "Long Time") & " " _
            & sTITEL_LOGBUCH & vbCr
        gsAktion = gsAktion & vbCr
        gsAktion = gsAktion & "Kenndaten des Systems:" & vbCr
        gsAktion = gsAktion & "    Prozessor: " & System.ProcessorType & vbCr
        gsAktion = gsAktion & "    Auflsung: " & System.HorizontalResolution & " x " _
            & System.VerticalResolution & vbCr
        sWindowsName = System.OperatingSystem
        Select Case LCase(System.OperatingSystem)
        Case "windows"
            'Windows Plattform 1
            Select Case Left(System.Version, 3)
            Case "4.0"
                sWindowsName = "Windows 95"
            Case "4.1"
                sWindowsName = "Windows 98"
            Case "4.9"
                sWindowsName = "Windows ME"
            End Select
        Case "windows nt"
            'Windows Plattform 2,
            Select Case Left(System.Version, 3)
            Case "3.5"
                sWindowsName = "Windows NT 3.51" 'Ungetestet; wer hat noch NT 3.51 ?
            Case "4.0"
                sWindowsName = "Windows NT 4.0"
            Case "5.0"
                sWindowsName = "Windows 2000"
            Case "5.1"
                sWindowsName = "Windows XP"
            End Select
        End Select
        gsAktion = gsAktion & "    Betriebssytem: " & sWindowsName & " (Version " _
            & System.Version & ")" & vbCr
        If System.Country = wdGermany Then
            gsAktion = gsAktion & "    Land: Germany" & vbCr
        Else
            gsAktion = gsAktion & "    Land: " & System.Country & vbCr
        End If
        gsAktion = gsAktion & "    Sprache: " & System.LanguageDesignation & vbCr
        gsAktion = gsAktion & vbCr
    
        gsAktion = gsAktion & "Kenndaten der Installation:" & vbCr
        gsAktion = gsAktion & "    Office: " & gsOfficeName & " (Version " _
            & Word.Application.Version & ")" & vbCr
        gsAktion = gsAktion & "    AddIn: " & sADDIN_NAME & " (Version " & sADDIN_VERSION _
             & ")" & vbCr
        gsAktion = gsAktion & "    Installationsverzeichnis: " & gsInstVerzeichnis & vbCr
        gsAktion = gsAktion & "    Installations-Add-In: " & ThisDocument.Name & vbCr
    Case 1 'Deinstallation in gsAktion beschreiben
        gsAktion = "Planung zum Deinstallation alter Versionen:" & vbCr
    Case 2 'fr alle gesetzten gsXXXXxxFlag Erzeugen der AddIns in gsAktion beschreiben
        gsAktion = "Planung zum Erzeugen der Add-Ins:" & vbCr
    Case 3 'fr alle gesetzten gsXXXXxxFlag Installation in gsAktion beschreiben
        gsAktion = "Planung zur Installation der neuen Version:" & vbCr
    Case 4 'Deinstallation durchfhren und in gsAktion beschreiben
        gsAktion = "Deinstallation der alten Versionen:" & vbCr
    Case 5 'fr alle gesetzten gsXXXXxxFlag Add-Ins erzeugen und in gsAktion beschreiben
        gsAktion = "Erzeugen der Add-Ins:" & vbCr
    Case 6 'fr alle gesetzten gsXXXXxxFlag Installation durchfhren und in gsAktion beschreiben
        gsAktion = "Installation der neuen Version:" & vbCr
    Case 9
        fbInstallieren = fbInstallationsdateienPruefen(sOfficeVersion)
        'Hinweis wenn Windows NT, 2000 oder XP und Office97 ohne SR2
        ' And LCase(System.OperatingSystem) = "windows nt" _
        'Siehe Microsoft Knowledge Base D38624 und D40060
        'Ebenfalls Hinweis bei Windows 95/98/ME
        If fbInstallieren = True _
        And sOfficeVersion = "8.0" _
        And Word.Application.Version <> "8.0b" Then
            MsgBox sMSG_OFFICE97OHNESP2 _
                , vbInformation, sTITEL_INSTALLIEREN
            gsAktion = gsAktion & "    Installations-Add-In: " & ThisDocument.Name & vbCr
        End If
        Exit Function
    End Select
    
    If fbWord_installieren(iAufgabe, sOfficeVersion) = True Then
        If fbExcel_installieren(iAufgabe, sOfficeVersion) = True Then
            If fbPowerpoint_installieren(iAufgabe, sOfficeVersion) = True Then
                fbInstallieren = True
            End If
        End If
    End If
    
    If InStr(gsAktion, vbCr) = Len(gsAktion) Then
        ' Nur eine Zeile bedeutet, dass keine weiteren Informationen vorhanden sind
        gsAktionen(iAufgabe) = sLEER
    Else
        gsAktionen(iAufgabe) = gsAktion & vbCr
    End If
    
End Function

Function fbAddIn_deaktivieren() As Boolean
    Dim oEinAddIn As Object
    For Each oEinAddIn In AddIns
        If LCase(Left(oEinAddIn.Name, 7)) = sADDIN_NAME & "_" Then
            oEinAddIn.Installed = False
        End If
    Next oEinAddIn
    fbAddIn_deaktivieren = True
End Function

Function fbProtokoll_schreiben() As Boolean
    'Die Funktion ergnzt das Installationslogbuch im Installationsverzeichnis um die neue
    'Installation
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsAktionen wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim vEineAktion As Variant
    Dim lPos As Long
    
    Open gsInstVerzeichnis & sINSTLOGBUCH For Append Access Write Lock Read Write As #1
    
    For Each vEineAktion In gsAktionen
        Do While vEineAktion <> sLEER
            lPos = InStr(1, vEineAktion, vbCr)
            Print #1, Left(vEineAktion, lPos - 1)
            vEineAktion = Mid(vEineAktion, lPos + 1)
        Loop
    Next vEineAktion
    
    Print #1, sLEER

    Close #1
    
    fbProtokoll_schreiben = True

End Function

Function fbProtokoll_UmRegistryErgaenzen() As Boolean
    'Die Funktion ergnzt das Installationslogbuch im Installationsverzeichnis um die Eintrge
    'fr Gs4Word in der Registry
    'Global:
    '   gsInstVerzeichnis wird gelesen
    '   gsAktionen wird gelesen
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim sVBAPfad As String
    Dim lPfadIndex As Long
    Dim vSubPfadName As Variant
    Dim sWertPfad As String
    Dim lWertIndex As Long
    Dim vWertName As Variant
    Dim sWertName As String
    Dim sWert As String
    
    sVBAPfad = "Software\VB and VBA Program Settings" & "\" & sREGISTRY_APPNAME
    
    Open gsInstVerzeichnis & sINSTLOGBUCH For Append Access Write Lock Read Write As #1
    
    Print #1, "Eintrge in der Registry unter HKEY_CURRENT_USER:"
    
    
    lPfadIndex = 0
    Do While True
        vSubPfadName = fvRegistry_SubPfadNummerLesen(HKEY_CURRENT_USER, sVBAPfad, lPfadIndex)
        If IsNull(vSubPfadName) = True Then 'fertig
            Exit Do
        End If
        sWertPfad = sVBAPfad & "\" & CStr(vSubPfadName)
        Print #1, "    Schlssel "; sWertPfad
        
        lWertIndex = 0
        Do While True
            vWertName = fvRegistry_WertNummerLesen(HKEY_CURRENT_USER, sWertPfad, lWertIndex)
            If IsNull(vWertName) = True Then 'fertig
                Exit Do
            End If
            sWertName = CStr(vWertName)
            sWert = fvRegistry_WertLesen(HKEY_CURRENT_USER, sWertPfad, sWertName, NEVER_RETURN_NULL)
            Print #1, "        " & sWertName & " = " & sWert
            lWertIndex = lWertIndex + 1
        Loop
        lPfadIndex = lPfadIndex + 1
    Loop
    
    Close #1
    
    fbProtokoll_UmRegistryErgaenzen = True

End Function

Function fbWord_installieren(iAufgabe As Integer, sOfficeVersion As String) As Boolean
    'Die Funktion installiert in drei Aufrufen gsWordAddIn im Startup-Verzeichniss von Word.
    'Zuvor werden alle alten Versionen des Add-In gelscht.
    'Die Funktion verwendet folgende Einstellungen:
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\WORD\OPTIONS\, STARTUP-PATH
    'Argumente:
    '   iAufgabe siehe fbInstallieren
    '   sOfficeVersion ist die Versionsnummer von Office
    'Global:
    '   gsWordAddIn wird gelesen (Name des Word-Add-In)
    '   gsAlteWordAddIns wird gelesen
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gbWordFlag wird gelesen und gendert
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim bErgebnis As Boolean
    Dim sDir(3) As String
    Dim vEinDir As Variant
    Dim iZaehler1 As Integer
    Dim iZaehler2 As Integer
    Dim sDatei As String
    Dim lPosition As Long
    Dim sRegOfficePath As String
    Dim sRegOptionsPath As String
    Dim sRegInstallrootPath As String
    Dim sRegSecurityPath As String
    Dim vEinAddIn As Variant
    Dim sText As String
    Const sPREFIX As String = "    Word: "
         
    fbWord_installieren = False
        
    sRegOfficePath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD"
    sRegOptionsPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\OPTIONS"
    sRegInstallrootPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\INSTALLROOT"
    sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\SECURITY"
            
    'Startup-Dir fr Word ermitteln
    'Die Reihenfolge, in der die Tabelle sDir() gefllt wird, beeinflusst, in welches Verzeichnis
    'das Add-In bei der Installation kopiert wird
           
    ' 1. Autostart-Verzeichnis des Users
    iZaehler1 = 0
    sDir(iZaehler1) = Word.Application.Options.DefaultFilePath(wdStartupPath)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    
    ' 2. Autostart-Verzeichnis aus der Registry
    'Fehlt unter Office 10.0, wenn es das Default-Verzeichnis ist
    iZaehler1 = 1
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegOptionsPath, "STARTUP-PATH", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    
    '3. Autostart-Verzeichnis der Installation
    iZaehler1 = 2
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegOptionsPath, "PROGRAMDIR", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    If sDir(iZaehler1) <> sLEER Then
        sDir(iZaehler1) = sDir(iZaehler1) & "startup\"
    End If
            
    '4. Noch einmal Autostart-Verzeichnis der Installation
    'Das Ergebnis in sDir(1) und sDir(2) msste immer gleich sein, aber mir kann niemand
    'besttigen, dass diese beiden Registry-Eintrge immer redundant vorhanden sind.
    iZaehler1 = 3
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    If sDir(iZaehler1) <> sLEER Then
        sDir(iZaehler1) = sDir(iZaehler1) & "startup\"
    End If
    
    'Doubletten in sDir() entfernen
    For iZaehler1 = LBound(sDir) To UBound(sDir)
        For iZaehler2 = iZaehler1 + 1 To UBound(sDir)
            If LCase(sDir(iZaehler1)) = LCase(sDir(iZaehler2)) Then
                sDir(iZaehler2) = sLEER
            End If
        Next iZaehler2
    Next iZaehler1
    
    'Word darf nur einmal laufen
    If iAufgabe > 0 Then
        If fbAnzahlInstanzen_ermitteln(sTASKNAME_WORD) > 1 Then
            'Fehler: Mehrere Word-Instanzen
            MsgBox sMSG_WORDLAEUFTMEHRFACH, vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End If
    End If
    
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case 0 'gbWordFlag und Sicherheitsflag setzen und in gsAktion beschreiben
        If fsDir_ermitteln(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)) = sLEER Then
            gbWordFlag = False
        Else
            gbWordFlag = True
        End If
        ' If fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath) = True Then
        If gbWordFlag = False _
        Or sOfficeVersion = "8.0" _
        Or fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
        NEVER_RETURN_NULL) = vSECURITYWERT_DONTTRUST Then
            gbWordSicherheit = True
        Else
            gbWordSicherheit = False
        End If
        gbKonfAddInErzeugenFlag = False
        gbWordAddInErzeugenFlag = False
    Case 1 'Deinstallation in gsAktion beschreiben
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteWordAddIns, vbNormal)
                Do While sDatei <> ""
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und darf nicht gelscht werden" & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & "Lsche Add-In " & sDatei & " aus " & vEinDir & vbCr
                    End If
                    sDatei = Dir ' Nchsten Eintrag abrufen.
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen beschreiben
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_WORD)) Then
            gsAktion = gsAktion & sPREFIX _
                & "Lsche die Konfiguration von Gs4Word in der Registry" & vbCr
        End If
    Case 2 'Wenn ein gbXXXFlag gesetzt ist Erzeugen der Konfigurations-Add-Ins in gsAktion
        'beschreiben. Wenn gbWordFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
        If (gbWordFlag = True _
        Or gbExcelFlag = True _
        Or gbPowerpointFlag = True) Then
            If Dir(gsInstVerzeichnis & gsKonfigurationAddIn, vbNormal) = sLEER Then
                gbKonfAddInErzeugenFlag = True
                gbKonfAddInErzeugenAenderbar = False
                If Dir(gsInstVerzeichnis & gsKonfigurationAddIn, vbNormal) <> sLEER Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Lsche Add-In " & gsKonfigurationAddIn & " in " & gsInstVerzeichnis & vbCr
                End If
            Else
                gbKonfAddInErzeugenAenderbar = True
            End If
        Else
            gbKonfAddInErzeugenAenderbar = False
        End If
        If gbKonfAddInErzeugenFlag = True Then
            gsAktion = gsAktion & sPREFIX _
                & "Erzeuge Add-In " & gsKonfigurationAddIn & " in " & gsInstVerzeichnis & vbCr
        End If
        If gbWordFlag = True Then
            If Dir(gsInstVerzeichnis & gsWordAddIn, vbNormal) = sLEER Then
                gbWordAddInErzeugenFlag = True
                gbWordAddInErzeugenAenderbar = False
                If Dir(gsInstVerzeichnis & gsWordAddIn, vbNormal) <> sLEER Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Lsche Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis & vbCr
                End If
            Else
                gbWordAddInErzeugenAenderbar = True
            End If
        Else
            gbWordAddInErzeugenAenderbar = False
        End If
        If gbWordAddInErzeugenFlag = True Then
            gsAktion = gsAktion & sPREFIX _
                & "Erzeuge Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis & vbCr
        End If
    Case 3 'Wenn gbWordFlag gesetzt ist Installation, nderung der Sicherheitseinstellungen und
        'erstellen der Konfiguration in gsAktion beschreiben
        If gbWordFlag = True Then
            'Installation beschreiben
            For Each vEinDir In sDir
                If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und muss nicht mehr kopiert werden" & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & "Kopiere Add-In " & gsWordAddIn & " nach " & vEinDir & vbCr
                    End If
                    Exit For
                End If
            Next vEinDir
            'Sicherheitseinstellungen beschreiben
            If gbWordSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Die Sicherheitseinstellungen mssen nicht verndert werden" & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & "Die Sicherheitseinstellungen mssen in der Registry verndert werden" & vbCr
            End If
            'Konfiguration anlegen beschreiben
            gsAktion = gsAktion & sPREFIX _
                & "Schreibe die neue Konfiguration von Gs4Word in die Registry" & vbCr
            'Sicherheitseinstellungen beschreiben
            If gbWordSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Die Sicherheitseinstellungen mssen nicht verndert werden" & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & "ndere die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                    & "\" & sRegSecurityPath & vbCr
            End If
        End If
    Case 4 'Deinstallation durchfhren und in gsAktion beschreiben
        'Alle alten Versionen des Add-In lschen
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteWordAddIns, vbNormal)
                Do While sDatei <> ""
                    For Each vEinAddIn In AddIns
                        If LCase(vEinAddIn.Name) = LCase(sDatei) Then
                            vEinAddIn.Installed = False
                        End If
                    Next vEinAddIn
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und wurde nicht gelscht" & vbCr
                    ElseIf fbDatei_loeschen(vEinDir & sDatei) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " wurde aus " & vEinDir & " gelscht" & vbCr
                    Else
                        'Fehler: Add-In konnte nicht gelscht werden
                        sText = "(FEHLER) Add-In " & sDatei & " in " & vEinDir _
                            & " konnte nicht gelscht werden."
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                    sDatei = Dir(vEinDir & gsAlteWordAddIns, vbNormal)
                    'sDatei = Dir 'reicht hier nicht, denn in fbDatei_loeschen wurde Dir verndert
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_WORD)) Then
            If fbKonfiguration_loeschen(sTASKNAME_WORD) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Konfiguration von Gs4Word wurde in der Registry gelscht" & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = "(FEHLER) Konfiguration von Gs4Word konnte in der Registry nicht " _
                    & "gelscht werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case 5 'Wenn gbWordFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
        If gbKonfAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsKonfigurationAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsKonfigurationAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Add-In " & gsKonfigurationAddIn & " in " & gsInstVerzeichnis _
                        & " wurde gelscht" & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = "(FEHLER) Add-In " & gsKonfigurationAddIn & " in " & gsInstVerzeichnis _
                        & " konnte nicht gelscht werden."
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbKonfigurationAddInErzeugen(sOfficeVersion, bERZEUGE_AUS_RUNTIME) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Add-In " & gsKonfigurationAddIn & " in " & gsInstVerzeichnis _
                    & " wurde erzeugt" & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsKonfigurationAddIn)
               'Fehler: Add-In konnte nicht erzeugt werden
                sText = "(FEHLER) Add-In " & gsKonfigurationAddIn & " in " & gsInstVerzeichnis _
                    & " konnte nicht erzeugt werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
        If gbWordAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsWordAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsWordAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis _
                        & " wurde gelscht" & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = "(FEHLER) Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis _
                        & " konnte nicht gelscht werden."
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbWordAddInErzeugen(sOfficeVersion, bERZEUGE_AUS_RUNTIME) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis _
                    & " wurde erzeugt" & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsWordAddIn)
                'Fehler: Add-In konnte nicht erzeugt werden
                sText = "(FEHLER) Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis _
                    & " konnte nicht erzeugt werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case 6 'Wenn gbWordFlag gesetzt ist Installation durchfhren und in gsAktion beschreiben
        If gbWordFlag = True Then
            'Installation durchfhren
            For Each vEinDir In sDir
                If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und wurde nicht kopiert" & vbCr
                    ElseIf fbDatei_kopieren(gsInstVerzeichnis & gsWordAddIn, _
                        vEinDir & gsWordAddIn) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis _
                            & " wurde nach " & vEinDir & " kopiert" & vbCr
                        Exit For
                    Else
                        'Fehler: Add-In konnte nicht kopiert werden
                        sText = "(FEHLER) Add-In " & gsWordAddIn & " in " & gsInstVerzeichnis _
                            & "konnte nicht nach " & vEinDir & " kopiert werden" & vbCr
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                End If
            Next vEinDir
            'Konfiguration anlegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTASKNAME_WORD, True)
            gsMailToSwitch = gsInstallationsMailToSwitch
            If fbKonfiguration_schreiben(sTASKNAME_WORD) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Neue Konfiguration von Gs4Word wurde in die Registry geschrieben" & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = "(FEHLER) Neue Konfiguration von Gs4Word konnte nicht in die Registry " _
                    & "geschrieben werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
            'Sicherheitseinstellungen aendern
            If gbWordSicherheit = False Then
                If fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                        & "\" & sRegSecurityPath & " wurden gendert" & vbCr
                Else
                    'Fehler: Sicherheitseinstellungen konnten nicht verndert werden
                    sText = "(FEHLER) Die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                        & "\" & sRegSecurityPath & " konnten nicht verndert werden" & vbCr
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                 End If
            End If
        End If
    End Select
    
    fbWord_installieren = True

End Function

Function fbExcel_installieren(iAufgabe As Integer, sOfficeVersion As String) As Boolean
    'Die Funktion installiert in drei Aufrufen gsExcelAddIn im Xlstart-Verzeichniss von Excel.
    'Zuvor werden alle alten Versionen des Add-In gelscht.
    'Die Funktion verwendet folgende Einstellungen:
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\EXCEL\INSTALLROOT\, PATH
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\EXCEL\MICROSOFT EXCEL\, ALTSTARTUP
    'Argumente:
    '   iAufgabe siehe fbInstallieren
    '   sOfficeVersion ist die Versionsnummer von Office
    'Global:
    '   gsExcelAddIn wird gelesen (Name des Excel-Add-In)
    '   gsAlteExcelAddIns wird gelesen
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gbExcelxxFlag wird gelesen und gendert
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim oExcel As Object 'Zum Test ob Excel existiert
    Dim bErgebnis As Boolean
    Dim sDir(3) As String
    Dim vEinDir As Variant
    Dim iZaehler1 As Integer
    Dim iZaehler2 As Integer
    Dim sAddIn() As String
    Dim sOpenName() As String
    Dim sOpenWert() As String
    Dim lIndex As Long
    Dim iZaehler As Integer
    Dim sDatei As String
    Dim lPosition As Long
    Dim sRegOfficePath As String
    Dim sRegOptionsPath As String
    Dim sRegAddInManagerPath As String
    Dim sRegMicrosoftExcelPath As String
    Dim sRegInstallrootPath As String
    Dim sRegSecurityPath As String
    Dim sWert As String
    Dim vWertName As Variant
    Dim sWertName As String
    Dim sPfade(1) As String
    Dim vEinPfad As Variant
    Dim sEinPfad As String
    Dim sText As String
    Const sPREFIX As String = "    Excel: "

    fbExcel_installieren = False
           
    sRegOptionsPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\OPTIONS"
    sRegAddInManagerPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\Add-IN MANAGER"
    sRegMicrosoftExcelPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\MICROSOFT EXCEL"
    sRegInstallrootPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\INSTALLROOT"
    sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\SECURITY"
                  
    'Prfen on Gs4Word im Excel-Men "Extras > Add-In-Manager..." als Add-In eingetragen ist
    'Je nach Office-Version steht der Schssel OPEN, OPENn oder OPENnn (mit n und nn als Zahl)
    'in Office\x.x\Excel\Options\ oder Office\x.x\Excel\Microsoft Excel\
     
    'Eintrge in Excel\Options und Excel\Microsoft Excel durchsuchen
    sPfade(0) = sRegOptionsPath ' In Office 10.0 und ?
    sPfade(1) = sRegMicrosoftExcelPath 'In Office 8.0 und ?
    ReDim sOpenName(0)
    ReDim sOpenWert(0)
    For Each vEinPfad In sPfade
        sEinPfad = CStr(vEinPfad)
        lIndex = 0
        Do While True
            vWertName = fvRegistry_WertNummerLesen(HKEY_CURRENT_USER, sEinPfad, lIndex)
            If IsNull(vWertName) = True Then 'fertig
                Exit Do
            End If
            sWertName = CStr(vWertName)
            If UCase(Left(sWertName, 4)) = "OPEN" _
            And (Len(sWertName) = 4 _
            Or (Len(sWertName) > 4 And IsNumeric(Mid(sWertName, 5)) = True)) Then
                sWert = fvRegistry_WertLesen(HKEY_CURRENT_USER, sEinPfad, sWertName, NEVER_RETURN_NULL)
                If InStr(1, sWert, sADDIN_NAME, 1) > 0 Then
                    sOpenName(UBound(sOpenName)) = sWertName
                    sOpenWert(UBound(sOpenWert)) = sWert
                    ReDim Preserve sOpenName(UBound(sOpenName) + 1)
                    ReDim Preserve sOpenWert(UBound(sOpenWert) + 1)
                End If
            End If
            lIndex = lIndex + 1
        Loop
    Next vEinPfad
    
    'Eintrge in Excel\Add-In Manager durchsuchen
    sEinPfad = sRegAddInManagerPath
    lIndex = 0
    ReDim sAddIn(0)
    Do While True
        vWertName = fvRegistry_WertNummerLesen(HKEY_CURRENT_USER, sEinPfad, lIndex)
        If IsNull(vWertName) = True Then 'fertig
            Exit Do
        End If
        sWertName = CStr(vWertName)
        If InStr(1, sWertName, sADDIN_NAME, 1) > 0 Then
            sAddIn(UBound(sAddIn)) = sWertName
            ReDim Preserve sAddIn(UBound(sAddIn) + 1)
        End If
        lIndex = lIndex + 1
    Loop
     
    'Xlstart-Dir fr Excel ermitteln
    'Die Reihenfolge, in der die Tabelle sDir() gefllt wird, beeinflusst, in welches Verzeichnis
    'das Add-In bei der Installation kopiert wird
    
    '1. Autostart-Verzeichnis des Users ab Office 9.0
    iZaehler1 = 0
    If gbExcelFlag = True Then
        sDir(iZaehler1) = Gib_ExcelStartupVerzeichnis & "\"
    End If
    
    '2. Autostart-Verzeichnis der Installation
    iZaehler1 = 1
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    If sDir(iZaehler1) <> sLEER Then
        sDir(iZaehler1) = sDir(iZaehler1) & "xlstart\"
    End If
    
    '3. Alternatives Autostart-Verzeichnis (das gibt es nur in Excel)
    iZaehler1 = 2
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegMicrosoftExcelPath, "ALTSTARTUP", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
     
    '4. Alternatives Autostart-Verzeichnis (das gibt es nur in Excel)
    'Je nach Office-Version steht der Schssel ALTSTARTUP
    'in Office\x.x\Excel\Options\ oder Office\x.x\Excel\Microsoft Excel\
    iZaehler1 = 3
    sDir(iZaehler1) = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegMicrosoftExcelPath, "ALTSTARTUP", _
        NEVER_RETURN_NULL)
    sDir(iZaehler1) = fsDir_ermitteln(sDir(iZaehler1))
    
    'Doubletten in sDir() entfernen
    For iZaehler1 = LBound(sDir) To UBound(sDir)
        For iZaehler2 = iZaehler1 + 1 To UBound(sDir)
            If LCase(sDir(iZaehler1)) = LCase(sDir(iZaehler2)) Then
                sDir(iZaehler2) = sLEER
            End If
        Next iZaehler2
    Next iZaehler1
    
    'Excel darf nicht laufen
    If iAufgabe > 0 Then
        If fbAnzahlInstanzen_ermitteln(sTASKNAME_EXCEL) > 0 Then
            'Fehler: Mehrere Excel-Instanzen
            MsgBox sMSG_EXCELLAEUFT, vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End If
    End If
        
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case 0 'gbExcelFlag und Sicherheitsflag setzen und in gsAktion beschreiben
        If fsDir_ermitteln(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)) = sLEER Then
            gbExcelFlag = False
        Else
            'Excel auf Echtheit prfen
            On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
            Set oExcel = CreateObject("Excel.Application") 'Erzeugt einen neue Instanz von Excel
            On Error GoTo 0
            If oExcel Is Nothing Then
                gbExcelFlag = False
            Else
                oExcel.Quit
                Set oExcel = Nothing
                gbExcelFlag = True
                'Hier gibt es unter verschiedenen Kombinationen von Windows und Excel einen Fehler:
                'Das Objekt wird nicht immer richtig aus dem Speicher entfernt.
                'Der Fehler ist unter Windows 2000 / Office 2000 und Windows 98 / Office 2002
                'reproduzierbar.
                'Er tritt in der Kombination Windows NT / Office 2000 nicht auf.
                'Siehe fbAnzahlInstanzen_ermitteln
            End If
        End If
        ' If fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath) = True Then
        If gbExcelFlag = False _
        Or sOfficeVersion = "8.0" _
        Or fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
        NEVER_RETURN_NULL) = vSECURITYWERT_DONTTRUST Then
            gbExcelSicherheit = True
        Else
            gbExcelSicherheit = False
        End If
        gbExcelAddInErzeugenFlag = False
    Case 1 'Deinstallation in gsAktion beschreiben
        For iZaehler = LBound(sOpenWert) To UBound(sOpenWert)
            If sOpenWert(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & "Lsche Key HKEY_CURRENT_USER\" & sRegMicrosoftExcelPath & " Name " _
                    & sOpenName(iZaehler) & " mit Wert " & sOpenWert(iZaehler) & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sAddIn) To UBound(sAddIn)
            If sAddIn(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & "Lsche Key HKEY_CURRENT_USER\" & sRegAddInManagerPath & " Name " _
                    & sAddIn(iZaehler) & vbCr
            End If
        Next iZaehler
        
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteExcelAddIns, vbNormal)
                Do While sDatei <> ""
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und darf nicht gelscht werden" & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & "Entferne den Schreibschutz bei Add-In " & sDatei & " aus " _
                            & vEinDir & vbCr
                        gsAktion = gsAktion & sPREFIX _
                            & "Lsche Add-In " & sDatei & " aus " & vEinDir & vbCr
                    End If
                    sDatei = Dir ' Nchsten Eintrag abrufen.
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen beschreiben
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_EXCEL)) Then
            gsAktion = gsAktion & sPREFIX _
                & "Lsche die Konfiguration von Gs4Word in der Registry" & vbCr
        End If
    Case 2 'Wenn gsExcelFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
        If gbExcelFlag = True Then
            If Dir(gsInstVerzeichnis & gsExcelAddIn, vbNormal) = sLEER Then
                gbExcelAddInErzeugenFlag = True
                gbExcelAddInErzeugenAenderbar = False
                If Dir(gsInstVerzeichnis & gsExcelAddIn, vbNormal) <> sLEER Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Lsche Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis & vbCr
                End If
            Else
                gbExcelAddInErzeugenAenderbar = True
            End If
        Else
            gbExcelAddInErzeugenAenderbar = False
        End If
        If gbExcelAddInErzeugenFlag = True Then
            gsAktion = gsAktion & sPREFIX _
                & "Erzeuge Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis & vbCr
        End If
     Case 3 'Wenn gsExcelFlag gesetzt ist Installation, nderung der Sicherheitseinstellungen und
        'erstellen der Konfiguration in gsAktion beschreiben
        If gbExcelFlag = True Then
           'Installation beschreiben
           For Each vEinDir In sDir
               If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & gsExcelAddIn & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und muss nicht mehr kopiert werden" & vbCr
                    Else
                        gsAktion = gsAktion & sPREFIX _
                            & "Kopiere Add-In " & gsExcelAddIn & " nach " & vEinDir & vbCr
                        gsAktion = gsAktion & sPREFIX _
                            & "Setze Schreibschutz bei Add-In " & gsExcelAddIn & " in " & vEinDir _
                            & vbCr
                    End If
                    Exit For
                End If
            Next vEinDir
            'Konfiguration anlegen beschreiben
            gsAktion = gsAktion & sPREFIX _
                & "Schreibe die neue Konfiguration von Gs4Word in die Registry" & vbCr
            'Sicherheitseinstellungen beschreiben
            If gbExcelSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Die Sicherheitseinstellungen mssen nicht verndert werden" & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & "ndere die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                    & "\" & sRegSecurityPath & vbCr
            End If
        End If
    Case 4 'Deinstallation durchfhren und in gsAktion beschreiben
        'Alle alten Eintrge zum Add-In in der Registry lschen
        For iZaehler = LBound(sOpenWert) To UBound(sOpenWert)
            If sOpenWert(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegMicrosoftExcelPath, _
                    sOpenName(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & "Key HKEY_CURRENT_USER\" & sRegMicrosoftExcelPath & " Name " _
                    & sOpenName(iZaehler) & " mit Wert " & sOpenWert(iZaehler) & " wurde gelscht" & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sAddIn) To UBound(sAddIn)
            If sAddIn(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegAddInManagerPath, _
                    sAddIn(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & "Key HKEY_CURRENT_USER\" & sRegAddInManagerPath & " Name " _
                    & sAddIn(iZaehler) & " wurde gelscht" & vbCr
            End If
        Next iZaehler
        
        'Alle alten Versionen des Add-In lschen
        For Each vEinDir In sDir
            If vEinDir <> sLEER Then
                sDatei = Dir(vEinDir & gsAlteExcelAddIns, vbNormal)
                Do While sDatei <> ""
                    SetAttr vEinDir & sDatei, vbNormal 'Bei Excel Schreibschutz entfernen
                    gsAktion = gsAktion & sPREFIX _
                        & "Der Schreibschutz bei Add-In " & sDatei & " aus " & vEinDir _
                        & " wurde entfernt" & vbCr
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und wurde nicht gelscht" & vbCr
                    ElseIf fbDatei_loeschen(vEinDir & sDatei) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " wurde aus " & vEinDir & " gelscht" & vbCr
                    Else
                        'Fehler: Add-In konnte nicht gelscht werden
                        sText = "(FEHLER) Add-In " & sDatei & " in " & vEinDir _
                            & " konnte nicht gelscht werden."
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                    sDatei = Dir(vEinDir & gsAlteExcelAddIns, vbNormal)
                    'sDatei = Dir 'reicht hier nicht, denn in fbDatei_loeschen wurde Dir verndert
                Loop
            End If
        Next vEinDir
        'Konfiguration lschen
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_EXCEL)) Then
            If fbKonfiguration_loeschen(sTASKNAME_EXCEL) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Konfiguration von Gs4Word wurde in der Registry gelscht" & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = "(FEHLER) Konfiguration von Gs4Word konnte in der Registry nicht " _
                    & "gelscht werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case 5 'Wenn gsExcelFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
        If gbExcelAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsExcelAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsExcelAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis _
                        & " wurde gelscht" & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = "(FEHLER) Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis _
                        & " konnte nicht gelscht werden."
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbExcelAddInErzeugen(sOfficeVersion, bERZEUGE_AUS_RUNTIME) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis _
                    & " wurde erzeugt" & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsExcelAddIn)
                'Fehler: Add-In konnte nicht erzeugt werden
                sText = "(FEHLER) Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis _
                    & " konnte nicht erzeugt werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
     Case 6 'Wenn gsExcelFlag gesetzt ist Installation durchfhren und in gsAktion beschreiben
        If gbExcelFlag = True Then
            'Installation durchfhren
            For Each vEinDir In sDir
                If vEinDir <> sLEER Then
                    If LCase(vEinDir) = LCase(gsInstVerzeichnis) Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & sDatei & " liegt im Installationsverzeichnis " _
                            & vEinDir & " und wurde nicht kopiert" & vbCr
                        Exit For
                    ElseIf fbDatei_kopieren(gsInstVerzeichnis & gsExcelAddIn, _
                        vEinDir & gsExcelAddIn) = True Then
                        gsAktion = gsAktion & sPREFIX _
                            & "Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis _
                            & " wurde nach " & vEinDir & " kopiert" & vbCr
                        SetAttr vEinDir & gsExcelAddIn, vbReadOnly 'Bei Excel Schreibschutz setzen
                        gsAktion = gsAktion & sPREFIX _
                            & "Der Schreibschutz bei Add-In " & gsExcelAddIn & " aus " & vEinDir _
                            & " wurde gesetzt" & vbCr
                        Exit For
                    Else
                        'Fehler: Add-In konnte nicht kopiert werden
                        sText = "(FEHLER) Add-In " & gsExcelAddIn & " in " & gsInstVerzeichnis _
                            & "konnte nicht nach " & vEinDir & " kopiert werden" & vbCr
                        gsAktion = gsAktion & sPREFIX & sText & vbCr
                        MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                        Exit Function
                    End If
                End If
            Next vEinDir
            'Konfiguration anlegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTASKNAME_EXCEL, True)
            gsMailToSwitch = gsInstallationsMailToSwitch
            If fbKonfiguration_schreiben(sTASKNAME_EXCEL) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Neue Konfiguration von Gs4Word wurde in die Registry geschrieben" & vbCr
            Else
                'Fehler: Konfiguration konnte nicht in die Registry geschrieben werden
                sText = "(FEHLER) Neue Konfiguration von Gs4Word konnte nicht in die Registry " _
                    & "geschrieben werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
            'Sicherheitseinstellungen aendern
            If gbExcelSicherheit = False Then
                If fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                        & "\" & sRegSecurityPath & " wurden gendert" & vbCr
                Else
                    'Fehler: Sicherheitseinstellungen konnten nicht verndert werden
                    sText = "(FEHLER) Die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                        & "\" & sRegSecurityPath & " konnten nicht verndert werden" & vbCr
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                 End If
            End If
        End If
    End Select
    
    fbExcel_installieren = True

End Function

Function fbPowerpoint_installieren(iAufgabe As Integer, sOfficeVersion As String) As Boolean
    'Die Funktion installiert in drei Aufrufen gsPowerpointAddIn fr Powerpoint in
    'HKEY_CURRENT_USER.
    'Zuvor werden alle alten Versionen des Add-In in HKEY_CURRENT_USER und HKEY_LOCAL_MACHINE
    'gelscht.
    'Die Funktion verwendet folgende Einstellungen:
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\, ""
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, ""
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, AUTOLOAD
    '   HKEY_CURRENT_USER\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, PATH
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\, ""
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, ""
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, AUTOLOAD
    '   HKEY_LOCAL_MACHINE\SOFTWARE\MICROSOFT\OFFICE\x.x\POWERPOINT\ADDINS\Gs4Word\, PATH
    'Argumente:
    '   iAufgabe siehe fbInstallieren
    '   sOfficeVersion ist die Versionsnummer von Office
    'Global:
    '   gsPowerpointAddInRegistryName wird gelesen (Name des Add-In)
    '   gsAltePowerpointAddIns wird gelesen
    '   gsInsVerzeichnis wird gelesen
    '   gsPathSeparator wird gelesen
    '   gbPowerpointxxFlag wird gelesen und gendert
    '   gsAktion wird neu gefllt
    'Rckgabewert:
    '   True = Aufgabe erledigt
    '   False = Es ist eine Fehler aufgetreten
    'Effekt
    '   keiner
    
    Dim oPowerpoint As Object 'Zum Test ob Powerpoint existiert
    Dim bErgebnis As Boolean
    Dim sCurrentUserAddIns() As String
    Dim sLocalMachineAddIns() As String
    Dim iZaehler As Integer
    Dim sRegAddInsPath As String
    Dim sRegInstallrootPath As String
    Dim sRegSecurityPath As String
    Dim lIndex As Long
    Dim vWertName As Variant
    Dim sWertName As String
    Dim sText As String
    Const sPREFIX As String = "    Powerpoint: "
         
    fbPowerpoint_installieren = False
        
    sRegAddInsPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\ADDINS"
    sRegInstallrootPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\INSTALLROOT"
    sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\SECURITY"
                            
    'Prfen ob Gs4Word im Powerpoint-Men "Extras>Add-In-Manager..." als Add-In eingetragen ist
    lIndex = 0
    ReDim sCurrentUserAddIns(0)
    Do While True
        vWertName = fvRegistry_SubPfadNummerLesen(HKEY_CURRENT_USER, sRegAddInsPath, lIndex)
        If IsNull(vWertName) = True Then 'fertig
            Exit Do
        End If
        sWertName = CStr(vWertName)
        If InStr(1, sWertName, sADDIN_NAME, 1) > 0 Then
            sCurrentUserAddIns(UBound(sCurrentUserAddIns)) = sWertName
            ReDim Preserve sCurrentUserAddIns(UBound(sCurrentUserAddIns) + 1)
        End If
        lIndex = lIndex + 1
    Loop
    lIndex = 0
    ReDim sLocalMachineAddIns(0)
    Do While True
        vWertName = fvRegistry_SubPfadNummerLesen(HKEY_LOCAL_MACHINE, sRegAddInsPath, lIndex)
        If IsNull(vWertName) = True Then 'fertig
            Exit Do
        End If
        sWertName = CStr(vWertName)
        If InStr(1, sWertName, sADDIN_NAME, 1) > 0 Then
            sLocalMachineAddIns(UBound(sLocalMachineAddIns)) = sWertName
            ReDim Preserve sLocalMachineAddIns(UBound(sLocalMachineAddIns) + 1)
        End If
        lIndex = lIndex + 1
    Loop
    
    'Powerpoint darf nicht laufen
    If iAufgabe > 0 Then
        If fbAnzahlInstanzen_ermitteln(sTASKNAME_POWERPOINT) > 0 Then
            'Fehler: Mehrere Powerpoint-Instanzen
            MsgBox sMSG_POWERPOINTLAEUFT, vbExclamation, sTITEL_INSTALLIEREN
            Exit Function
        End If
    End If
    
    'Prfen was weiter geschehen soll
    Select Case iAufgabe
    Case 0 'gbPowerpointFlag und Sicherheitsflag setzen und in gsAktion beschreiben
        If fsDir_ermitteln(fvRegistry_WertLesen(HKEY_LOCAL_MACHINE, sRegInstallrootPath, "PATH", _
        NEVER_RETURN_NULL)) = sLEER Then
            gbPowerpointFlag = False
        Else
            gbPowerpointFlag = True
            'Powerpoint auf Echtheit prfen
            On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
            Set oPowerpoint = CreateObject("Powerpoint.Application") 'Erzeugt einen neue Instanz von Powerpoint
            On Error GoTo 0
            If oPowerpoint Is Nothing Then
                gbPowerpointFlag = False
            Else
                oPowerpoint.Quit
                Set oPowerpoint = Nothing
                gbPowerpointFlag = True
            End If
        End If
        If gbPowerpointFlag = False _
        Or sOfficeVersion = "8.0" _
        Or fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath) = False _
        Or fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
            NEVER_RETURN_NULL) = vSECURITYWERT_DONTTRUST = True _
        Or IsNull(fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, sSECURITYNAME_DONTTRUST, _
            WITH_RETURN_NULL)) = True Then
            gbPowerpointSicherheit = True
        Else
            gbPowerpointSicherheit = False
        End If
        gbPowerpointAddInErzeugenFlag = False
    Case 1 'Deinstallation in gsAktion beschreiben
        For iZaehler = LBound(sCurrentUserAddIns) To UBound(sCurrentUserAddIns)
            If sCurrentUserAddIns(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & "Lsche Key HKEY_CURRENT_USER\" & sRegAddInsPath & "\" _
                    & sCurrentUserAddIns(iZaehler) & " mit allen Werten " & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sLocalMachineAddIns) To UBound(sLocalMachineAddIns)
            If sLocalMachineAddIns(iZaehler) <> sLEER Then
                gsAktion = gsAktion & sPREFIX _
                    & "Lsche Key HKEY_LOCAL_MACHINE\" & sRegAddInsPath & "\" _
                    & sLocalMachineAddIns(iZaehler) & " mit allen Werten " & vbCr
            End If
        Next iZaehler
        'Konfiguration lschen beschreiben
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_POWERPOINT)) Then
            gsAktion = gsAktion & sPREFIX _
                & "Lsche die Konfiguration von Gs4Word in der Registry" & vbCr
        End If
    Case 2 'Wenn gbPowerpointFlag gesetzt ist Erzeugen der Add-Ins in gsAktion beschreiben
        If gbPowerpointFlag = True Then
            If Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) = sLEER Then
                gbPowerpointAddInErzeugenFlag = True
                gbPowerpointAddInErzeugenAenderbar = False
                If Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) <> sLEER Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Lsche Add-In " & gsPowerpointAddIn & " in " & gsInstVerzeichnis _
                        & vbCr
                End If
            Else
                gbPowerpointAddInErzeugenAenderbar = True
            End If
        Else
            gbPowerpointAddInErzeugenAenderbar = False
        End If
        If gbPowerpointAddInErzeugenFlag = True Then
            gsAktion = gsAktion & sPREFIX _
                & "Erzeuge Add-In " & gsPowerpointAddIn & " in " & gsInstVerzeichnis & vbCr
        End If
    Case 3 'Wenn gbPowerpointFlag gesetzt ist Installation, nderung der Sicherheitseinstellungen
        'und erstellen der Konfiguration  in gsAktion beschreiben
        If gbPowerpointFlag = True Then
            'Installation beschreiben
            gsAktion = gsAktion & sPREFIX _
                & "Erzeuge Key HKEY_CURRENT_USER\" & sRegAddInsPath & "\" _
                & gsPowerpointAddInRegistryName & " mit allen Werten " & vbCr
            'Konfiguration anlegen beschreiben
            gsAktion = gsAktion & sPREFIX _
                & "Schreibe die neue Konfiguration von Gs4Word in die Registry" & vbCr
            'Sicherheitseinstellungen beschreiben
            If gbPowerpointSicherheit = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Die Sicherheitseinstellungen mssen nicht verndert werden" & vbCr
            Else
                gsAktion = gsAktion & sPREFIX _
                    & "ndere die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                    & "\" & sRegSecurityPath & vbCr
            End If
        End If
    Case 4 'Deinstallation durchfhren und in gsAktion beschreiben
        For iZaehler = LBound(sCurrentUserAddIns) To UBound(sCurrentUserAddIns)
            If sCurrentUserAddIns(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                    & sCurrentUserAddIns(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & "Key HKEY_CURRENT_USER\" & sRegAddInsPath & "\" _
                    & sCurrentUserAddIns(iZaehler) & " mit allen Werten wurde gelscht" & vbCr
            End If
        Next iZaehler
        For iZaehler = LBound(sLocalMachineAddIns) To UBound(sLocalMachineAddIns)
            If sLocalMachineAddIns(iZaehler) <> sLEER Then
                bErgebnis = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                    & sLocalMachineAddIns(iZaehler))
                gsAktion = gsAktion & sPREFIX _
                    & "Key HKEY_LOCAL_MACHINE\" & sRegAddInsPath & "\" _
                    & sLocalMachineAddIns(iZaehler) & " mit allen Werten wurde gelscht" & vbCr
            End If
        Next iZaehler
        'Konfiguration lschen
        If Not IsEmpty(GetAllSettings(sREGISTRY_APPNAME, sREGISTRY_SECTION & sSPACE _
        & sTASKNAME_POWERPOINT)) Then
            If fbKonfiguration_loeschen(sTASKNAME_POWERPOINT) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Konfiguration von Gs4Word wurde in der Registry gelscht" & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = "(FEHLER) Konfiguration von Gs4Word konnte in der Registry nicht " _
                    & "gelscht werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case 5 'Wenn gbPowerpointFlag gesetzt ist Add-Ins erzeugen und in gsAktion beschreiben
        If gbPowerpointAddInErzeugenFlag = True Then
            If Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) <> sLEER Then
                If fbDatei_loeschen(gsInstVerzeichnis & gsPowerpointAddIn) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Add-In " & gsPowerpointAddIn & " in " & gsInstVerzeichnis _
                        & " wurde gelscht" & vbCr
                Else
                    'Fehler: Add-In konnte nicht gelscht werden
                    sText = "(FEHLER) Add-In " & gsPowerpointAddIn & " in " & gsInstVerzeichnis _
                        & " konnte nicht gelscht werden."
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
            If fbPowerpointAddInErzeugen(sOfficeVersion, bERZEUGE_AUS_RUNTIME) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Add-In " & gsPowerpointAddIn & " in " & gsInstVerzeichnis _
                    & " wurde erzeugt" & vbCr
            Else
                Call fbDatei_loeschen(gsInstVerzeichnis & gsPowerpointAddIn)
                'Fehler: Add-In konnte nicht erzeugt werden
                sText = "(FEHLER) Add-In " & gsPowerpointAddIn & " in " & gsInstVerzeichnis _
                    & " konnte nicht erzeugt werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
        End If
    Case 6 'Wenn gbPowerpointFlag gesetzt ist Installation durchfhren und in gsAktion beschreiben
        If gbPowerpointFlag = True Then
            'Installation
            bErgebnis = fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                & gsPowerpointAddInRegistryName, "PATH", gsInstVerzeichnis & gsPowerpointAddIn, REG_SZ)
            bErgebnis = fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegAddInsPath & "\" _
                & gsPowerpointAddInRegistryName, "AUTOLOAD", "&Hffffffff", REG_DWORD)
            gsAktion = gsAktion & sPREFIX _
                & "Key HKEY_CURRENT_USER\" & sRegAddInsPath & "\" _
                & gsPowerpointAddInRegistryName & " mit allen Werten wurde angelegt" & vbCr
            'Konfiguration anlegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTASKNAME_POWERPOINT, True)
            gsMailToSwitch = gsInstallationsMailToSwitch
            If fbKonfiguration_schreiben(sTASKNAME_POWERPOINT) = True Then
                gsAktion = gsAktion & sPREFIX _
                    & "Neue Konfiguration von Gs4Word wurde in die Registry geschrieben" & vbCr
            Else
                'Fehler: Add-In konnte nicht gelscht werden
                sText = "(FEHLER) Neue Konfiguration von Gs4Word konnte nicht in die Registry " _
                    & "geschrieben werden."
                gsAktion = gsAktion & sPREFIX & sText & vbCr
                MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                Exit Function
            End If
            'Sicherheitseinstellungen aendern
            If gbPowerpointSicherheit = False Then
                If fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
                    gsAktion = gsAktion & sPREFIX _
                        & "Die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                        & "\" & sRegSecurityPath & " wurden gendert" & vbCr
                Else
                    'Fehler: Sicherheitseinstellungen konnten nicht verndert werden
                    sText = "(FEHLER) Die Sicherheitseinstellungen im Key HKEY_CURRENT_USER" _
                        & "\" & sRegSecurityPath & " konnten nicht verndert werden" & vbCr
                    gsAktion = gsAktion & sPREFIX & sText & vbCr
                    MsgBox sText, vbExclamation, sTITEL_INSTALLIEREN
                    Exit Function
                End If
            End If
        End If
    End Select
    
    fbPowerpoint_installieren = True

End Function

Function fsDir_ermitteln(sDir As String) As String
    'Die Funktion ermittet aus der Eingabe das Verzeichnis. Dabei werden Evironment-Variable ersetzt
    
    Dim lPosition As Long
    
    If sDir <> sLEER Then
        sDir = Trim(sDir)
        If Left(sDir, 1) = Chr(34) Then 'Verzeichnis ist in Anfhrungszeichen eingeschossen
            sDir = Mid(sDir, 2) 'erstes Anfhrungszeichen entfernen
            lPosition = InStr(sDir, Chr(34)) 'zweites Anfhrungszeichen suchen
            sDir = Left(sDir, lPosition - 1)
        End If
        If Right(sDir, 1) <> gsPathSeparator Then
            sDir = sDir & gsPathSeparator
        End If
        If LCase(Left(sDir, 12)) = LCase("%systemroot%") Then
            sDir = Environ("systemroot") & gsPathSeparator & Mid(sDir, 13)
        ElseIf LCase(Left(sDir, 13)) = LCase("%userprofile%") Then
            sDir = Environ("userprofile") & gsPathSeparator & Mid(sDir, 13)
        End If
        If Dir(sDir, vbDirectory) = sLEER Then 'Verzeichnis existiert nicht
            sDir = sLEER
        End If
    End If
    fsDir_ermitteln = sDir
End Function

Function fbDatei_kopieren(sVonDateiname As String, sNachDateiname As String) As Boolean
    'Die Funktion kopiert eine normale, nicht gesperrte Datei. Wenn das nicht mglich ist, wird eine
    'Meldung angezeigt. Scheibgeschtzte Dateien, versteckte Dateien, Systemdateien oder
    'Verzeichnisse werden nicht kopiert.
    'Argumente:
    '   sVonDateiname = Name der Quell-Datei
    '   sNachDateiname = Name der Ziel-Datei
    'Rckgabewert:
    '   False = Datei sVonDateiname konnte nicht nach sNachDateiname werden.
    '   True = Datei sVonDateiname wurde nach sNachDateiname kopiert.
    'Effekt
    '   Entweder wurde sVonDateiname wurde nach sNachDateiname kopiert
    '   oder es wurde eine Fehlermeldung angezeigt.
    
    Dim iDateiAttribute As Integer 'Attribute der Datei in sDateiName
    Dim iFehlerNummer As Integer 'Fehlernumer aus GetAttr()
    
    
    On Error Resume Next
    iDateiAttribute = GetAttr(sVonDateiname)
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        If iDateiAttribute And vbReadOnly Then
            MsgBox sMSG_DATEIISTSCHREIBGESCHUETZT _
                & vbCr & "(" & sVonDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbHidden Then 'wird mit Dir(sDateiName) nicht gefunden
            MsgBox sMSG_DATEIISTVERSTECKT _
                & vbCr & "(" & sVonDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbSystem Then
            MsgBox sMSG_DATEIISTSYSTEMDATEI _
                & vbCr & "(" & sVonDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbDirectory Then
            MsgBox sMSG_DATEIISTVERZEICHNIS _
                & vbCr & "(" & sVonDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        End If
    Else
        MsgBox sMSG_KDATEIFEHLT _
            & vbCr & "(" & sVonDateiname & ")" _
            , vbExclamation, sTITEL_INSTALLIEREN
        fbDatei_kopieren = False
        Exit Function
    End If
    
    On Error Resume Next
    iDateiAttribute = GetAttr(sNachDateiname)
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        If iDateiAttribute And vbReadOnly Then
            MsgBox sMSG_DATEIISTSCHREIBGESCHUETZT _
                & vbCr & "(" & sNachDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbHidden Then 'wird mit Dir(sDateiName) nicht gefunden
            MsgBox sMSG_DATEIISTVERSTECKT _
                & vbCr & "(" & sNachDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbSystem Then
            MsgBox sMSG_DATEIISTSYSTEMDATEI _
                & vbCr & "(" & sNachDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        ElseIf iDateiAttribute And vbDirectory Then
            MsgBox sMSG_DATEIISTVERZEICHNIS _
                & vbCr & "(" & sNachDateiname & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbDatei_kopieren = False
            Exit Function
        End If
    End If
    
    On Error Resume Next
    FileCopy sVonDateiname, sNachDateiname
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then 'Datei vorhanden
        fbDatei_kopieren = True
    Else
        MsgBox sMSG_KDATEIKANNNICHTKOPIERTWERDEN _
            & vbCr & "(" & sNachDateiname & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbDatei_kopieren = False
    End If
    
End Function

Function Gib_ExcelStartupVerzeichnis() As String
    Dim iFehlerNummer As Integer
    Dim sExcelStartupVerzeichnis As String
    
    Dim oExcel As Object
       
    'Excel-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
    Set oExcel = CreateObject("Excel.Application") 'Erzeugt einen neue Instanz von Excel
    On Error GoTo 0
    If oExcel Is Nothing Then
        Gib_ExcelStartupVerzeichnis = sLEER
        Exit Function
    End If
    
    On Error Resume Next
    Gib_ExcelStartupVerzeichnis = oExcel.Application.StartupPath
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        Gib_ExcelStartupVerzeichnis = sLEER
    End If
    
    oExcel.Quit
    Set oExcel = Nothing

End Function

Function fbInstallationsdateienPruefen(sOfficeVersion As String) As Boolean

    Dim sDateien(2) As String
    Dim vEineDatei As Variant
    Dim sVerzeichnisse(3) As String
    Dim vEinVerzeichnis As Variant
    
    'Namen aller Dateien des Add-In eintragen
    sDateien(0) = "gpl.txt"
    sDateien(1) = "Dokumentation.html"
    sDateien(2) = "liesmich.txt"
    sVerzeichnisse(0) = "Sourcen"
    sVerzeichnisse(1) = "Runtime"
    sVerzeichnisse(2) = "Html"
    sVerzeichnisse(3) = "Html\Gs4Word"
       
    'Alle Dateien prfen
    For Each vEineDatei In sDateien
        If Dir(gsInstVerzeichnis & vEineDatei, vbNormal) = sLEER Then
            MsgBox sMSG_DATEIFEHLT _
                & vbCr & "(" & gsInstVerzeichnis & vEineDatei & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbInstallationsdateienPruefen = False
            Exit Function
        End If
    Next vEineDatei
    
    If Dir(gsInstVerzeichnis & sVerzeichnisse(1), vbDirectory) = sLEER Then
        MkDir gsInstVerzeichnis & sVerzeichnisse(1)
    End If
    
    'Alle Verzeichnisse prfen
    For Each vEinVerzeichnis In sVerzeichnisse
        If Dir(gsInstVerzeichnis & vEinVerzeichnis, vbDirectory) = sLEER Then
            MsgBox sMSG_VERZEICHNISFEHLT _
                & vbCr & "(" & gsInstVerzeichnis & vEinVerzeichnis & ")" _
                , vbExclamation, sTITEL_INSTALLIEREN
            fbInstallationsdateienPruefen = False
            Exit Function
        End If
    Next vEinVerzeichnis
        
    fbInstallationsdateienPruefen = False
    If fbInstallationAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
        If fbKonfigurationAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
            If fbWordAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                If fbExcelAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                    If fbPowerpointAddInErzeugen(sOfficeVersion, bERZEUGE_PRUEFEN) = True Then
                        fbInstallationsdateienPruefen = True
                    End If
                End If
            End If
        End If
    End If

End Function

Function fbInstallationAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oWord As Object
    'Dim oEinCommandBar As Object
    Dim oControl As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(8) As String
    Dim sSourcePfad As String
    
    'Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_ger.bas"
    sDateien(2) = "TECH_Prozeduren.bas"
    sDateien(3) = "TECH_ger.bas"
    sDateien(4) = "INST_Prozeduren.bas"
    sDateien(5) = "INST_ger.bas"
    sDateien(6) = "INST_UF_Deinstallation.frm"
    sDateien(7) = "INST_UF_Installation.frm"
    sDateien(8) = "REG_Prozeduren.bas"
       
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & "Sourcen\" & vEineDatei, vbNormal) = sLEER Then
                MsgBox sMSG_SOURCEFEHLT _
                    & vbCr & "(" & gsInstVerzeichnis & "Sourcen\" & vEineDatei & ")" _
                    , vbExclamation, sTITEL_INSTALLIEREN
                fbInstallationAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbInstallationAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & "Sourcen\" & vEineDatei, _
                gsInstVerzeichnis & "Runtime\" & vEineDatei)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & "Runtime\"
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & "Sourcen\"
    End Select
        
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbInstallationAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbInstallationAddInErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox sMSG_KEINEWEITEREVERBINDUNGZUWORD, vbExclamation, sTITEL_INSTALLIEREN
        fbInstallationAddInErzeugen = False
    End If
    
    If fbInstallationAddInErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & gsInstallationsAddIn, _
            FileFormat:=wdFormatTemplate
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox sMSG_WORDSOURCENICHTLADBAR, vbExclamation, sTITEL_INSTALLIEREN
                    fbInstallationAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbInstallationAddInErzeugen = True Then
            'Alle Mens verbergen
            'For Each oEinCommandBar In oWord.CommandBars
            '    If oEinCommandBar.Visible = True _
            '    And oEinCommandBar.Name <> "Menu Bar" Then
            '        'MsgBox oEinCommandBar.Name
            '        oEinCommandBar.Visible = False
            '    End If
            'Next oEinCommandBar
            
            'Neues Menu einfgen
            oWord.CommandBars.Add(Name:=sADDIN_NAME, Position:=msoBarTop).Visible = True
            Set oControl = oWord.CommandBars(sADDIN_NAME).Controls.Add(Type:=msoControlButton, ID:=1, _
                Before:=1, temporary:=False)
            With oControl
                .FaceId = 2144
                .Caption = "Gs4Word deinstallieren"
                .Style = msoButtonIconAndCaption
                .OnAction = sVORLAGE_ACTION_DEINSTALLATION
                .Enabled = True
                .Visible = True
                .BeginGroup = True
            End With
            Set oControl = oWord.CommandBars(sADDIN_NAME).Controls.Add(Type:=msoControlButton, ID:=1, _
                Before:=1, temporary:=False)
            With oControl
                .FaceId = 2144
                .Caption = "Gs4Word installieren"
                .Style = msoButtonIconAndCaption
                .OnAction = sVORLAGE_ACTION_INSTALLATION
                .Enabled = True
                .Visible = True
                .BeginGroup = True
            End With
            
            ' Text einfgen
            With oWord.Selection
                .Font.Bold = True
                .TypeText Text:="Installation von Gs4Word"
                .Font.Bold = False
                .TypeParagraph
                .TypeParagraph
                .TypeText Text:="Unterhalb der Menzeile finden Sie eine neue Leiste mit zwei " _
                    & "Buttons:"
                .TypeParagraph
                .TypeParagraph
                .TypeText Text:="Mit dem Button "
                .Font.Bold = True
                .TypeText Text:="Gs4Word installieren"
                .Font.Bold = False
                .TypeText Text:=" knnen Sie Gs4Word installieren. " _
                    & "Vorhandene Installationen werden dabei deinstalliert. " _
                    & "Fehlende Add-Ins werden automatisch neu erzeugt."
                .TypeParagraph
                .TypeText Text:="Mit dem Button "
                .Font.Bold = True
                .TypeText Text:="Gs4Word deinstallieren"
                .Font.Bold = False
                .TypeText Text:=" knnen Sie Gs4Word wieder deinstallieren."
                .TypeParagraph
            End With
        End If
        
        If fbInstallationAddInErzeugen = True Then
        
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & gsInstallationsAddIn, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_INSTALLATIONSADDINNICHTERZEUGT, vbExclamation, sTITEL_INSTALLIEREN
                fbInstallationAddInErzeugen = False
            Else
                fbInstallationAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)

End Function

Function fbKonfigurationAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oWord As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(6) As String
    Dim sSourcePfad As String
    
    'Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_ger.bas"
    sDateien(2) = "TECH_Prozeduren.bas"
    sDateien(3) = "TECH_ger.bas"
    sDateien(4) = "KONF_Prozeduren.bas"
    sDateien(5) = "KONF_UserForm.frm"
    sDateien(6) = "KONF_ger.bas"
       
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & "Sourcen\" & vEineDatei, vbNormal) = sLEER Then
                MsgBox sMSG_SOURCEFEHLT _
                    & vbCr & "(" & gsInstVerzeichnis & "Sourcen\" & vEineDatei & ")" _
                    , vbExclamation, sTITEL_INSTALLIEREN
                fbKonfigurationAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbKonfigurationAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & "Sourcen\" & vEineDatei, _
                gsInstVerzeichnis & "Runtime\" & vEineDatei)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & "Runtime\"
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & "Sourcen\"
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbKonfigurationAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbKonfigurationAddInErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox sMSG_KEINEWEITEREVERBINDUNGZUWORD, vbExclamation, sTITEL_INSTALLIEREN
        fbKonfigurationAddInErzeugen = False
    End If
    
    If fbKonfigurationAddInErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & gsKonfigurationAddIn, _
            FileFormat:=wdFormatTemplate
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox sMSG_WORDSOURCENICHTLADBAR, vbExclamation, sTITEL_INSTALLIEREN
                    fbKonfigurationAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbKonfigurationAddInErzeugen = True Then
        
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & gsKonfigurationAddIn, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_KONFIGADDINNICHTERZEUGT, vbExclamation, sTITEL_INSTALLIEREN
                fbKonfigurationAddInErzeugen = False
            Else
                fbKonfigurationAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)

End Function

Function fbWordAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oWord As Object
    Dim iFehlerNummer As Integer

    Dim sDateien(4) As String
    Dim vEineDatei As Variant
    Dim sSourcePfad As String
    
    '(1) Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_ger.bas"
    sDateien(2) = "GLOB_UserForm.frm"
    sDateien(3) = "DOC_Prozeduren.bas"
    sDateien(4) = "DOC_ger.bas"
    
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & "Sourcen\" & vEineDatei, vbNormal) = sLEER Then
                MsgBox sMSG_SOURCEFEHLT _
                    & vbCr & "(" & gsInstVerzeichnis & "Sourcen\" & vEineDatei & ")" _
                    , vbExclamation, sTITEL_INSTALLIEREN
                fbWordAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbWordAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & "Sourcen\" & vEineDatei, _
                gsInstVerzeichnis & "Runtime\" & vEineDatei)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & "Runtime\"
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & "Sourcen\"
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_WORD, sOfficeVersion) = False Then
        fbWordAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbWordAddInErzeugen = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox sMSG_KEINEWEITEREVERBINDUNGZUWORD, vbExclamation, sTITEL_INSTALLIEREN
        fbWordAddInErzeugen = False
    End If
    
    If fbWordAddInErzeugen = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=gsInstVerzeichnis & gsWordAddIn, _
            FileFormat:=wdFormatTemplate
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox sMSG_WORDSOURCENICHTLADBAR, vbExclamation, sTITEL_INSTALLIEREN
                    fbWordAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbWordAddInErzeugen = True Then
        
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            '17.8.2002 Es funktioniert doch nicht immer
            oWord.ActiveDocument.SaveAs _
                FileName:=gsInstVerzeichnis & gsWordAddIn, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_WORDADDINNICHTERZEUGT, vbExclamation, sTITEL_INSTALLIEREN
                fbWordAddInErzeugen = False
            Else
                fbWordAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_WORD, sOfficeVersion)
    
End Function

Function fbExcelAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oExcel As Object
    Dim iFehlerNummer As Integer

    Dim sDateien(4) As String
    Dim vEineDatei As Variant
    Dim sSourcePfad As String
    Dim sWorkbookname As String
    
    '(1) Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_ger.bas"
    sDateien(2) = "GLOB_UserForm.frm"
    sDateien(3) = "XLS_Prozeduren.bas"
    sDateien(4) = "XLS_ger.bas"
    
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & "Sourcen\" & vEineDatei, vbNormal) = sLEER Then
                MsgBox sMSG_SOURCEFEHLT _
                    & vbCr & "(" & gsInstVerzeichnis & "Sourcen\" & vEineDatei & ")" _
                    , vbExclamation, sTITEL_INSTALLIEREN
                fbExcelAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbExcelAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & "Sourcen\" & vEineDatei, _
                gsInstVerzeichnis & "Runtime\" & vEineDatei)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & "Runtime\"
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & "Sourcen\"
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_EXCEL, sOfficeVersion) = False Then
        fbExcelAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbExcelAddInErzeugen = True
    
    'Excel-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oExcel Nothing
    Set oExcel = CreateObject("Excel.Application") 'Erzeugt einen neue Instanz von Excel
    On Error GoTo 0
    If oExcel Is Nothing Then
        MsgBox sMSG_KEINEVERBINDUNGZUEXCEL, vbExclamation, sTITEL_INSTALLIEREN
        fbExcelAddInErzeugen = False
    End If
    
    If fbExcelAddInErzeugen = True Then
    
        'Excel Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oExcel.Visible = True
        oExcel.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oExcel.Workbooks.Add
        
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oExcel.ActiveWorkbook.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox sMSG_EXCELSOURCENICHTLADBAR, vbExclamation, sTITEL_INSTALLIEREN
                    fbExcelAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If fbExcelAddInErzeugen = True Then
            'Add-In speichern
            'Dazu muss das Workbook als Add-In gekennzeichnet werden. Danach wird es nicht mehr als
            'ActiveWorkbook erkannt und muss mit seinem Namen angesprochen werden.
            sWorkbookname = oExcel.ActiveWorkbook.Name
            On Error Resume Next
            oExcel.ActiveWorkbook.IsAddin = True
            iFehlerNummer = Err.Number
            If iFehlerNummer = 0 Then
                oExcel.Workbooks(sWorkbookname).SaveAs _
                    FileName:=gsInstVerzeichnis & gsExcelAddIn, _
                    FileFormat:=18 '18 = xlAddIn
                iFehlerNummer = Err.Number
            End If
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_EXCELADDINNICHTERZEUGT, vbExclamation, sTITEL_INSTALLIEREN
                fbExcelAddInErzeugen = False
            Else
                fbExcelAddInErzeugen = True
            End If
        End If
        If fbExcelAddInErzeugen = False Then
            On Error Resume Next
            oExcel.ActiveWorkbook.Close SaveChanges:=False
            On Error GoTo 0
        End If
        
        oExcel.Quit
        Set oExcel = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_EXCEL, sOfficeVersion)

End Function

Function fbPowerpointAddInErzeugen(sOfficeVersion As String, bAktion As Byte) As Boolean

    Dim oPowerpoint As Object
    Dim iFehlerNummer As Integer

    Dim sDateien(4) As String
    Dim vEineDatei As Variant
    Dim sSourcePfad As String
    
    '(1) Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "GLOB_Prozeduren.bas"
    sDateien(1) = "GLOB_ger.bas"
    sDateien(2) = "GLOB_UserForm.frm"
    sDateien(3) = "PPT_Prozeduren.bas"
    sDateien(4) = "PPT_ger.bas"
        
    Select Case bAktion
    Case bERZEUGE_PRUEFEN
        For Each vEineDatei In sDateien
            If Dir(gsInstVerzeichnis & "Sourcen\" & vEineDatei, vbNormal) = sLEER Then
                MsgBox sMSG_SOURCEFEHLT _
                    & vbCr & "(" & gsInstVerzeichnis & "Sourcen\" & vEineDatei & ")" _
                    , vbExclamation, sTITEL_INSTALLIEREN
                fbPowerpointAddInErzeugen = False
                Exit Function
            End If
        Next vEineDatei
        fbPowerpointAddInErzeugen = True
        Exit Function
    Case bERZEUGE_AUS_RUNTIME
        For Each vEineDatei In sDateien
            Call fbSourceOhneKommentar_erzeugen( _
                gsInstVerzeichnis & "Sourcen\" & vEineDatei, _
                gsInstVerzeichnis & "Runtime\" & vEineDatei)
        Next vEineDatei
        sSourcePfad = gsInstVerzeichnis & "Runtime\"
    Case bERZEUGE_AUS_SOURCE
        sSourcePfad = gsInstVerzeichnis & "Sourcen\"
    End Select
    
    If fbSecurity_aendern("ErzeugenSet", sTASKNAME_POWERPOINT, sOfficeVersion) = False Then
        fbPowerpointAddInErzeugen = False
        Exit Function
    End If
    
    'Beginnen wir die Sache mal optimistisch
    fbPowerpointAddInErzeugen = True
    
    'Powerpoint-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oPowerpoint Nothing
    Set oPowerpoint = CreateObject("Powerpoint.Application") 'Erzeugt einen neue Instanz von Powerpoint
    On Error GoTo 0
    If oPowerpoint Is Nothing Then
        MsgBox sMSG_KEINEVERBINDUNGZUPOWERPOINT, vbExclamation, sTITEL_INSTALLIEREN
        fbPowerpointAddInErzeugen = False
    End If
    
    If fbPowerpointAddInErzeugen = True Then
    
        'Powerpoint Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht
        'eingreifen, falls das Erzeugen des Add-In nicht funktioniert.
        '   In Office 10.0 muss Visible=True sein, sonst kann Powerpoint das Add-In nicht erzeugen!
        '   Oder ist es etwas anderes, das gleichzeitig mit Visiable aktiviert wird?
        oPowerpoint.Visible = True
        oPowerpoint.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oPowerpoint.Presentations.Add
        
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oPowerpoint.ActivePresentation.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox sMSG_POWERPOINTSOURCENICHTLADBAR, vbExclamation, sTITEL_INSTALLIEREN
                    fbPowerpointAddInErzeugen = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        'Add-In speichern
        On Error Resume Next
        oPowerpoint.ActivePresentation.SaveAs gsInstVerzeichnis & gsPowerpointAddIn, 8 '8 = ppSaveAsAddIn
        iFehlerNummer = Err.Number
        If iFehlerNummer <> 0 Then
            MsgBox sMSG_POWERPOINTADDINNICHTERZEUGT, vbExclamation, sTITEL_INSTALLIEREN
            fbPowerpointAddInErzeugen = False
        End If
            
        If fbPowerpointAddInErzeugen = True Then
            On Error Resume Next
            oPowerpoint.ActivePresentation.Close
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_POWERPOINTADDINNICHTERZEUGT, vbExclamation, sTITEL_INSTALLIEREN
                fbPowerpointAddInErzeugen = False
            Else
                fbPowerpointAddInErzeugen = True
            End If
        Else
            On Error Resume Next
            oPowerpoint.ActivePresentation.Close
            On Error GoTo 0
        End If
        
        If fbPowerpointAddInErzeugen = True _
        And Dir(gsInstVerzeichnis & gsPowerpointAddIn, vbNormal) = sLEER Then
            'unter Office 10.0 erzeugt Powerpoint einfach kein Add-In wenn es fehlerhaft ist
            'Dabei meldet Powerpoint keinen Fehler!
                MsgBox sMSG_POWERPOINTSOURCENICHTLADBAR, vbExclamation, sTITEL_INSTALLIEREN
                fbPowerpointAddInErzeugen = False
        End If
        
        oPowerpoint.Quit
        Set oPowerpoint = Nothing
    End If
    
    Call fbSecurity_aendern("ErzeugenReset", sTASKNAME_POWERPOINT, sOfficeVersion)
        
End Function

Function fbSourceOhneKommentar_erzeugen(sDateiNameAlt As String, sDateiNameNeu As String) As Boolean
    
    Const sKZENDE As String = " _"
    Const lMAXZEILENLAENGE As Long = 1023
    Const sOPTIONEXPLIZIT As String = "Option Explicit"
    
    Dim lPosKommentar As Long
    Dim lPosLiteral As Long
    Dim sFortsetzung As String
    Dim sZeile As String
            
    Open sDateiNameAlt For Input Access Read Shared As #1
    Open sDateiNameNeu For Output Access Write As #2
    
    'Print #2, "Rem Copyright (C) 2002 J.W.Schmitz-Hbsch"
    'Print #2, "Rem Dieser Code wurde aus der Source " & sDateiNameAlt & " generiert."
    
    sFortsetzung = sLEER
    Do While Not EOF(1) ' Auf Dateiende abfragen.
        Line Input #1, sZeile   ' Datenzeilen lesen.
        sZeile = sZeile & sLEER
        lPosKommentar = InStr(sZeile, "'")
        lPosLiteral = InStr(sZeile, Chr(34))
        If lPosKommentar > 0 _
        And (lPosLiteral = 0 Or lPosKommentar < lPosLiteral) Then
            sZeile = Left(sZeile, lPosKommentar - 1)
        End If
        If Not Trim(sZeile) = sLEER Then
            sZeile = Trim(sZeile)
            If sZeile = sOPTIONEXPLIZIT Then
                Print #2, "Rem Copyright (C) 2002 J.W.Schmitz-Hbsch"
                Print #2, "Rem Dieser Code wurde aus der Source " & sDateiNameAlt & " generiert."
            End If
            
            '----------------------+---------+---------+---------+---------+---------+---------+
            '                      |   (1)   |   (2)   |   (3)   |   (4)   |   (5)   |   (6)   |
            '----------------------+---------+---------+---------+---------+---------+---------+
            'sFortsetzung          |  leer   |  leer   | gefllt | gefllt | gefllt | gefllt |
            'sZeile                |fortsetz.| normal  |fortsetz.|fortsetz.| normal  | normal  |
            'sZeile + sForts > 1023|    -    |    -    |    J    |    N    |    J    |    N    |
            '----------------------+---------+---------+---------+---------+---------+---------+
            'sForts.=sForts.&sZeile|    -    |    -    |    -    |    X    |    -    |    X    |
            'Print sFortsetzung    |    -    |    -    |    X    |    -    |    X    |    X    |
            'sFortsetzung = ""     |    -    |    -    |    -    |    -    |    X    |    -    |
            'sFortsetzung = sZeile |    X    |    -    |    X    |    -    |    -    |    -    |
            'Print sZeile          |    -    |    X    |    -    |    -    |    X    |    -    |
            '----------------------+---------+---------+---------+---------+---------+---------+
            If sFortsetzung = sLEER Then
                If Right(sZeile, 2) = sKZENDE Then
                    'Fall (1)
                    sFortsetzung = Trim(Left(sZeile, Len(sZeile) - 2))
                Else
                    'Fall (2)
                    Print #2, sZeile
                End If
            Else
                If Right(sZeile, 2) = sKZENDE Then
                    If Len(sFortsetzung & sSPACE & sZeile) > lMAXZEILENLAENGE Then
                        'Fall (3)
                        Print #2, sFortsetzung & sKZENDE
                        sFortsetzung = Trim(Left(sZeile, Len(sZeile) - 2))
                    Else
                        'Fall (4)
                        sFortsetzung = sFortsetzung & sSPACE & Trim(Left(sZeile, Len(sZeile) - 2))
                    End If
                Else
                    If Len(sFortsetzung & sSPACE & sZeile) > lMAXZEILENLAENGE Then
                        'Fall (5)
                        Print #2, sFortsetzung & sKZENDE
                        Print #2, sZeile
                        sFortsetzung = sLEER
                    Else
                        'Fall (6)
                        sFortsetzung = sFortsetzung & sSPACE & Trim(sZeile)
                        Print #2, sFortsetzung
                        sFortsetzung = sLEER
                    End If
                End If
            End If
        End If
    Loop
    
    Close #1
    Close #2
    
    'Zu UserForms (.frm) gehrt immer eine .frx-Datei
    If LCase(Right(sDateiNameAlt, 4)) = ".frm" _
    And LCase(Right(sDateiNameNeu, 4)) = ".frm" Then
        Call fbDatei_kopieren( _
            Left(sDateiNameAlt, Len(sDateiNameAlt) - 4) & ".frx", _
            Left(sDateiNameNeu, Len(sDateiNameNeu) - 4) & ".frx")
    End If

    
    fbSourceOhneKommentar_erzeugen = True
    
End Function

Function fbSecurity_aendern(sAufgabe As String, sTaskName As String, sOfficeVersion As String) As Boolean
'SOFTWARE\MICROSOFT\OFFICE\XX.X\XXXXX\SECURITY
'               Unter Powerpoint 10.0 kann der Eintrag SECURIRY komplett fehlen
'               DWORD Level Sicherheitsstufe
'                       1 = Niedrig; 2 = Mittel; 3=Hoch
'               DWORD AccessVBOM  Zugriff auf Visual-Basic-Objekt vertrauen
'                       0 = Aus; 1 = An (Name kann fehlen)
'               DWORD DontTustInstalledFiles Allen installieren Add-Ins vertrauen
'                       0 = Vertrauen 1= Nicht vertrauen (Name kann fehlen)

    Static bSecurityVorhanden As Boolean
    Static vLevel As Variant
    Static vAccessVBOM As Variant
    Static vDontTust As Variant
    
    Dim sRegSecurityPath As String
    
    fbSecurity_aendern = True
    
    If sOfficeVersion = "8.0" Then
        Exit Function
    End If
    
    Select Case sTaskName
    Case sTASKNAME_WORD
        sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\WORD\SECURITY"
    Case sTASKNAME_EXCEL
        sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\EXCEL\SECURITY"
    Case sTASKNAME_POWERPOINT
        sRegSecurityPath = "SOFTWARE\MICROSOFT\OFFICE\" & sOfficeVersion & "\POWERPOINT\SECURITY"
    Case Else
        MsgBox sMSG_CASEELSE & vbCr & "(fbSecurity_aendern)" _
            , vbExclamation, sTITEL_INSTALLIEREN & " Case 1"
            fbSecurity_aendern = False
            Exit Function
    End Select
    
    Select Case sAufgabe
    Case "ErzeugenSet"
        bSecurityVorhanden = fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sRegSecurityPath)
        vLevel = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
            sSECURITYNAME_LEVEL, NEVER_RETURN_NULL)
        vAccessVBOM = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
            sSECURITYNAME_ACCESSVBOM, NEVER_RETURN_NULL)
        vDontTust = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
            sSECURITYNAME_DONTTRUST, NEVER_RETURN_NULL)
        If Not vLevel = vSECURITYWERT_LEVEL_1 _
        And Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_LEVEL, vSECURITYWERT_LEVEL_1, REG_DWORD) = True Then
            fbSecurity_aendern = False
        End If
        If Not vAccessVBOM = vSECURITYWERT_ACCESSVBOM _
        And Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_ACCESSVBOM, vSECURITYWERT_ACCESSVBOM, REG_DWORD) = True Then
            fbSecurity_aendern = False
        End If
        If Not vDontTust = vSECURITYWERT_DONTTRUST _
        And Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_DONTTRUST, vSECURITYWERT_DONTTRUST, REG_DWORD) = True Then
            fbSecurity_aendern = False
        End If
    Case "ErzeugenReset"
        If Not vLevel = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_LEVEL, NEVER_RETURN_NULL) Then
            If vLevel = sLEER Then
                If Not fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_LEVEL) = True Then
                    fbSecurity_aendern = False
                End If
            Else
                If Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_LEVEL, vLevel, REG_DWORD) = True Then
                    fbSecurity_aendern = False
                End If
            End If
        
        End If
        If Not vAccessVBOM = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_ACCESSVBOM, NEVER_RETURN_NULL) Then
            If vAccessVBOM = sLEER Then
                If Not fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_ACCESSVBOM) = True Then
                    fbSecurity_aendern = False
                End If
            Else
                If Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_ACCESSVBOM, vAccessVBOM, REG_DWORD) = True Then
                    fbSecurity_aendern = False
                End If
            End If
        End If
        If Not vDontTust = fvRegistry_WertLesen(HKEY_CURRENT_USER, sRegSecurityPath, _
        sSECURITYNAME_DONTTRUST, NEVER_RETURN_NULL) Then
            If vDontTust = sLEER Then
                If Not fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST) = True Then
                    fbSecurity_aendern = False
                End If
            Else
                If Not fbRegistry_WertSetzen(HKEY_CURRENT_USER, sRegSecurityPath, _
                sSECURITYNAME_DONTTRUST, vDontTust, REG_DWORD) = True Then
                    fbSecurity_aendern = False
                End If
            End If
        End If
        If bSecurityVorhanden = False Then
            If Not fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sRegSecurityPath) = True Then
                fbSecurity_aendern = False
            End If
        End If
    Case Else
        MsgBox sMSG_CASEELSE & vbCr & "(fbSecurity_aendern)" _
            , vbExclamation, sTITEL_INSTALLIEREN
            fbSecurity_aendern = False
            Exit Function
    End Select
    
    If fbSecurity_aendern = False Then
        MsgBox sMSG_SICHERHEITSWERTNICHTAENDERBAR, vbExclamation, sTITEL_INSTALLIEREN
    End If

End Function

Function fbAnzahlInstanzen_ermitteln(sTaskName As String) As Integer
    'Die Funktion ermittel, wie viele Instranzen des Programms aus sTaskname laufen.
    'Global:
    '   Application.Tasks wird gelesen
    '   Application.Name wird gelesen
    'Rckgabewert:
    '   Anzahl der laufenden Instanzen.
    
    Dim oEinTask As Object
    Dim iFehlerNummer As Integer
    Dim bGeisterTask As Boolean
    
    fbAnzahlInstanzen_ermitteln = 0
    For Each oEinTask In Application.Tasks
        If UCase(Left(oEinTask.Name, Len(sTaskName))) = UCase(sTaskName) Or UCase(Right(oEinTask.Name, Len(sTaskName))) = UCase(sTaskName) Then
            'Patch fr Microsoft Excel 2000 (= Version 9.0) und Windows 2000 (= Version 5.0)
            bGeisterTask = False
            'If sTaskName = sTASKNAME_EXCEL _
            'And Val(oEinTask.Application.Version) = 9 _
            'And LCase(System.OperatingSystem) = "windows nt" _
            'And Left(System.Version, 3) = "5.0" Then
            If sTaskName = sTASKNAME_EXCEL Then
                'Hier gibt es unter Windows 2000 / Office 2000 und Windows 98 /Office 2002
                'einen Fehler:
                'Auch eine Excel-Instanz, die schon aus dem Speicher entfernt wurde,
                'wird hier angezeigt. Dass es eine "Geister-Task" ist, findet man heraus,
                'indem man zustzlich abfragt, ob die Task gltig ist.!
                'Die Abfrage IsObjectValid(oEinTask) allein reicht nicht aus. Die Geister-Task wird
                'als Tasks erkannt, die Funktion IsObjectValid(oEinTask) liefert True, ausser, man
                'zeigt zuvor eine MsgBox an (!!!) oder aktiviert die Task. Nur dann merkt VBA, dass
                'die Task nicht existiert und - oh Wunder - IsObjectValid(oEinTask) meldet False.
                'Siehe fbExcel_installieren
                'Der Fehler ist unter Windows 2000 und Office 2000 reproduzierbar.
                'Er tritt in der Kombination Windows NT / Office 2000 nicht auf.
                'Da unsicher ist, ob er in anderen Windows- / Office-Kombinationen auch auftritt,
                'wird der Patch generell fr Excel aktiviert.
                'Beta-Version 2.42: Die Auswirkungen von oEinTask.Activate mssen noch getestet
                'werden.
                On Error Resume Next
                oEinTask.Activate
                Application.Activate
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    bGeisterTask = True
                End If
            End If
            If IsObjectValid(oEinTask) = True _
            And bGeisterTask = False Then
                fbAnzahlInstanzen_ermitteln = fbAnzahlInstanzen_ermitteln + 1
            End If
        End If
    Next oEinTask
End Function

'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Sub ERZEUGEN()
    'Dummy-Prozedur fr GLOB_Prozeduren
End Sub

Function fbVorlageAnpassen(bDummy As Boolean) As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageAnpassen = True
End Function

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

'===================================================================================================
'Ende.
'===================================================================================================
