Attribute VB_Name = "INST_Registry"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   REG_Prozeduren
' Effekt:
'   Das Modul enthlt alle Zugriffe auf die Registry
'       Siehe HOWTO: Use the Registry API to Save and Retrieve Setting (Q145679)
'           in 'http://support.microsoft.com/default.aspx?scid=kb;EN-US;q145679
'       Siehe auch Support.dot in Microsoft Office\OfficeXX\Macros
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   17.07.2002 J.W.Schmitz-Hbsch erstellt

'Const REG_NONE = 0
Public Const REG_SZ As Long = 1
Public Const REG_EXPAND_SZ = 2
Public Const REG_BINARY = 3
Public Const REG_DWORD As Long = 4
'Const REG_DWORD_LITTLE_ENDIAN = 4
'Const REG_DWORD_BIG_ENDIAN = 5
'Const REG_LINK = 6
'Const REG_MULTI_SZ = 7

Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Public Const WITH_RETURN_NULL = True
Public Const NEVER_RETURN_NULL = False

Private Const REG_BINARY_LAENGE = 1
Private Const REG_DWORD_LAENGE = 4

Private Const ERROR_NONE = 0
Private Const ERROR_BADDB = 1
Private Const ERROR_BADKEY = 2
Private Const ERROR_CANTOPEN = 3
Private Const ERROR_CANTREAD = 4
Private Const ERROR_CANTWRITE = 5
Private Const ERROR_OUTOFMEMORY = 6
Private Const ERROR_ARENA_TRASHED = 7
Private Const ERROR_ACCESS_DENIED = 8
Private Const ERROR_INVALID_PARAMETERS = 87
Private Const ERROR_NO_MORE_ITEMS = 259

Private Const KEY_QUERY_VALUE = &H1
Private Const KEY_SET_VALUE = &H2
Private Const KEY_ALL_ACCESS = &H3F

Private Const REG_OPTION_NON_VOLATILE = 0

Public Type FILETIME
   dwLowDateTime As Long
   dwHighDateTime As Long
End Type

Private Declare Function RegCloseKey Lib "advapi32.dll" ( _
    ByVal hKey As Long) _
    As Long
Private Declare Function RegCreateKeyEx Lib "advapi32.dll" Alias "RegCreateKeyExA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal Reserved As Long, _
    ByVal lpClass As String, _
    ByVal dwOptions As Long, _
    ByVal samDesired As Long, _
    ByVal lpSecurityAttributes As Long, _
    phkResult As Long, _
    lpdwDisposition As Long) _
    As Long
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" Alias "RegOpenKeyExA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String, _
    ByVal ulOptions As Long, _
    ByVal samDesired As Long, _
    phkResult As Long) _
    As Long
Private Declare Function RegQueryValueExString Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As String, _
    lpcbData As Long) _
    As Long
Private Declare Function RegQueryValueExLong Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    lpData As Long, _
    lpcbData As Long) _
    As Long
Private Declare Function RegQueryValueExNULL Lib "advapi32.dll" Alias "RegQueryValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Long, _
    lpcbData As Long) _
    As Long

Private Declare Function RegEnumValue Lib "advapi32.dll" Alias "RegEnumValueA" _
    (ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpValueName As String, _
    lpcbValueName As Long, _
    ByVal lpReserved As Long, _
    lpType As Long, _
    ByVal lpData As Any, _
    lpcbData As Long) _
    As Long

 Private Declare Function RegEnumKeyEx Lib "advapi32.dll" Alias "RegEnumKeyExA" _
    (ByVal hKey As Long, _
    ByVal dwIndex As Long, _
    ByVal lpName As String, _
    lpcbName As Long, _
    ByVal lpReserved As Long, _
    ByVal lpClass As Long, _
    lpcbClass As Long, _
    lpftLastWriteTime As FILETIME) _
    As Long

 'unbenutzt
 Private Declare Function RegGetNumberOfSubKeys Lib "advapi32.dll" Alias "RegQueryValueA" _
    (ByVal hKey As Long, _
    ByVal lpClass As Long, _
    ByVal lpcbClass As Long, _
    ByVal lpReserved As Long, _
    lpcSubKeys As Long, _
    lpcbMaxSubKeyLen As Long, _
    ByVal lpcbMaxClassLen As Long, _
    ByVal lpcValues As Long, _
    ByVal lpcbMaxValueNameLen As Long, _
    lpcbMaxValueLen As Long, _
    ByVal lpcbSecurityDescriptor As Long, _
    ByVal lpftLastWriteTime As Long) _
    As Long

Private Declare Function RegSetValueExString Lib "advapi32.dll" Alias "RegSetValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    ByVal lpValue As String, _
    ByVal cbData As Long) _
    As Long
Private Declare Function RegSetValueExLong Lib "advapi32.dll" Alias "RegSetValueExA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String, _
    ByVal Reserved As Long, _
    ByVal dwType As Long, _
    lpValue As Long, _
    ByVal cbData As Long) _
    As Long
Private Declare Function RegDeleteKey Lib "advapi32.dll" Alias "RegDeleteKeyA" ( _
    ByVal hKey As Long, _
    ByVal lpSubKey As String) _
    As Long
Private Declare Function RegDeleteValue Lib "advapi32.dll" Alias "RegDeleteValueA" ( _
    ByVal hKey As Long, _
    ByVal lpValueName As String) _
    As Long
Private Declare Function ExpandEnvironmentStrings Lib "kernel32" Alias "ExpandEnvironmentStringsA" ( _
   ByVal lpSrc As String, _
   ByVal lpDst As String, _
   ByVal nSize As Long) _
   As Long
         
Sub Test()

Call fbEinTest("", REG_SZ)
Call fbEinTest("X", REG_SZ)
Call fbEinTest("X X", REG_SZ)
Call fbEinTest("X  X", REG_SZ)
Call fbEinTest("XX", REG_SZ)

Call fbEinTest("&HFFFFFFFF", REG_DWORD)
Call fbEinTest("&H00000000", REG_DWORD)
Call fbEinTest("&H0000FFFF", REG_DWORD)
Call fbEinTest("&HFFFF0000", REG_DWORD)
Call fbEinTest("&H00FF00FF", REG_DWORD)
Call fbEinTest("&HFF00FF00", REG_DWORD)
Call fbEinTest("&HF0F0F0F0", REG_DWORD)
Call fbEinTest("&H0F0F0F0F", REG_DWORD)
Call fbEinTest("&H0", REG_DWORD)
Call fbEinTest("&HF", REG_DWORD)
Call fbEinTest("&HFF", REG_DWORD)
Call fbEinTest("&HFFF", REG_DWORD)
Call fbEinTest("&HFFFF", REG_DWORD)
Call fbEinTest("&HFFFFF", REG_DWORD)
Call fbEinTest("&HFFFFFF", REG_DWORD)
Call fbEinTest("&HFFFFFFF", REG_DWORD)
Call fbEinTest("&HFFFFFFFF", REG_DWORD)
Call fbEinTest("&HF", REG_DWORD)
Call fbEinTest("&H0F0F0F0F", REG_DWORD)
Call fbEinTest(0, REG_DWORD)
Call fbEinTest(1, REG_DWORD)
Call fbEinTest(2147483647, REG_DWORD)

Call fbEinTest("&H0", REG_BINARY)
Call fbEinTest("&H00", REG_BINARY)
Call fbEinTest("&HF", REG_BINARY)
Call fbEinTest("&HFF", REG_BINARY)
Call fbEinTest("&H0F", REG_BINARY)
Call fbEinTest("&HF0", REG_BINARY)
Call fbEinTest(0, REG_BINARY)
Call fbEinTest(255, REG_BINARY)

End Sub

Function fbEinTest(vWert As Variant, lType As Long) As Boolean
    Dim bErgebnisfbRegistry_WertSetzen As Boolean
    Dim vErgebnisfvRegistry_WertLesen As Variant
    Dim bErgebnisfbRegistry_WertLoeschen As Boolean
    Dim bErgebnisfbRegistry_PfadPruefen As Boolean
    Dim bErgebnisfbRegistry_PfadLoeschen As Boolean
    Dim dErgebnisfvRegistry_WertLesen, dWert As Double
    Dim bOK As Boolean
    Dim sderPfad As String
    Dim sDerWert As String
    
    sderPfad = "Gs4WORDTEST\MICROSOFT\OFFICE\8.0\POWERPOINT\ADDINS\GS4WORD_224GER"
    sDerWert = "REG_" & lType
    bErgebnisfbRegistry_WertSetzen = fbRegistry_WertSetzen(HKEY_CURRENT_USER, sderPfad, sDerWert, vWert, lType)
    If bErgebnisfbRegistry_WertSetzen = True Then
        vErgebnisfvRegistry_WertLesen = fvRegistry_WertLesen(HKEY_CURRENT_USER, sderPfad, sDerWert)
        dErgebnisfvRegistry_WertLesen = vErgebnisfvRegistry_WertLesen
        If lType = REG_SZ Then
            If vErgebnisfvRegistry_WertLesen = vWert Then
                bOK = True
            Else
                bOK = False
            End If
        Else
            dWert = vWert
            If dErgebnisfvRegistry_WertLesen = dWert Then
                bOK = True
            Else
                bOK = False
            End If
        End If
        
        If bOK = True Then
            bErgebnisfbRegistry_WertLoeschen = fbRegistry_WertLoeschen(HKEY_CURRENT_USER, sderPfad, sDerWert)
            If bErgebnisfbRegistry_WertLoeschen = True Then
                bErgebnisfbRegistry_PfadPruefen = fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sderPfad)
                If bErgebnisfbRegistry_PfadPruefen = True Then
                    bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, sderPfad)
                    If bErgebnisfbRegistry_PfadLoeschen = True Then
                        bErgebnisfbRegistry_PfadPruefen = fbRegistry_PfadPruefen(HKEY_CURRENT_USER, sderPfad)
                        If bErgebnisfbRegistry_PfadPruefen = False Then
                            bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, "TEST\MICROSOFT\OFFICE\8.0\POWERPOINT\ADDINS")
                            bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, "TEST\MICROSOFT\OFFICE\8.0\POWERPOINT")
                            bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, "TEST\MICROSOFT\OFFICE\8.0")
                            bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, "TEST\MICROSOFT\OFFICE")
                            bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, "TEST\MICROSOFT")
                            bErgebnisfbRegistry_PfadLoeschen = fbRegistry_PfadLoeschen(HKEY_CURRENT_USER, "TEST")

                             fbEinTest = True
                            Exit Function
                        End If
                    End If
                End If
            End If
        End If
    End If
    MsgBox "Fehler bei Test " & lType & " mit Wert " & vWert _
        & vbCr & "fbRegistry_WertSetzen = " & bErgebnisfbRegistry_WertSetzen _
        & vbCr & "fvRegistry_WertLesen = " & vErgebnisfvRegistry_WertLesen _
        & vbCr & "fbRegistry_WertLoeschen = " & bErgebnisfbRegistry_WertLoeschen
End Function

Public Function fbRegistry_WertSetzen(lKeyName As Long, sPfadName As String, sWertName As String, ByVal vWert As Variant, lWertType As Long) As Boolean
' Alle Werte <= 2147483647 knnen als Zahl oder Hex-Wert angegeben werden.
' Alle Werte >  2147483647 mssen als Hex-Wert angegeben werden.
    Dim lHandleNr As Long ' Handlenummer
    Dim lReturnCode As Long
    Dim sSzWert As String
    
    lReturnCode = RegCreateKeyEx(lKeyName, sPfadName, 0, vbNullString, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, 0&, lHandleNr, lReturnCode)
    If lReturnCode = ERROR_NONE Then
       Select Case lWertType
            Case REG_SZ
                sSzWert = vWert & Chr$(0)
                lReturnCode = RegSetValueExString(lHandleNr, sWertName, 0&, lWertType, vWert, Len(sSzWert))
            Case REG_DWORD
                lReturnCode = RegSetValueExLong(lHandleNr, sWertName, 0&, lWertType, vWert, REG_DWORD_LAENGE)
            Case REG_BINARY
                lReturnCode = RegSetValueExLong(lHandleNr, sWertName, 0&, lWertType, CByte(vWert), REG_BINARY_LAENGE)
            Case Else
                lReturnCode = ERROR_INVALID_PARAMETERS
        End Select
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fbRegistry_WertSetzen = True
    Else
        fbRegistry_WertSetzen = False
    End If
End Function

Public Function fvRegistry_WertLesen(lKeyName As Long, sPfadName As String, sWertName As String, _
Optional bNullReturn As Boolean = True) As Variant
    Dim lHandleNr As Long
    Dim sSzWert As String
    Dim lSzWertLaenge As Long
    Dim lReturnCode As Long
    Dim lWertType As Long
    Dim sEinHexByte As String
    Dim sWert As String
    Dim iZaehler As Integer
    
    Dim sExpEnvOutput As String
    Dim lExpEnvOutputLaenge As Long
    Dim lExpEnvReturnCode As Long
       
    lReturnCode = RegOpenKeyEx(lKeyName, sPfadName, 0, KEY_QUERY_VALUE, lHandleNr)
    If lReturnCode = ERROR_NONE Then
    
        lReturnCode = RegQueryValueExNULL(lHandleNr, sWertName, 0&, lWertType, 0&, lSzWertLaenge)
        If lReturnCode = ERROR_NONE Then

            Select Case lWertType
                Case REG_SZ
                    sSzWert = String(lSzWertLaenge, 0)
                    lReturnCode = RegQueryValueExString(lHandleNr, sWertName, 0&, lWertType, sSzWert, lSzWertLaenge)
                    If lReturnCode = ERROR_NONE Then
                        sWert = Left$(sSzWert, lSzWertLaenge - 1)
                    End If
                Case REG_EXPAND_SZ
                    sSzWert = String(lSzWertLaenge, 0)
                    lReturnCode = RegQueryValueExString(lHandleNr, sWertName, 0&, lWertType, sSzWert, lSzWertLaenge)
                    If lReturnCode = ERROR_NONE Then
                        'Erforderliche Lnge fr das Ergebnis errechnen
                        sExpEnvOutput = ""
                        lExpEnvOutputLaenge = 1
                        lExpEnvReturnCode = ExpandEnvironmentStrings(sSzWert, sExpEnvOutput, lExpEnvOutputLaenge)
                        'Jetzt Wert ermitteln
                        sExpEnvOutput = Space(lExpEnvReturnCode)
                        lExpEnvOutputLaenge = lExpEnvReturnCode
                        lExpEnvReturnCode = ExpandEnvironmentStrings(sSzWert, sExpEnvOutput, lExpEnvOutputLaenge)
                        If lExpEnvReturnCode = 0 Then
                            lReturnCode = ERROR_BADKEY
                        Else
                            sWert = Left(sExpEnvOutput, lExpEnvReturnCode - 1)
                        End If
                    End If
                Case REG_DWORD
                    'Der normale Basic-Code ist:
                    '   lReturnCode = RegQueryValueExLong(lHandleNr, sWertName, 0&, lWertType, lDwWert, lDwWertLaenge)
                    '   If lReturnCode = ERROR_NONE Then sWert = lDwWert
                    ' Die folgende Idee habe ich von Ade Miller (Summit Software Company) und Nate Woods (Summit Software Company)
                    ' http://msdn.microsoft.com/code/default.asp?url=/msdn-files/026/000/006/Clients/Common/abtform_frm.asp
                    ' Dort bercksichtigt der Code nicht, dass Hex(Asc("&H0x") in VBA zu "x" und nicht zu "0x" umgesetzt wird
                    ' Dort wird der Basic-Code auch flschlicherweise auch fr REG_SZ verwendet.
                    lSzWertLaenge = REG_DWORD_LAENGE
                    sSzWert = String(lSzWertLaenge, 0)
                    lReturnCode = RegQueryValueExString(lHandleNr, sWertName, 0&, lWertType, sSzWert, lSzWertLaenge)
                    If lReturnCode = ERROR_NONE Then
                        For iZaehler = Len(sSzWert) To 1 Step -1
                            sEinHexByte = Hex(Asc(Mid(sSzWert, iZaehler, 1)))
                            Select Case Len(sEinHexByte)
                            Case 0
                                sWert = sWert & "00"
                            Case 1
                                sWert = sWert & "0" & sEinHexByte
                            Case Else
                                sWert = sWert & sEinHexByte
                            End Select
                        Next
                        sWert = "&H" & sWert
                    End If
                Case REG_BINARY
                    lSzWertLaenge = REG_BINARY_LAENGE
                    sSzWert = String(lSzWertLaenge, 0)
                    lReturnCode = RegQueryValueExString(lHandleNr, sWertName, 0&, lWertType, sSzWert, lSzWertLaenge)
                    If lReturnCode = ERROR_NONE Then
                        For iZaehler = Len(sSzWert) To 1 Step -1
                            sEinHexByte = Hex(Asc(Mid(sSzWert, iZaehler, 1)))
                            Select Case Len(sEinHexByte)
                            Case 0
                                sWert = sWert & "00"
                            Case 1
                                sWert = sWert & "0" & sEinHexByte
                            Case Else
                                sWert = sWert & sEinHexByte
                            End Select
                        Next
                        sWert = "&H" & sWert
                    End If
                Case Else
                    lReturnCode = ERROR_INVALID_PARAMETERS
            End Select
        End If
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fvRegistry_WertLesen = sWert
    Else
        If bNullReturn = True Then
            fvRegistry_WertLesen = Null
        Else
            fvRegistry_WertLesen = sLEER
        End If
    End If
    
End Function

Public Function fvRegistry_WertNummerLesen(lKeyName As Long, sPfadName As String, _
lWertNummer As Long, Optional bNullReturn As Boolean = True) As Variant
    'lWertNummer beginnt bei 0
    Dim lHandleNr As Long
    Dim lReturnCode As Long
    Dim sWertName As String
    Dim lWertNameLaenge As Long
    Dim lSzWertLaenge As Long 'wird nicht ausgewertet
    Dim lWertType As Long 'wird nicht ausgewertet
    
    lReturnCode = RegOpenKeyEx(lKeyName, sPfadName, 0, KEY_QUERY_VALUE, lHandleNr)
    If lReturnCode = ERROR_NONE Then
       
        lWertNameLaenge = 2000
        sWertName = String(lWertNameLaenge, 0)
        lReturnCode = RegEnumValue(lHandleNr, lWertNummer, sWertName, lWertNameLaenge, 0&, lWertType, 0&, lSzWertLaenge)
        If lReturnCode = ERROR_NONE Then
            
            sWertName = Left(sWertName, lWertNameLaenge)
        
        End If
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fvRegistry_WertNummerLesen = sWertName
    Else
        If bNullReturn = True Then
            fvRegistry_WertNummerLesen = Null
        Else
            fvRegistry_WertNummerLesen = sLEER
        End If
    End If
    
End Function

Function fbRegistry_WertLoeschen(lKeyName As Long, sPfadName As String, sWertName As String) As Boolean
    Dim lHandleNr As Long
    Dim lReturnCode As Long
       
    lReturnCode = RegOpenKeyEx(lKeyName, sPfadName, 0, KEY_ALL_ACCESS, lHandleNr)
    If lReturnCode = ERROR_NONE Then
        lReturnCode = RegDeleteValue(lHandleNr, sWertName)
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fbRegistry_WertLoeschen = True
    Else
        fbRegistry_WertLoeschen = False
    End If
End Function

Public Function fvRegistry_SubPfadNummerLesen(lKeyName As Long, sSubPfadName As String, _
lSubPfadNummer As Long, Optional bNullReturn As Boolean = True) As Variant
    'lSubPfadNummer beginnt bei 0
    Dim lHandleNr As Long
    Dim lReturnCode As Long
    Dim sRestPfadName As String
    Dim lRestPfadNameLaenge As Long
    Dim ft As FILETIME
    
    lReturnCode = RegOpenKeyEx(lKeyName, sSubPfadName, 0, KEY_ALL_ACCESS, lHandleNr)
    If lReturnCode = ERROR_NONE Then
       
        lRestPfadNameLaenge = 2000
        sRestPfadName = String(lRestPfadNameLaenge, 0)
        lReturnCode = RegEnumKeyEx(lHandleNr, lSubPfadNummer, sRestPfadName, lRestPfadNameLaenge, 0, 0, 0, ft)
        If lReturnCode = ERROR_NONE Then
            
            sRestPfadName = Left(sRestPfadName, lRestPfadNameLaenge)
        End If
    End If
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fvRegistry_SubPfadNummerLesen = sRestPfadName
    Else
        If bNullReturn = True Then
            fvRegistry_SubPfadNummerLesen = Null
        Else
            fvRegistry_SubPfadNummerLesen = sLEER
        End If
    End If
    
End Function

Function fbRegistry_PfadPruefen(lKeyName As Long, sPfadName As String) As Boolean
    'Die Funktion prft den letzten Teil des Pfades
    
    Dim lHandleNr As Long
    Dim lReturnCode As Long
       
    lReturnCode = RegOpenKeyEx(lKeyName, sPfadName, 0, KEY_QUERY_VALUE, lHandleNr)
    RegCloseKey (lHandleNr)
    
    If lReturnCode = ERROR_NONE Then
        fbRegistry_PfadPruefen = True
    Else
        fbRegistry_PfadPruefen = False
    End If
End Function
Function fbRegistry_PfadLoeschen(lKeyName As Long, sPfadName As String) As Boolean
'   Die Funktion lscht den letzten Teil des Pfades
    Dim lReturnCode As Long
       
    lReturnCode = RegDeleteKey(lKeyName, sPfadName)
    
    If lReturnCode = ERROR_NONE Then
        fbRegistry_PfadLoeschen = True
    Else
        fbRegistry_PfadLoeschen = False
    End If
End Function

