Attribute VB_Name = "KONF_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt :
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   KONF_AddIn
' Effekt:
'   Das Modul konfiguriert Gs4Word
' Restriktionen:
'   Das Modul mit sprachabhngigen Texten KONF_sss muss vorhanden sein. Dabei ist sss die Sprache.
'   Die UserForm KONF_UserForm muss vorhanden sein. Die Module TECH_Modul, TECH_sss, GLOB_AddIn und
'   GLOB_sss mssen vorhanden sein.
'   Dieses Add-In darf nicht schreibgeschtzt sein. Es muss "Gs4WordKonfiguration_vvvsss.dot"
'   heissen. vvv ist die Versionsnummer und sss die Sprache.
'   Der genaue Name steht in der ThisDocument.Name.
' Entwicklung und Test:
'   Siehe Modul DOC_Erzeugen
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   19.07.2002  Komplett umgebaut
'   25.08.2002  Erweitert fr Version 2.41

' Die Eintrge in der Registry sind in GLOB_AddIn beschrieben (siehe dort)

'===================================================================================================
'Deklarationen
'===================================================================================================
    
' Die folgenden Variablen werden fr den Konfigurationsdialog bentigt
'---------------------------------------------------------------------
Public gbVorlageIstAenderbar As Boolean

Sub WordKonfigurierenVorlageNichtAendern()
    'Die Prozedur liest die Word-Konfiguration des Add-In aus der Registry, bietet sie in einem
    'Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Da die Vorlage nicht gendert werden darf, mssen im Dialog die als Button oder Menpunkt
    'angezeigten Felder zur nderung gesperrt werden.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:
    
    Call fbKonfiguration_aendern(sTASKNAME_WORD, False)
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - WordKonfigurierenVorlageNichtAendern" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub WordKonfigurierenVorlageIstAenderbar()
    'Die Prozedur liest die Word-Konfiguration des Add-In aus der Registry, bietet sie in einem
    'Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Da die Vorlage gendert werden darf, drfen im Dialog die als Button oder Menpunkt
    'angezeigten Felder verndert werden.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:
    
    Call fbKonfiguration_aendern(sTASKNAME_WORD, True)
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - WordKonfigurierenVorlageIstAenderbar" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub ExcelKonfigurieren()
    'Die Prozedur liest die Excel-Konfiguration des Add-In aus der Registry, bietet sie in einem
    'Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:
    
    Call fbKonfiguration_aendern(sTASKNAME_EXCEL, True)
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - ExcelKonfigurieren" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub PowerpointKonfigurieren()
    'Die Prozedur liest die Powerpoint-Konfiguration des Add-In aus der Registry, bietet sie in
    'einem Dialog zur nderung an und schreibt die genderte Konfiguration wieder in die Registry.
    'Effekt
    '   Der Dialog zur Konfiguration des Add-In wurde angezeigt.
    '   Ggf. wurde die Registry verndert.
    
    On Error GoTo Fehler_aufgetreten:
    
    Call fbKonfiguration_aendern(sTASKNAME_POWERPOINT, True)
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - PowerpointKonfigurieren" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER

End Sub

'===================================================================================================
'Alle Private Funktionen und Subroutinen, die nur in KONF_Prozeduren verwendet werden.
'===================================================================================================

Private Function fbKonfiguration_aendern(sTaskName As String, bVorlageIstAenderbar As Boolean) As Boolean
    'Die Funktion zeigt die UserForm fr die Konfiguration an.
    'Die genderten Werte werden in den globalen Variablen gespeichert.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_AddIn entsprechen.
    '   bVorlageIstAenderbar Nur wenn das Flag gesetzt ist, wird auch gbButtonFlag und gsMailToSwitch
    '       mit den Defaultwerten belegt
    'Global:
    '   giDialogEffekt wird gesetzt
    '   g*-Variable werden ggf. gendert
    'Rckgabewert:
    '   False = Die nderung der Konfiguration wurde abgebrochen
    '   True = Die Konfiguration wurde gendert
    'Effekt
            
    ' (1) Vorlauf
    '------------
    Call fbKonfiguration_ausRegistryFuellen(sTaskName)
    
    Do While True
    
        ' (2) UserForm anzeigen
        '----------------------
        gsTaskName = sTaskName
        gbVorlageIstAenderbar = bVorlageIstAenderbar
        KONF_UserForm.Show
        
        ' (3) Nachlauf
        '-------------
        Select Case giDialogEffekt
        Case False ' Abbrechen
            'Konfiguration wiederherstellen
            Call fbKonfiguration_lesen(sTaskName)
            Exit Do
        Case True ' OK
            'Zuerst die aktuelle Konfiguration lschen
            Call fbKonfiguration_loeschen(sTaskName)
            'Dann die Konfiguration neu in die Registry schreiben
            Call fbKonfiguration_schreiben(sTaskName)
            Exit Do
        Case -2
            'Die Defaults verwenden
            Call fbKonfiguration_mitTechnikDefaultsBelegen
            Call fbKonfiguration_mitAnwendungsDefaultsBelegen(sTaskName, bVorlageIstAenderbar)
        Case Else
            MsgBox sMSG_CASEELSE _
                & vbCr & "(Konfigurieren)" _
                , vbExclamation, sTITEL_ERZEUGEN
            Error 51
            Exit Do
        End Select
    Loop
End Function

'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Sub ERZEUGEN()
    'Dummy-Prozedur fr GLOB_Prozeduren

End Sub

Function fbVorlageAnpassen(bDummy As Boolean) As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageAnpassen = True
End Function

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

'===================================================================================================
'Ende.
'===================================================================================================


