Attribute VB_Name = "MAKE_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   MAKE_Prozeduren
' Effekt:
'   Das Modul erzeugt alle Add-Ins fr Gs4Word.
'
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten MAKE_sss muss vorhanden sein. Dabei ist sss die
'   Sprache.
'   Unter Word 9.0 und 10.0 muss die Sicherheitsstufe niedrig oder Mittel sein, damit dieses
'   Add-In ausgefhrt werden kann.
'   Dieses Add-In wird nicht automatisch erzeugt
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   14.08.2002 J.W.Schmitz-Hbsch erstellt

'===================================================================================================
'Deklarationen
'===================================================================================================

' Allgemeine Konstante
'---------------------
Public Const sLEER As String = ""
Public Const sSPACE As String = " "
Public Const sPDF As String = ".pdf"
Public Const sPS As String = ".ps"

'===================================================================================================
'Prozeduren
'===================================================================================================
Sub ADDINSERZEUGEN()

    On Error GoTo Fehler_aufgetreten:
        
    Const sINSTALLATIONSMACRO = "INST_Prozeduren.ALLEADDINSERZEUGEN"
    Const sINSTALLATIONSADDIN = "Installation.dot"
    
    Dim iFehlerNummer As Integer
    Dim sInstallationsProgrammNameOriginal As String
    Dim sInstallationsProgrammNameTemp As String
    Dim oWord As Object
    
    sInstallationsProgrammNameOriginal = _
        ThisDocument.Path & Application.PathSeparator & sINSTALLATIONSADDIN
    sInstallationsProgrammNameTemp = _
        ThisDocument.Path & Application.PathSeparator & "Tmp_" & sINSTALLATIONSADDIN
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox sMSG_KEINEVERBINDUNGZUWORD, vbExclamation, sTITEL_MAKE
        Exit Sub
    End If
    
    'Installations-Add-In kopieren, damit das Original neu erzeugt werden kann.
    On Error Resume Next
    FileCopy sInstallationsProgrammNameOriginal, sInstallationsProgrammNameTemp
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If Not iFehlerNummer = 0 Then
        MsgBox sMSG_KDATEIKANNNICHTKOPIERTWERDEN _
            & vbCr & "(" & sInstallationsProgrammNameOriginal & ")" _
            , vbExclamation, sTITEL_MAKE
        Exit Sub
    End If
    
    'Temporres Installations-Add-In laden
    On Error Resume Next
    oWord.AddIns.Add FileName:=sInstallationsProgrammNameTemp, Install:=True
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer <> 0 Then
        MsgBox sMSG_INSTALLATIONSADDINFEHLT _
            & vbCr & "(" & sInstallationsProgrammNameTemp & ")" _
            , vbExclamation, sTITEL_MAKE
    Else
        'Installations-Add-In ausfhren
        
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht
        'eingreifen, falls das Erzeugen des Add-In nicht funktioniert.
        'oWord.Visible = True
        'oWord.WindowState = wdWindowStateMinimize
        
        On Error Resume Next
        oWord.Run MacroName:=sINSTALLATIONSMACRO
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer <> 0 Then
            MsgBox sMSG_INSTALLATIONSMAKROFEHLT _
                & vbCr & "(" & sInstallationsProgrammNameTemp _
                & " - " & sINSTALLATIONSMACRO & ")" _
                , vbExclamation, sTITEL_MAKE
        Else
            'Installations-Add-In entladen
            On Error Resume Next
            oWord.AddIns(sInstallationsProgrammNameTemp).Delete
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_INSTALLATIONSMAKROSCHLIESSEN _
                    & vbCr & "(" & sInstallationsProgrammNameTemp & ")" _
                    , vbExclamation, sTITEL_MAKE
            End If
        End If
    End If
    
    'Word beenden
    oWord.Quit
    Set oWord = Nothing
    
    'Wenn das Installations-Add-In fehlt, muss das temporre Add-In wieder zurckkopiert werden
    If Dir(sInstallationsProgrammNameOriginal, vbNormal) = sLEER Then
        On Error Resume Next
        FileCopy sInstallationsProgrammNameTemp, sInstallationsProgrammNameOriginal
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If Not iFehlerNummer = 0 Then
            MsgBox sMSG_TDATEIKANNNICHTKOPIERTWERDEN _
                & vbCr & "(" & sInstallationsProgrammNameOriginal & ")" _
                , vbExclamation, sTITEL_MAKE
            Exit Sub
        End If
    Else
        'Wenn ein Installations-Add-In vorhanden ist, kann das temporre Add-In gelscht werden
        Kill sInstallationsProgrammNameTemp
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & "Fehler # " & Str(Err.Number) & sSPACE & Err.Description _
        & vbCr & "in " & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - ADDINSERZEUGEN" _
        , vbExclamation, sTITEL_FEHLER

End Sub

Sub MAKEADDINERZEUGEN()
    'Mit dieser Funktion erzeuge ich dieses (!) Add-In unter einem anderen Namen.
 
    On Error GoTo Fehler_aufgetreten:
        
    Const sADDIN_NAME As String = "Gs4Word" 'Name des Add-Ins fr die Symbolleiste
    Const sVORLAGE_ACTION_ALLEADDINSERZEUGEN As String = "MAKE_Prozeduren.ADDINSERZEUGEN"
    Const sVORLAGE_ACTION_DIESESADDINSERZEUGEN As String = "MAKE_Prozeduren.MAKEADDINERZEUGEN"
    Const sVORLAGE_NAME_ALLEADDINSERZEUGEN As String = "Alle Add-Ins erzeugen"
    Const sVORLAGE_NAME_DIESESADDINSERZEUGEN As String = "Dieses Add-In erzeugen"
    
    Dim oWord As Object
    Dim oControl As Object
    Dim iFehlerNummer As Integer
    Dim vEineDatei As Variant
    Dim sDateien(1) As String
    Dim sMakeAddIn As String
    Dim sSourcePfad As String
    Dim sInstVerzeichnis As String
    Dim bStatus As Boolean
    
    'Namen aller Sourcen des Add-In eintragen
    sDateien(0) = "MAKE_Prozeduren.bas"
    sDateien(1) = "MAKE_ger.bas"
    
    'Name des neuen Make-Add-In
    sInstVerzeichnis = ThisDocument.Path & Application.PathSeparator
    sSourcePfad = ThisDocument.Path & Application.PathSeparator & "Sourcen" & Application.PathSeparator
    sMakeAddIn = ThisDocument.Name
       
    For Each vEineDatei In sDateien
        If Dir(sSourcePfad & vEineDatei, vbNormal) = sLEER Then
            MsgBox sMSG_SOURCEFEHLT _
                & vbCr & "(" & sSourcePfad & vEineDatei & ")" _
                , vbExclamation, sTITEL_MAKE
            Exit Sub
        End If
    Next vEineDatei
    
    Do While LCase(sMakeAddIn) = LCase(ThisDocument.Name)
        sMakeAddIn = InputBox(sMSG_INPUT, sTITEL_MAKE, ThisDocument.Name)
    Loop
    If sMakeAddIn = sLEER Then
        Exit Sub
    End If
    
    'Beginnen wir die Sache mal optimistisch
    bStatus = True
    
    'Word-Instanz erzeugen
    On Error Resume Next ' wenn der folgende Befehl misslingt, ist oWord Nothing
    Set oWord = CreateObject("Word.Application") 'Erzeugt einen neue Instanz von Word
    On Error GoTo 0
    If oWord Is Nothing Then
        MsgBox "sMSG_KEINEWEITEREVERBINDUNGZUWORD", vbExclamation, sTITEL_MAKE
        bStatus = False
    End If
    
    If bStatus = True Then
    
        'Word Applikation minimiert anzeigen, bei False sieht man nichts und kann nicht eingreifen,
        'falls das Erzeugen des Add-In nicht funktioniert.
        oWord.Visible = True
        oWord.WindowState = wdWindowStateMinimize
        
        'Dann wird das neue Add-In leer angelegt
        oWord.Documents.Add NewTemplate:=True
        
        'Add-In speichern
        oWord.ActiveDocument.SaveAs _
            FileName:=sInstVerzeichnis & sMakeAddIn, _
            FileFormat:=wdFormatTemplate
            
        'Alle Sourcen in das Add-In laden
        For Each vEineDatei In sDateien
            If vEineDatei <> "" Then
                On Error Resume Next
                oWord.ActiveDocument.VBProject.vbcomponents.Import (sSourcePfad & vEineDatei)
                iFehlerNummer = Err.Number
                On Error GoTo 0
                If iFehlerNummer <> 0 Then
                    MsgBox sMSG_MAKESOURCENICHTLADBAR, vbExclamation, sTITEL_MAKE
                    bStatus = False
                    Exit For
                End If
            End If
        Next vEineDatei
        
        If bStatus = True Then
            
            'Neues Menu einfgen
            oWord.CommandBars.Add(Name:=sADDIN_NAME, Position:=msoBarTop).Visible = True
            Set oControl = oWord.CommandBars(sADDIN_NAME).Controls.Add(Type:=msoControlButton, ID:=1, _
                Before:=1, temporary:=False)
            With oControl
                .FaceId = 2144
                .Caption = sVORLAGE_NAME_DIESESADDINSERZEUGEN
                .Style = msoButtonIconAndCaption
                .OnAction = sVORLAGE_ACTION_DIESESADDINSERZEUGEN
                .Enabled = True
                .Visible = True
                .BeginGroup = True
            End With
            
            Set oControl = oWord.CommandBars(sADDIN_NAME).Controls.Add(Type:=msoControlButton, ID:=1, _
                Before:=1, temporary:=False)
            With oControl
                .FaceId = 2144
                .Caption = sVORLAGE_NAME_ALLEADDINSERZEUGEN
                .Style = msoButtonIconAndCaption
                .OnAction = sVORLAGE_ACTION_ALLEADDINSERZEUGEN
                .Enabled = True
                .Visible = True
                .BeginGroup = True
            End With
            
            ' Text einfgen
            With oWord.Selection
                .Font.Bold = True
                .TypeText Text:="Erzeugen der Add-Ins fr Gs4Word"
                .Font.Bold = False
                .TypeParagraph
                .TypeParagraph
                .TypeText Text:="Unterhalb der Menzeile finden Sie eine neue Leiste mit zwei " _
                    & "Buttons:"
                .TypeParagraph
                .TypeParagraph
                .TypeText Text:="Mit dem Button "
                .Font.Bold = True
                .TypeText Text:=sVORLAGE_NAME_ALLEADDINSERZEUGEN
                .Font.Bold = False
                .TypeText Text:=".erstellen Sie das Installations-Add-In und alle Add-Ins fr " _
                    & "Word, Excel und Powerpoint neu. " _
                    & "Verwenden Sie diesen Button nur, wenn Sie die Sourcen der Add-Ins " _
                    & "verndern wollen. Bis die erste Meldung erscheint, kann es etwas dauern, " _
                    & "denn zuvor muss das Installations-Add-In geladen werden."
                .TypeParagraph
                .TypeText Text:="Der Button "
                .Font.Bold = True
                .TypeText Text:=sVORLAGE_NAME_DIESESADDINSERZEUGEN
                .Font.Bold = False
                .TypeText Text:=" erzeugt dieses Make-Add-In unter einem anderen Namen neu."
                .TypeParagraph
            End With
        End If
        
        If bStatus = True Then
        
            'Add-In noch mal speichern
            'Ohne dieses zustzliche Speichern als Template funktioniert bei Office97 die Prozedur
            'AutoExec im erzeugten Add-In nicht, wenn die unvernderte Source verwendet wird. Wurde
            'die Source zuvor mit fbSourceOhneKommentar_erzeugen verndert, gibt es keine Probleme.
            'Die Source ohne Kommentare unterscheidet sich von der Originalsource durch ihre
            'fehlerhafte Formatierung. Die Einrckungen am Zeilenanfang fehlen.
            oWord.ActiveDocument.SaveAs _
                FileName:=sInstVerzeichnis & sMakeAddIn, _
                FileFormat:=wdFormatTemplate
        
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdSaveChanges
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer <> 0 Then
                MsgBox sMSG_MAKEADDINNICHTERZEUGT, vbExclamation, sTITEL_MAKE
                bStatus = False
            Else
                MsgBox sMAKEADDINERZEUGT _
                    & vbCr & "(" & sInstVerzeichnis & sMakeAddIn & ")" _
                    , vbInformation, sTITEL_MAKE
                bStatus = True
            End If
        Else
            On Error Resume Next
            oWord.ActiveDocument.Close SaveChanges:=wdDoNotSaveChanges
            On Error GoTo 0
        End If
        
        oWord.Quit SaveChanges:=wdDoNotSaveChanges
        Set oWord = Nothing
    End If
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & "Fehler # " & Str(Err.Number) & sSPACE & Err.Description _
        & vbCr & "in " & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisDocument.Name & " - MAKEADDINERZEUGEN" _
        , vbExclamation, sTITEL_FEHLER

End Sub


