Attribute VB_Name = "PPT_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   PPT_Prozeduren
' Effekt beim Start von Powerpoint:
'   Das Modul erstellt in dieser Vorlage beim Aufruf von Powerpoint ...
'       1. in der aktiven Menleiste ein Men "PDF".
'       2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration
'       vorgesehen ist.
' Effekt beim Aufruf von PDF > Erzeugen:
'   Das Modul erstellt aus der aktuellen Powerpoint-Prsentation eine PDF-Datei. Dazu erzeugt es
'   eine gleichnamige Postscript-Datei mit der Endung .ps und eine gleichnamige PDF-Datei mit der
'   Endung .pdf. Die Postscript-Datei wird wieder gelscht.
' Effekt beim Aufruf von "PDF > Info":
'   Das Modul zeigt Informationen ber sich an.
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten PPT_sss muss vorhanden sein. Dabei ist sss die
'   Sprache. Die Module GLOB_Prozeduren und GLOB_sss und die UserForm GLOB_UserForm mssen vorhanden
'   sein.
'   Dieses Add-In darf nicht schreibgeschtzt sein. Es muss "Gs4Wordxxx_vvvsss.dot" heissen.
'   Dabei ist xxx ein beliebiger, optionaler Zusatz ohne Unterstrich "_". vvv ist die Versionsnummer
'   und sss die Sprache.
'   Der genaue Name kann nur mit For Each cbEinAddin In AddIns ermittelt werden.
' Entwicklung und Test:
'   siehe Dokumentation
'   Damit man Powerpoint-AddIns in VBA sieht, muss der Registry-Eintrag
'   HKEY_CURRENT_USER\Software\Microsoft\Office\8.0\PowerPoint\Options\DebugAddins
'   als DWORD existieren und den Wert 1 haben. Der Defaultwert ist 0.
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   06.01.2002 J.W.Schmitz-Hbsch erstellt
'   10.01.2002 Je nach Ansicht unterschiedliche PDF-Dateien erzeugen
'   16.02.2002 umbenannt in PPT_Erzeugen
'   27.04.2002 Erweitert um .ViewType 9 bis 12 fr Powerpoint 2002
'   04.05.2002 Ungespeicherte Prsentationen mssen in Powerpoint 2002 besonders behandelt werden.
'   09.05.2002 Erweitert um Lschen der PS-Datei wenn gbPSDateiLoeschenFlag gesetzt ist
'   09.05.2002 Nur fr eine Folie eine PDF-Datei erzeugen, wenn gbEinTeilobjektFlag gesetzt ist
'   18.05.2002 Auf UserForm umgestellt , Parametersteuerung je AddIn
'   19.07.2002 Komplett umgebaut fr Version 2.40
'   28.08.2002 Erweitert fr Version 2.41

'===================================================================================================
' Portierung von Word nach Excel und Powerpoint
'===================================================================================================
' Kommentare:
'   Word -> Excel -> Powerpoint
'   Word-Dokument -> Excel-Arbeitsmappe -> Powerpoint-Prsentation
'   Dokument -> Arbeitsmappe -> Prsentation
' Schlselworte:
'   Documents.Count -> Workbooks.Count -> Presentations.Count
'   ActiveDocument -> ActiveWorkbook -> ActivePresentation
'   ThisDocument -> ThisWorkbook -> For Each cbEinAddin In AddIns
'   ActivePrinter -> ActivePrinter -> ActivePresentation.PrintOptions.ActivePrinter

'===================================================================================================
'Deklarationen
'===================================================================================================

' Die folgenden Konstanen steuern die Verarbeitung in der Prozedur fbVorlageAnpassen
'-----------------------------------------------------------------------------------
Private Const sVORLAGE_ACTION_ERZEUGEN As String = "PPT_Prozeduren.ERZEUGEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const sVORLAGE_ACTION_INFO As String = "PPT_Prozeduren.INFO"
    'Modul- und Prozedurname fr die Anzeige der Informationen ber das Add-In.
Private Const sVORLAGE_ACTION_KONFIGURIEREN As String = "GLOB_Prozeduren.KONFIGURIEREN"
    'Modul- und Prozedurname fr das Konfigurieren des Add-In.
Private Const sVORLAGE_ACTION_DOKUMENTATION As String = "GLOB_Prozeduren.DOKUMENTATION"
    'Modul- und Prozedurname fr die Anzeige der Dokumentation des Add-In.
Private Const sVORLAGE_ACTION_MAILTO As String = "GLOB_Prozeduren.MAIL"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const lVORLAGE_BUTTON_FACEID As Long = 2144
    'Symbol-ID fr den PDF-Button: 481=Herz, 276=Trauriger Smilie, 2144 = Zahnrder
Private Const lVORLAGE_BUTTON_BEFOREID As Long = 21
    'ID eines Buttons in der Symboleiste Standard. Vor diesem Button wird der PDF-Button eingefgt.
    '2520=Neu, 23=ffnen, 3 = Speichern, 2521=Drucken, 109=Seitenansicht, 2566=Rechtscheibung und
    'Grammatik, 21=Ausschneiden,, ..., 984=Hilfe
    'Wenn die Nummer ungltig oder 0 ist, wird der PDF-Button vor den letzten Button eingefgt.

' Die folgende Konstane steuert die Verarbeitung in der Prozedur Info
'--------------------------------------------------------------------
Private Const sADDIN_NAME As String = "Gs4Word"
    ' Name des Add-Ins

'===================================================================================================
'Vorlage anpassen beim Start von Powerpoint
'===================================================================================================
    
Sub Auto_Open()

    On Error GoTo Fehler_aufgetreten:
    
    Call fbVorlageAnpassen(False)

    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & "Gs4Word - fbVorlageAnpassen" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER
End Sub

Function fbVorlageAnpassen(bUnbedingtSpeichernFlag As Boolean) As Boolean
    'Die Prozedur erstellt in dieser Vorlage beim Aufruf ...
    '    1. in der aktiven Menleiste ein Men "PDF".
    '    2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration
    '       vorgesehen ist.
    'Wenn all das schon richtig eingestellt war, und bUnbedingterUpdateFlag = False ist, dann
    'geschieht nichts.
    'Argumente:
    '   bUnbedingterUpdateFlag
    '       Thrue = Die Vorlage wird unbedingt gespeichert.
    '       False = Die Vorlage wird nur dann gespeichert, wenn das Menue oder die Buttons verndert
    '               wurde.
    'Rckgabewert:
    '   True = das Men und ggf. die Symbolleiste "Standard" wurden angepasst.
    'Effekt
    '   ggf. wurde Menleiste und ggf. Symbolleiste verndert.
    
    Const sVORLAGE_TAG As String = "Gs4WordPPT20011230"
        'Identifikation der PDF-Mens und -Buttons. Dieser Tag-String darf nie gendert werden.
    
    Dim cbAktiveMenueLeiste As CommandBar
    Dim cbEinControl As CommandBarControl
    Dim cbEinButton As CommandBarButton
    Dim iPosition As Integer
    Dim iZaehler As Integer
    Dim lAnzahlPDFMenues As Long
    Dim lAnzahlPDFButtons As Long
    
    ' (1) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_POWERPOINT)
        'um gbButtonFlag zu fllen. Die Konfiguration muss nicht in der Registry stehen.
        
    ' (2) CustomizationContext setzen
    '--------------------------------
    ' Entfllt in Powerpoint

    Set cbAktiveMenueLeiste = CommandBars.ActiveMenuBar
    
    ' (3) Prfen, ob Menu oder Button verndert werden muss
    '------------------------------------------------------
    'Prfen ob das PDF-Men schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Mens vorhanden sind!
    lAnzahlPDFMenues = 0
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'ein PDF-Menu gefunden
            lAnzahlPDFMenues = lAnzahlPDFMenues + 1
        End If
    Next cbEinControl
    
    'Prfen ob der PDF-Button schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Buttons vorhanden sind!
    lAnzahlPDFButtons = 0
    For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'einen PDF-Button gefunden
            lAnzahlPDFButtons = lAnzahlPDFButtons + 1
        End If
    Next cbEinControl
    
    'Fertig wenn nicht unbedingt gespeichert werden muss und das PDF-Men schon vorhanden ist und
    'der PDF-Button richtig an oder aus ist.
    If bUnbedingtSpeichernFlag = False _
    And lAnzahlPDFMenues = 1 _
    And ((gbButtonFlag = False And lAnzahlPDFButtons = 0) _
    Or (gbButtonFlag = True And lAnzahlPDFButtons = 1)) Then
        Exit Function 'Sollzustand erreicht -> fertig
    End If
    'Es kann nur dann weitergehen, wenn die Vorlage nicht schreibgeschtzt ist.
    ' Entfllt in Powerpoint
    
    ' (4) Aktive Menleiste um das PDF-Men erweitern
    '------------------------------------------------
    'Alle ggf. vorhandenen PDF-Mens lschen
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then
            cbEinControl.Delete
        End If
    Next cbEinControl
   
    'Men "PDF" einfgen
    Set cbEinControl = cbAktiveMenueLeiste.Controls.Add(Type:=msoControlPopup, _
        Before:=cbAktiveMenueLeiste.Controls.Count, Temporary:=True)
    With cbEinControl
        .Caption = sVORLAGE_MENU_CAPTION
        .Tag = sVORLAGE_TAG
    End With

    'Befehl "Erzeugen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_ERZEUGEN_CAPTION
        .OnAction = sVORLAGE_ACTION_ERZEUGEN
    End With
    
    'Befehl "Mailen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_MAILTO_CAPTION
        .OnAction = sVORLAGE_ACTION_MAILTO
        If gsMailToSwitch = sMAILTOSWITCH_AUS Then
            .Enabled = False
        End If
    End With
    
    'Befehl "Konfigurieren" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_KONFIGURIEREN_CAPTION
        .OnAction = sVORLAGE_ACTION_KONFIGURIEREN
    End With
        
    'Befehl "Dokumentation" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_DOKUMENTATION_CAPTION
        .OnAction = sVORLAGE_ACTION_DOKUMENTATION
        If gsDokuAufruf = sLEER Then
            .Enabled = False
        End If
    End With
        
    'Befehl "Info" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_INFO_CAPTION
        .OnAction = sVORLAGE_ACTION_INFO
    End With
        
    ' (5) Symbolleiste "Standard" um den PDF-Button erweitern
    '--------------------------------------------------------
    If lAnzahlPDFButtons > 0 Then
        'Alle vorhandenen PDF-Buttons lschen
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            If cbEinControl.Tag = sVORLAGE_TAG Then
                cbEinControl.Delete
            End If
        Next cbEinControl
    End If
    
    If gbButtonFlag = True Then
        'Einen PDF-Button einfgen.
        'Zuerst nach der Position des Buttons suchen, vor dem der PDF-Button stehen soll
        iZaehler = 0
        iPosition = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Count
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            iZaehler = iZaehler + 1
            If cbEinControl.Id = lVORLAGE_BUTTON_BEFOREID Then
                iPosition = iZaehler
                Exit For
            End If
        Next cbEinControl
        Set cbEinControl = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Add(Type:=msoControlButton, _
        Id:=1, Before:=iPosition, Temporary:=True)
        With cbEinControl
            .FaceId = lVORLAGE_BUTTON_FACEID
            '.BeginGroup = True 'wanns scheee maacht
            .Caption = sVORLAGE_BUTTON_CAPTION
            .Style = msoButtonAutomatic
            .Tag = sVORLAGE_TAG
            .TooltipText = sVORLAGE_BUTTON_TOOLTIPTEXT
            .OnAction = sVORLAGE_ACTION_ERZEUGEN
        End With
    End If
    
    ' (6) Vorlage speichern
    '----------------------
    ' Entfllt in Powerpoint
    
    fbVorlageAnpassen = True
        
End Function
    
'===================================================================================================
'Men "PDF > Info"
'===================================================================================================
Sub INFO()
    'Die Prozedur zeigt eine Box mit Informationen ber das Add-In an.
    'Effekt
    '   Die Info-Box wurde angezeigt.
    
    Dim cbEinAddin As AddIn
    Dim sAddInFullName As String
    Dim sAddInName As String
    
    For Each cbEinAddin In AddIns
        If UCase(Left(cbEinAddin.Name, Len(sADDIN_NAME))) = UCase(sADDIN_NAME) Then
            sAddInName = cbEinAddin.Name
            sAddInFullName = cbEinAddin.FullName
        End If
    Next cbEinAddin

    Call fbInfo_anzeigen(sAddInFullName)
    
End Sub
    
'===================================================================================================
'Men "PDF > Erzeugen..."
'===================================================================================================

Sub ERZEUGEN()
Attribute ERZEUGEN.VB_Description = "pdf"
Attribute ERZEUGEN.VB_ProcData.VB_Invoke_Func = "p\n14"
    'Effekt
    '   Ggf. wurden ein oder zwei Dialoge gefhrt oder eine Fehlermeldung angezeigt.
    '   Ggf. wurde eine Postscript-Datei gelscht.
    '   Ggf. wurde  eine PDF-Datei erzeugt.
    On Error GoTo Fehler_aufgetreten:
 
    Dim sPDFDateiName As String 'Name der PDF-Datei mit absolutem Pfad
    Dim sPSDateiName As String 'Name der Postscript-Datei mit absolutem Pfad

    gsMailtoDateiName = sLEER
    
    ' (1) Office-Datei prfen
    '------------------------
    If fbOfficeDatei_gespeichert() = False Then
       Exit Sub
    End If
       
    ' (2) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_POWERPOINT) 'Dabei auch gsAusgabeMedienListe() fllen
    If fbKonfiguration_testen(sTASKNAME_POWERPOINT) = False Then
        MsgBox sMSG_KONFIGUNVOLLSTAENDIG, vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
    
    ' (3) Name der Postscript- und PDF-Datei ermitteln
    '-------------------------------------------------
    gsBasisDateiName = fsBasisDateiName_ermitteln(gsSymbDateiName)
    If gsBasisDateiName = "" Then
        Exit Sub
    End If
                    
    ' (4) Einstellungen_waehlen
    '--------------------------
    If fbEinstellungen_waehlen(sTASKNAME_POWERPOINT) = False Then
        Exit Sub
    End If
     
    ' (5) In diesem Verzeichnis die alte Postscript- und PDF-Dateien lschen, wenn vorhanden
    '---------------------------------------------------------------------------------------
    sPSDateiName = gsBasisDateiName & sPS
    sPDFDateiName = gsBasisDateiName & sPDF
    If fbDatei_pruefen_loeschen(sPSDateiName) = False Then
        Exit Sub
    End If
    If fbDatei_pruefen_loeschen(sPDFDateiName) = False Then
        Exit Sub
    End If
    
    ' (6) Postscript-Datei erzeugen
    '------------------------------
    If fbPSDatei_erzeugen(ActivePresentation.FullName, sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (7) Postscript-Datei ergaenzen
    '-------------------------------
    If fbPSDatei_ergaenzen(sPSDateiName) = False Then
        Exit Sub
    End If
    
    
    ' (8) PDF-Datei erzeugen
    '-----------------------
    If fbPDFDatei_erzeugen(sPSDateiName, sPDFDateiName, gsAusgabeMedium) = False Then
        Exit Sub
    End If
    
    ' (9) Postscript-Datei wieder lschen
    '------------------------------------
    If gbPSDateiLoeschenFlag Then
        If fbDatei_loeschen(sPSDateiName) = False Then
            Exit Sub
        End If
    End If
    
    ' (10) PDF-Datei anzeigen
    '------------------------
    Call fbPDFDatei_anzeigen(sPDFDateiName)
    
    ' (11) PDF-Datei zum mailen merken
    '---------------------------------
    gsMailtoDateiName = sPDFDateiName
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & "Gs4Word - ERZEUGEN" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER
    
End Sub

'===================================================================================================
'Alle Private Funktionen und Subroutinen, die nur von der Subroutine ERZEUGEN verwendet werden.
'===================================================================================================

Private Function fbOfficeDatei_gespeichert() As Boolean
    'Die Funktion prft, ob eine Office-Datei geffnet ist und ob es jemals gespeichert wurde.
    'Global:
    '   ActivePresentation.Path
    '   ActivePresentation.Name
    '   Presentations.Count
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   False = Office-Datei ist nicht gespeichert
    '   True = Office-Datei ist gespeichert und hat eine Pfad
    'Effekt
    '   Ggf. wurde eine Fehlermeldung angezeigt.
    
    fbOfficeDatei_gespeichert = False
    
    If Presentations.Count < 1 Then  'Es ist keine Office-Datei geffnet
        MsgBox sMSG_KEINEOFFICEDATEI, vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
    
    Dim sName As String 'Name des aktiven Office-Dokuments ohne Pfad und mit Extension
    
     If flLetztesVorkommen_suchen(ActivePresentation.FullName, ActivePresentation.Name) = 0 Then
        'Besonderheit nur in Powerpoint 2002:
        'Bei einer nicht gespeicherten Prsentation steht in Powerpoint 2002 in Application.Name
        'schon der Inhalt des Prsentationstitels. Wenn dieser nicht in ActivePresentation.FullName
        'vorkommt, ist die Prsentation nicht gespeichert.
        sName = ""
    Else
        'Besonderheit in Powerpoint:
        'Wenn eine Prsentation durch Doppenklick im Windows-Explorer geffnet wird, enthlt
        'ActivePresentation.Name kein ".ppt". Nur in ActivePresentation.FullName steht ".ppt".
        'Eine neue Prsentation enthlt einen Namen ohne "." am Ende des Namens aber keine Pfad.
        'Deshalb wird der Dateiname extra ermittelt
        sName = Mid(ActivePresentation.FullName, _
            flLetztesVorkommen_suchen(ActivePresentation.FullName, ActivePresentation.Name))
    End If
    
    If ActivePresentation.Name = "" _
    Or ActivePresentation.Path = "" _
    Or sName = "" _
    Or flLetztesVorkommen_suchen(sName, ".") <= 0 Then
        'Die geffnete Office-Datei ist nicht gespeichert
        MsgBox sMSG_OFFICEDATEINICHTGESPEICHERT _
            & vbCr & "(" & CurDir & gsPathSeparator & sName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
    
    fbOfficeDatei_gespeichert = True

End Function

Private Function fbEinstellungen_waehlen(sTaskName As String) As Boolean
    'Die Funktion zeigt die UserForm fr die nderbaren Einstellungen an.
    'Die genderten Werte werden in den globalen Variablen gespeichert.
    'Falls der BasisDateiName verndert wurde, wird er neu erzeugt und geprft.
    'Argumente:
    '   sTaskName ist der Taskname. Der Wert muss einer der Konstanten sTASKNAME_XXXX aus PDF_Global
    '   entsprechen.
    'Global:
    '   gbDialogFlag wird gelesen
    '   gsPrintSwitch wird ggf. verndert
    '   gstypeSwitch wird ggf. verndert
    '   gsAusgabeMedium wird ggf. verndert
    '   gsBasisDateiName wird ggf. verndert
    '   giDialogEffekt wird gesetzt
    'Rckgabewert:
    '   False = Die Auswahl der Einstellungen wurde abgebrochen oder der genderte BasisDateiName
    '           ist fehlerhaft
    '   True = Die Einstellungen wurden ausgewhlt
    'Effekt
    
    If gbDialogFlag = True Then 'Einstellungen im Dialog ndern
        GLOB_UserForm.Show
        fbEinstellungen_waehlen = giDialogEffekt
        
        If giDialogEffekt = True Then
            gsBasisDateiName = fsBasisDateiName_ermitteln(gsBasisDateiName)
            If gsBasisDateiName = sLEER Then 'genderter BasisDateiName ist fehlerhaft
                fbEinstellungen_waehlen = False
            End If
        End If
    Else
        fbEinstellungen_waehlen = True
    End If

End Function

Private Function fbPSDatei_erzeugen(sOfficeDateiName As String, sPSDateiName As String) As Boolean
    'Erzeugt aus sOfficeDateiName die Postscriptdatei sPSDateiName. Wenn das nicht mglich ist, wird
    'eine Meldung angezeigt.
    'PrintOptions gibt es nur in Powerpoint
    'Argumente:
    '   sOfficeDateiName = Dateiname der aktiven Office-Datei
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Global:
    '   gsPrintSwitch wird gelesen
    '   gsTypeSwitch wird gelesen
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht erzeugt werden.
    '   True = Postscript-Datei sPSDateiName wurde erzeugt.
    'Effekt
    '   Entweder wurde eine Postscript-Datei erzeugt
    '   oder eine Fehlermeldung angezeigt.
    
    Dim bPSDateiLocked As Boolean
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePresentation.PrintOptions.ActivePrinter
    
    Dim iOutputType As Integer 'Ausgabetype beim Drucken
    Dim iRangeType As Integer 'Bereichstype beim Drucken
    Dim bFrameSlides As Boolean 'Rahmen beim Drucken
    Dim vRangeType As Variant
    Dim vNumberOfCopies As Variant
    Dim vCollate As Variant
    Dim vOutputType As Variant
    Dim vPrintHiddenSlides As Variant
    Dim vPrintColorType As Variant
    Dim vFitToPage As Variant
    Dim vFrameSlides As Variant
    Dim vActivePrinter As Variant
    Dim vPrintInBackground As Variant
    Dim vPSRangeType As Variant
    
    Select Case gsTypeSwitch
    Case sTYPESWITCH_POWERPOINT_AKTIV 'As String = "Aktuelle Komponente"
        Select Case fiGib_AktuellenViewtype
        Case 1  ' = ppViewSlide = Folien
            iOutputType = ppPrintOutputSlides 'Folien = 1
            bFrameSlides = msoTrue  'mit Rahmen
        Case 3  ' = ppViewNotesPage = Notizen
            iOutputType = ppPrintOutputNotesPages 'Notizseiten = 5
            bFrameSlides = msoFalse 'ohne Rahmen
        Case 6  ' = ppViewOutline = Gliederung
            iOutputType = ppPrintOutputOutline 'Gliederungsansicht = 6
            bFrameSlides = msoFalse 'ohne Rahmen
        Case 7  ' = ppViewSlideSorter = Foliensortierung oder = ppViewThumbnails
                ' = Miniaturansicht nur in Powerpoint 2002
            iOutputType = ppPrintOutputSixSlideHandouts 'Handzettel (6 Folien je Seite)= 4
            bFrameSlides = msoTrue  'mit Rahmen
        Case Else
            MsgBox sMSG_PPANSICHTNICHTVERWENDBAR, vbExclamation, sTITEL_ERZEUGEN
            fbPSDatei_erzeugen = False
            Exit Function
        End Select
    Case sTYPESWITCH_POWERPOINT_FOLIEN ' = "Folien"
            iOutputType = ppPrintOutputSlides 'Folien = 1
            bFrameSlides = msoTrue  'mit Rahmen
    Case sTYPESWITCH_POWERPOINT_HANDZETTEL2 ' = "Handzettel (2 Folien je Seite)"
            iOutputType = ppPrintOutputTwoSlideHandouts 'Handzettel (6 Folien je Seite)= 4
            bFrameSlides = msoTrue  'mit Rahmen
    Case sTYPESWITCH_POWERPOINT_HANDZETTEL3 ' = "Handzettel (3 Folien je Seite)"
            iOutputType = ppPrintOutputThreeSlideHandouts 'Handzettel (6 Folien je Seite)= 4
            bFrameSlides = msoTrue  'mit Rahmen
    Case sTYPESWITCH_POWERPOINT_HANDZETTEL6 ' = "Handzettel (6 Folien je Seite)"
            iOutputType = ppPrintOutputSixSlideHandouts 'Handzettel (6 Folien je Seite)= 4
            bFrameSlides = msoTrue  'mit Rahmen
    Case sTYPESWITCH_POWERPOINT_NOTIZEN ' = "Notizseiten"
            iOutputType = ppPrintOutputNotesPages 'Notizseiten = 5
            bFrameSlides = msoFalse 'ohne Rahmen
    Case sTYPESWITCH_POWERPOINT_GLIEDERUNG ' = "Gliederungsansicht"
            iOutputType = ppPrintOutputOutline 'Gliederungsansicht = 6
            bFrameSlides = msoFalse 'ohne Rahmen
    Case Else
        MsgBox sMSG_TYPESWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End Select
    
    Select Case gsPrintSwitch
    Case sPRINTSWITCH_POWERPOINT_PRAESENTATION 'Die ganze Prsentation ausgeben
        iRangeType = ppPrintAll
    Case sPRINTSWITCH_POWERPOINT_FOLIE 'Nur die aktuelle Folie ausgeben
        iRangeType = ppPrintCurrent
    Case sPRINTSWITCH_POWERPOINT_FOLIENAUSWAHL ' Nur markierte Folien ausgeben
        If Windows(1).Selection.Type = ppSelectionSlides Then
            iRangeType = ppPrintSelection
        Else
            iRangeType = ppPrintCurrent
        End If
    Case Else
        MsgBox sMSG_PRINTSWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End Select
    
    'Drucker-Einstellungen merken
    '   ActivePresentation.PrintOptions.OutputType =
    '       Alle Werte in Office 97:
    '          .OutputType = ppPrintOutputSlides 'Folien = 1
    '          .OutputType = ppPrintOutputTwoSlideHandouts 'Handzettel (2 Folien je Seite) = 2
    '          .OutputType = ppPrintOutputThreeSlideHandouts 'Handzettel (3 Folien je Seite) = 3
    '          .OutputType = ppPrintOutputSixSlideHandouts 'Handzettel (6 Folien je Seite)= 4
    '          .OutputType = ppPrintOutputNotesPages 'Notizseiten = 5
    '          .OutputType = ppPrintOutputOutline 'Gliederungsansicht = 6
    '          .OutputType = ppPrintOutputBuildSlides 'Folien = 7 (wie 1)
    '   ActivePresentation.PrintOptions.FrameSlides =
    '       Alle Werte:
    '          .FrameSlides = msoFalse 'ohne Rahmen
    '          .FrameSlides = msoTrue  'mit Rahmen
    
    With ActivePresentation.PrintOptions
        vActivePrinter = .ActivePrinter
        vCollate = .Collate
        vFitToPage = .FitToPage
        vFrameSlides = .FrameSlides
        vNumberOfCopies = .NumberOfCopies
        vOutputType = .OutputType
        vPrintColorType = .PrintColorType
        vPrintHiddenSlides = .PrintHiddenSlides
        vPrintInBackground = .PrintInBackground
        vRangeType = .RangeType
    End With
       
    If fbActivePrinterAuf_gsDruckerName_setzen() = False Then
        MsgBox sMSG_PSDRUCKERUNBEKANNT _
            & vbCr & "(" & gsPSDruckerName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End If

    'Jetzt drucken. Durch PrintInBackground = msoFalse wird in Powerpoint erzwungen, dass das Add-In
    'erst dann weiterluft, wenn die Postscript-Datei vollstndig erzeugt wurde.
    With ActivePresentation.PrintOptions
        '.ActivePrinter = wurde schon in fbActivePrinterAuf_gsDruckerName_setzen gesetzt
        .Collate = msoTrue
        .FitToPage = msoFalse
        .FrameSlides = bFrameSlides
        .NumberOfCopies = 1
        .OutputType = iOutputType
        .PrintColorType = ppPrintColor
        .PrintHiddenSlides = msoFalse
        .PrintInBackground = msoFalse
        .RangeType = iRangeType
    End With
    ActivePresentation.PrintOut , PrintToFile:=sPSDateiName
            
    'In Word und Powerpoint ist im Druckdialog der Schalter "Ausgabe in Datei umleiten" jetzt
    'angeschaltet (auch wenn wieder der Standard-Drucker aktiviert wurde). Er kann in Powerpoint
    'nicht abgeschaltet werden.
    
    'Drucker-Einstellungen wieder herstellen
    With ActivePresentation.PrintOptions
        .ActivePrinter = vActivePrinter
        .Collate = vCollate
        .FitToPage = vFitToPage
        .FrameSlides = vFrameSlides
        .NumberOfCopies = vNumberOfCopies
        .OutputType = vOutputType
        .PrintColorType = vPrintColorType
        .PrintHiddenSlides = vPrintHiddenSlides
        .PrintInBackground = vPrintInBackground
        .RangeType = vRangeType
    End With
       
    If Dir(sPSDateiName, vbNormal) <> sLEER Then
        'Dir liefert den ersten gefundenden Dateinamen oder sLEER
        If FileLen(sPSDateiName) > 0 Then
            'Die PS-Datei muss auch einen Inhalt haben
            fbPSDatei_erzeugen = True
            Exit Function
        End If
    End If
    
    'Ab hier nur noch Fehlerhandling
    If InStr(sPSDateiName, ",") > 0 Then
        MsgBox sMSG_PSDATEIMITKOMMA _
            & vbCr & "(" & gsPSDruckerName & ") - (" & sPSDateiName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    Else
        MsgBox sMSG_PSDATEINICHTERZEUGT _
            & vbCr & "(" & gsPSDruckerName & ") - (" & sPSDateiName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    End If
    
End Function

Private Function fbPSDatei_ergaenzen(sPSDateiName As String) As Boolean
    'Die Funktion ergnzt die Postscriptdatei sPSDateiName um Dokumenteigenschaften und Lesezeichen
    'Global:
    '   gbPdfmarkFlag wird gelesen
    'Argumente:
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    'Effekt
    '   Ggf. wurde eine Postscript-Datei verndert
    '   oder eine Fehlermeldung angezeigt.
    
    Dim sAuthor As String
    Dim sCreationDate As String
    Dim sCreator As String
    Dim sTitle As String
    Dim sSubject As String
    Dim sKeywords As String
    Dim sModDate As String
    Dim lTablesOfContents As Long
    Dim bUeberschriften As Boolean
    Dim sPageHeight As Single
    Dim sPageWidth As Single
    
    If gbPdfmarkFlag = False Then 'Keine pdfmarks verwenden
        fbPSDatei_ergaenzen = True
        Exit Function
    End If
    
    On Error Resume Next ' falls ein Element nicht definiert ist
    sAuthor = ActivePresentation.BuiltinDocumentProperties("Author")
    sCreationDate = Format(ActivePresentation.BuiltinDocumentProperties("Creation date"), "yyyymmDdhhnnss")
    sCreator = ActivePresentation.BuiltinDocumentProperties("Application name")
    sTitle = ActivePresentation.BuiltinDocumentProperties("Title")
    sSubject = ActivePresentation.BuiltinDocumentProperties("Subject")
    sKeywords = ActivePresentation.BuiltinDocumentProperties("Keywords")
    sModDate = Format(ActivePresentation.BuiltinDocumentProperties("Last save time"), "yyyymmDdhhnnss")
    lTablesOfContents = 0
    bUeberschriften = False
    sPageHeight = ActivePresentation.PageSetup.SlideHeight
    sPageWidth = ActivePresentation.PageSetup.SlideWidth
    On Error GoTo 0
        
    fbPSDatei_ergaenzen = fbPSDateiPdfmark_ergaenzen(sPSDateiName, _
    sAuthor, sCreationDate, sCreator, sTitle, _
    sSubject, sKeywords, sModDate, lTablesOfContents, bUeberschriften, _
    sPageHeight, sPageWidth)
    
End Function

Function fbActivePrinterAuf_gsDruckerName_setzen() As Boolean
    'Die Funktion setzt ActivePresentation.PrintOptions.ActivePrinter auf gsDruckerName.
    'In VBA fr Powerpoint muss dabei nicht der Port angegeben werden.
    'Im Gegensatz zu Word und Excel funktioniert ActivePrinter = gsPSDruckerName nicht
    'Global:
    '   gsPSDruckerName wird gelesen
    'Rckgabewert:
    '   True = Der Drucker aus gsDruckerName ist der ActivePrinter.
    '   False = Der Drucker aus gsDruckerName konnte nicht zum ActivePrinter
    '           gemacht werden. Der ActivePronter ist unverndert.
    'Effekt
    '   ActivePrinter verndert
    
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    
    On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (ist reproduzierbar!)
    ActivePresentation.PrintOptions.ActivePrinter = gsPSDruckerName
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then
        fbActivePrinterAuf_gsDruckerName_setzen = True
    Else
        fbActivePrinterAuf_gsDruckerName_setzen = False
    End If

End Function

Private Function fiGib_AktuellenViewtype() As Integer
    'Die Funktion ermittelt den aktuellen Viewtype in Powerpoint
    'Argumente: keine
    'Global:
    '   Application.ActiveWindow.ViewType =
    '       Nur wenn im Men Ansicht eine Folie, die Notizen, die Gliederung oder die
    '       Foliensortierung angezeigt wird, kann in fbPSDatei_erzeugen die PS-Datei mit einem
    '       passenden Output-Type erzeugt werden.
    '       Alle Werte in Office 97:
    '          .ViewType = ppViewSlide 'Folien = 1
    '          .ViewType = ppViewSlideMaster 'Folien-Master = 2
    '          .ViewType = ppViewNotesPage 'Notizen = 3
    '          .ViewType = ppViewHandoutMaster 'Handzettel-Master = 4
    '          .ViewType = ppViewNotesMaster 'Notizen-Master = 5
    '          .ViewType = ppViewOutline 'Gliederung = 6
    '          .ViewType = ppViewSlideSorter 'Foliensortierung = 7
    '          .ViewType = ppViewTitleMaster 'Titel-Master = 8
    '       Weitere Werte in Powerpoint 2002:
    '                      Diese Konstanten drfen nicht in den anderen Office-Versionen verwendet
    '                       werden.
    '          .ViewType = ppViewNormal 'Normalansicht = 9
    '                      Dabei steht der wirkliche ViewType in
    '                      Application.ActiveWindow.ActivePane.ViewType
    '          .ViewType = ppViewPreview 'Seitenansicht = 10
    '          .ViewType = ppViewThumbnails 'Miniaturansicht = 11
    '          .ViewType = ppViewMasterThumbnails 'Miniaturansicht-Master = 12
    'Rckgabewert:
    '   ViewType
    '       1 = ppViewSlide = Folien
    '       3 = ppViewNotesPage = Notizen
    '       6 = ppViewOutline = Gliederung
    '       7 = ppViewSlideSorter = Foliensortierung
    '       7 = ppViewThumbnails = Miniaturansicht nur in Powerpoint 2002
    '       0 = alles anderen Werte (siehe oben)
    'Effekt: keiner
    
    Dim iAktuellerViewType As Integer

    If Application.ActiveWindow.ViewType = 9 Then ' ppViewNormal aus Powerpoint 2002
        iAktuellerViewType = Application.ActiveWindow.ActivePane.ViewType
        'Hier kann 1, 3, 6 und 11 vorkommen
        'Die Bescheibung in Microsoft Knowledge Base Artikel D285436 ist falsch!. Die aktuelle
        'Ansicht wird nicht mit Application.ActiveWindow.Panes.Item(2).ViewType sondern mit
        'Application.ActiveWindow.ActivePane.ViewType angezeigt.
    Else
        iAktuellerViewType = Application.ActiveWindow.ViewType
    End If
    
    Select Case iAktuellerViewType
    Case 1, 3, 6, 7
        fiGib_AktuellenViewtype = iAktuellerViewType
    Case Else
         fiGib_AktuellenViewtype = 0
    End Select
       
End Function

'===================================================================================================
'Alle Funktionen und Subroutinen, die von der Subroutine ERZEUGEN
'und von ComboBoxEinTeilobjektFlag_Change verwendet werden.
'===================================================================================================

Function fsBasisDateiName_ermitteln(sSymbDateiName As String) As String
    'Die Funktion ermittelt aus sSymbDateiName den BasisDateinamen mit Pfad fr die PS- und
    'PDF-Datei.
    'Argumente
    '   sSymbDateiName = Symbolischer Dateiname
    'Global:
    '   ActivePresentation.Path = Pfad des aktiven Office-Dokuments
    '   ActivePresentation.Name = Dateiname des aktiven Office-Dokuments
    '   gsPathSeparator wird gelesen
    '   gsPrintSwitch wird gelesen
    '   gsTypeSwitch wird gelesen
    'Rckgabewert:
    '   "" = Es konnte kein Dateiname erzeugt werden
    '   "xxx...xxx" = BasisDateiname der Datei.
    'Effekt
    '   Entweder wurde eine Postscript-Datei mit 0 Byte Lnge angelegt und gelscht
    '   oder es wurde eine Fehlermeldung angezeigt.
        
    
    Dim sErweitererSymbDateiName As String 'Vollstndiger symbolischer Dateiname
    Dim sBasisName As String 'Name des aktiven Office-Dokuments ohne Pfad und Extension
    Dim lLaenge As Long
    Dim sPfadName As String
    Dim sTempNamenszusatz As String 'Nameszusatz fr die PS- und PDF-Datei
    Dim sNamenszusatz As String 'Nameszusatz fr die PS- und PDF-Datei
    '   Enthlt in Powerpoint immer den Namen des aktuellen Output-Typen
    
    'Nur in Powerpoint:
    Dim bFoliennummern() As Boolean
    Dim iZaehler As Integer
    Dim oSlideRange As Object
    Dim vEineFolie As Variant
    
    'Nur in Powerpoint:
    'Wenn eine Prsentation durch Doppenklick im Windows-Explorer geffnet wird, enthlt
    'ActivePresentation.Name kein ".ppt". Nur in ActivePresentation.FullName steht ".ppt".
    'Eine neue Prsentation enthlt einen Namen ohne "." am Ende des Namens aber keine Pfad.
    'Deshalb wird der Dateiname extra ermittelt
    Dim sName As String 'Name des aktiven Office-Dokuments ohne Pfad und mit Extension
    sName = Mid(ActivePresentation.FullName, _
        flLetztesVorkommen_suchen(ActivePresentation.FullName, ActivePresentation.Name))
      
    If Left(sSymbDateiName, 2) = "\\" _
    Or (Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" _
    And Mid(sSymbDateiName, 3, 1) = gsPathSeparator) Then '"\\XXX" "C:\XXX" unverndert lassen
        sErweitererSymbDateiName = sSymbDateiName
    ElseIf Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" Then '"C:XXX" wird zu "C:\aaa\XXX"
        sPfadName = CurDir(Left(sSymbDateiName, 2))
        If Right(sPfadName, 1) = gsPathSeparator Then
            sErweitererSymbDateiName = sPfadName & Mid(sSymbDateiName, 3)
        Else
            sErweitererSymbDateiName = sPfadName & gsPathSeparator & Mid(sSymbDateiName, 3)
        End If
    ElseIf Left(sSymbDateiName, 1) = gsPathSeparator Then
        '"\XXX" wird zu "D:\XXX" oder \\server\freigabe\XXX
        If Left(ActivePresentation.Path, 2) = "\\" Then '\\freigabe\server\
            lLaenge = InStr(InStr(3, ActivePresentation.Path, gsPathSeparator) + 1, _
                ActivePresentation.Path, gsPathSeparator) - 1
            If lLaenge < 3 Then 'Auch bei einem Fehler geht es weiter
                lLaenge = 0
            End If
        Else
            lLaenge = 2
        End If
        sErweitererSymbDateiName = Left(ActivePresentation.Path, lLaenge) & sSymbDateiName
    Else '"XXX" wird zu "D:\aaa\XXX"
        sErweitererSymbDateiName = ActivePresentation.Path & gsPathSeparator & sSymbDateiName
    End If
    
    Select Case gsTypeSwitch
    Case sTYPESWITCH_POWERPOINT_AKTIV 'As String = "Aktuelle Komponente"
        Select Case fiGib_AktuellenViewtype
        Case 1  ' = ppViewSlide = Folien
            sNamenszusatz = sNAMENSZUSATZ_FOLIEN
        Case 3  ' = ppViewNotesPage = Notizen
            sNamenszusatz = sNAMENSZUSATZ_NOTIZEN
        Case 6  ' = ppViewOutline = Gliederung
            sNamenszusatz = sNAMENSZUSATZ_GLIEDERUNG
        Case 7  ' = ppViewSlideSorter = Foliensortierung oder = ppViewThumbnails
                ' = Miniaturansicht nur in Powerpoint 2002
            sNamenszusatz = sNAMENSZUSATZ_HANDZETTEL
        Case Else
            MsgBox sMSG_PPANSICHTNICHTVERWENDBAR, vbExclamation, sTITEL_ERZEUGEN
            fsBasisDateiName_ermitteln = sLEER
            Exit Function
        End Select
    Case sTYPESWITCH_POWERPOINT_FOLIEN ' = "Folien"
        sNamenszusatz = sNAMENSZUSATZ_FOLIEN
    Case sTYPESWITCH_POWERPOINT_HANDZETTEL2 ' = "Handzettel (2 Folien je Seite)"
        sNamenszusatz = sNAMENSZUSATZ_HANDZETTEL2
    Case sTYPESWITCH_POWERPOINT_HANDZETTEL3 ' = "Handzettel (3 Folien je Seite)"
        sNamenszusatz = sNAMENSZUSATZ_HANDZETTEL3
    Case sTYPESWITCH_POWERPOINT_HANDZETTEL6 ' = "Handzettel (6 Folien je Seite)"
        sNamenszusatz = sNAMENSZUSATZ_HANDZETTEL6
    Case sTYPESWITCH_POWERPOINT_NOTIZEN ' = "Notizseiten"
        sNamenszusatz = sNAMENSZUSATZ_NOTIZEN
    Case sTYPESWITCH_POWERPOINT_GLIEDERUNG ' = "Gliederungsansicht"
        sNamenszusatz = sNAMENSZUSATZ_GLIEDERUNG
    Case Else
        MsgBox sMSG_TYPESWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fsBasisDateiName_ermitteln = sLEER
        Exit Function
    End Select

    Select Case gsPrintSwitch
    Case sPRINTSWITCH_POWERPOINT_PRAESENTATION 'Die ganze Prsentation ausgeben
        'nichts in sNamenszusatz verndern
    Case sPRINTSWITCH_POWERPOINT_FOLIE, sPRINTSWITCH_POWERPOINT_FOLIENAUSWAHL
        'Nur die aktuelle Folie ausgeben UND Nur markierte Tabellen ausgeben
        Select Case Windows(1).Selection.Type
        Case ppSelectionSlides, ppSelectionText, ppSelectionNone
            'Prfen ob mindestens eine Folie markiert ist
            On Error Resume Next 'ohne On Error gibt es einem Fehler; mit gibt es KEINEN Fehler!
            Set oSlideRange = Windows(1).Selection.SlideRange
            On Error GoTo 0
            If oSlideRange Is Nothing Then
                MsgBox sMSG_KEINEFOLIEAUSGEWAEHLT _
                    , vbExclamation, sTITEL_ERZEUGEN
                fsBasisDateiName_ermitteln = sLEER
                Exit Function
            End If
            
            ReDim bFoliennummern(10) As Boolean
            For Each vEineFolie In oSlideRange
                iZaehler = vEineFolie.SlideIndex
                If iZaehler > UBound(bFoliennummern) Then
                    ReDim Preserve bFoliennummern(iZaehler + 10)
                End If
                bFoliennummern(iZaehler) = True
            Next vEineFolie
            For iZaehler = LBound(bFoliennummern) To UBound(bFoliennummern)
                If bFoliennummern(iZaehler) = True Then
                    sNamenszusatz = sNamenszusatz & "_" & iZaehler
                    If gsPrintSwitch = sPRINTSWITCH_POWERPOINT_FOLIE Then
                        Exit For ' Nur die Nummer der ersten Folie
                    End If
                End If
            Next iZaehler
        'Case ppSelectionNone
        '    sNamenszusatz = sNamenszusatz & "_" & ActiveWindow.View.Slide.SlideIndex
        Case ppSelectionShapes
            sNamenszusatz = sNamenszusatz & "_S"
        'Case ppSelectionText
        '    sNamenszusatz = sNamenszusatz & "_T"
        Case Else
            sNamenszusatz = sNamenszusatz & "_E"
        End Select
    Case Else
        MsgBox sMSG_PRINTSWITCHUNBEKANNT _
            , vbExclamation, sTITEL_ERZEUGEN
        fsBasisDateiName_ermitteln = sLEER
        Exit Function
    End Select
                   
    sBasisName = Left(sName, flLetztesVorkommen_suchen(sName, ".") - 1) & sNamenszusatz
    fsBasisDateiName_ermitteln = fsSymbDateiName_umsetzen(sErweitererSymbDateiName, sBasisName, sLEER)
    
End Function

'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

'===================================================================================================
'Ende.
'===================================================================================================

