Attribute VB_Name = "TECH_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt :
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   TECH_Prozeduren
' Effekt:
'   Das Modul konfiguriert Gs4Word
' Restriktionen:
'   Die Module GLOB_Prozeduren und GLOB_sss mssen vorhanden sein.
' Entwicklung und Test:
'   Siehe Modul KONF_Prozeduren und INST_Prozeduren
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   Siehe Modul KONF_Prozeduren und INST_Prozeduren

' Die Eintrge in der Registry sind in GLOB_Prozeduren beschrieben (siehe dort)

'===================================================================================================
'Deklarationen
'===================================================================================================
    
' Spezielle Konstante zur Konfiguration
'--------------------------------------
Public Const sDOKUMENTATION As String = "Dokumentation.html"
Public Const sHTML As String = ".html"
Public Const iMAXRECHNERWARTEZEITFAKTOR As Integer = 10
    
' Die folgenden Variablen werden fr den Konfigurationsdialog bentigt
'---------------------------------------------------------------------
Public gbKonfigurationGespeichert As Boolean
Public gsTaskName As String
Public gbDateiumleitungsFlagIstAenderbar As Boolean

'===================================================================================================
'Alle ffentlichen Funktionen, die von KONF_UserForm & INST_UserForm verwendet werden
'===================================================================================================

Function fsSymbDateiName_konfigurieren(sAlterSymbDateiName As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten symbolischen Dateinamen an. Er
    'kann gendert werden. Sie gibt den genderten symbolischen Dateinamen zurck.
    'Die Funktion berprft den Namen auf syntaktische Fehler, ohne alle vollstndig zu finden.
    'Ob alle UNC-Namen "\\server\freigabe", Laufwerke und Verzeichnisses vorhanden sind, kann die
    'Funktion nicht berprfen.
    'Argumente:
    '   sAlterSymbDateiName = aktuell eingestellter symbolischer Datenname
    'Rckgabewert:
    '   xx..xx = neuer symbolischer Dateiname.
    'Effekt
    '   Der Dialog fr die Eingabe des symbolischen Dateinamens wurde gefhrt.
    
    fsSymbDateiName_konfigurieren = Trim(sAlterSymbDateiName)

    Do
        fsSymbDateiName_konfigurieren = _
            Trim(InputBox(sTEXT_IBSYMBDATEINAME, sTITEL_IBSYMBDATEINAME, _
            fsSymbDateiName_konfigurieren))
        
        If fsSymbDateiName_konfigurieren = sLEER Then ' Abgebrochen
            fsSymbDateiName_konfigurieren = Trim(sAlterSymbDateiName)
            Exit Function
        End If
        
    Loop While fsSymbDateiName_umsetzen(fsSymbDateiName_konfigurieren, "XXXXXX", sPDF) = sLEER
       
End Function

Function fsPostscriptDrucker_konfigurieren(sAlterDruckerName As String) As String
    'Die Funktion zeigt alle konfigurierten Drucker an und ermglicht die Auswahl eines Druckes. Der
    'zuletzt ausgewhlte Drucker ist voreingestellt. Sie gibt den neu ausgewhlten Postscript-
    'Drucker zurck.
    'Argumente:
    '   sAlterDruckerName = aktuell eingestellter Drucker oder sLEER
    'Rckgabewert:
    '   sLEER = Es konnte kein Postsscript-Drucker ermittelt werden.
    '   xx..xx = Name des ausgewhlten Postsscript-Druckers.
    'Effekt
    '   Der Dialog fr die Eingabe des Druckers wurde gefhrt.
    '----------------------------------------------------------------
    'Diese Funktion wird in der nchsten Version von Gs4Word umgestellt. Die vorhandenen
    'Drucker werden aus der Registry gelesen.
    'Dann kann der Drucker aus einer Combo-Box ausgewhlt werden.
    '----------------------------------------------------------------
       
    Dim sStandardDruckerName As String 'Name des aktuell eingesteller Druckers mit on-Klausel
    Dim sNeuerDruckerName As String
    
    sStandardDruckerName = ActivePrinter
    If sStandardDruckerName <> sAlterDruckerName _
    And sAlterDruckerName <> sLEER Then 'alten Drucker als Vorgabewert anzeigen
        On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (na ja)
        ActivePrinter = sAlterDruckerName
        On Error GoTo 0
    End If
    
    With Dialogs(wdDialogFilePrintSetup)
        '.DoNotSetAsSysDefault = 1 'Wert <> 0 damit der Drucker nicht zum Standarddrucker wird
        If .Show = True Then 'Button Schliessen (=OK) gedrckt
            sNeuerDruckerName = ActivePrinter
        Else
            sNeuerDruckerName = sLEER
        End If
    End With
    
    If sStandardDruckerName <> ActivePrinter Then
        On Error Resume Next
            ' falls der Drucker in der Zwischenzeit gelscht wurde (ist reproduzierbar!)
        ActivePrinter = sStandardDruckerName
        On Error GoTo 0
    End If

    fsPostscriptDrucker_konfigurieren = sNeuerDruckerName
    
End Function

Function fsProgrammName_konfigurieren(sAlterProgrammName As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten Programmnamen an. Der Pfad und
    'Programmname kann gendert werden. Sie gibt den ausgewhlten Programmnamen zurck.
    'Argumente:
    '   sAlterProgrammName = aktuell eingestellter Programm-Name
    '                       Der Wert wird zur Zeit nicht verwendet
    'Rckgabewert:
    '   sLEER = Es konnte kein neuer Programm-Name ermittelt werden.
    '   xx..xx = Name des ausgewhlten Programms mit Pfad.
    'Effekt
    '   Der Dialog fr die Eingabe des Programmnamens wurde gefhrt.
            
    With Dialogs(wdDialogFileOpen)
        '"Datei > ffnen" oder "Datei > Speichern unter" wechseln immer dann in das gewnschte
        'Verzeichnis, wenn man ein existierendes Verzeichnis oder eine existierende Datei (mit Pfad)
        'angibt.
        .Name = sAlterProgrammName
        If .Display = True Then
            fsProgrammName_konfigurieren = WordBasic.FilenameInfo$(.Name, 1)
            'In WordBasic.FilenameInfo$ gibt der Wert "1" im zweiten Argument den vollen Dateinamen
            'mit Pfad zurck.
        Else
            fsProgrammName_konfigurieren = sAlterProgrammName
        End If
    End With
    
End Function

Function fsMailtoParameter_konfigurieren(sAlterMailtoParameter As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten Mailto-Parameter an. Er kann
    'gendert werden. Sie gibt den genderten Mailto-Parameter zurck.
    'Die Funktion berprft den Parameter nicht auf syntaktische Fehler.
    'Argumente:
    '   sAlterMailtoParameter = aktuell eingestellter Mailto-Parameter
    'Rckgabewert:
    '   xx..xx = neuer Mailto-Parameter.
    'Effekt
    '   Der Dialog fr die Eingabe des Mailto-Parameters wurde gefhrt.
    
    fsMailtoParameter_konfigurieren = Trim(sAlterMailtoParameter)

    fsMailtoParameter_konfigurieren = _
        InputBox(sTEXT_IBMAILTOPARAMETER, sTITEL_IBMAILTOPARAMETER, _
        fsMailtoParameter_konfigurieren)
    
    If fsMailtoParameter_konfigurieren = sLEER Then ' Abgebrochen
        fsMailtoParameter_konfigurieren = Trim(sAlterMailtoParameter)
    Else
        fsMailtoParameter_konfigurieren = Trim(fsMailtoParameter_konfigurieren)
    End If
    
End Function

Function fsDokuAufruf_konfigurieren(sAlterDokuAufruf As String) As String
    'Die Funktion zeigt in einem Dialog den aktuell eingestellten Aufruf der Dokumentation an.
    'Er kann gendert werden. Sie gibt den genderten Aufruf der Dokumentation zurck.
    'Die Funktion berprft den Parameter nicht auf syntaktische Fehler.
    'Argumente:
    '   sAlterDokuAufruf = aktuell eingestellter Aufruf der Dokumentation
    'Rckgabewert:
    '   xx..xx = neuer Aufruf der Dokumentation.
    'Effekt
    '   Der Dialog fr die Eingabe des Aufrufes der Dokumentation wurde gefhrt.
    
    fsDokuAufruf_konfigurieren = Trim(sAlterDokuAufruf)

    fsDokuAufruf_konfigurieren = _
        InputBox(sTEXT_IBDOKUAUFRUF, sTITEL_IBDOKUAUFRUF, _
        fsDokuAufruf_konfigurieren)
    
    If fsDokuAufruf_konfigurieren = sLEER Then ' Abgebrochen
        fsDokuAufruf_konfigurieren = Trim(sAlterDokuAufruf)
    Else
        fsDokuAufruf_konfigurieren = Trim(fsDokuAufruf_konfigurieren)
    End If
    
End Function

Function fbKonfiguration_ausRegistryFuellen(sTaskName As String) As Boolean
    'Die Funktion belegt die globalen g*-Variablen aus der Registry mit den Werten aus der Registry
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   g*-Variable werden ggf. gendert
    '   gbKonfigurationGespeichert wird gesetzt
    'Rckgabewert:
    '   True = Die Konfiguration wurde ermittelt
    'Effekt
            
    Dim sPSDrucker As String
    
    Call fbKonfiguration_lesen(sTaskName)
    gbKonfigurationGespeichert = True
  
    'Variable giMaxRechnerWartezeit belegen
    If giMaxRechnerWartezeit = 0 Then
        gbKonfigurationGespeichert = False
        giMaxRechnerWartezeit = fiMaxRechnerWartezeit_ermitteln
    End If
    'Variable gsPathSeparator vor der Nutzung bei gsMailtoProgrammName belegen!!!
    If gsPathSeparator = sLEER Then
        gbKonfigurationGespeichert = False
    End If
    gsPathSeparator = Application.PathSeparator 'PathSeparator IMMER neu ermitteln
    If gsPSDruckerName = sLEER _
    Or gsPSDruckerPort = sLEER Then  'Default ermitteln
        gbKonfigurationGespeichert = False
        sPSDrucker = fsPostscriptDrucker_ermitteln()
        gsPSDruckerName = fsDruckerName_ermitteln(sPSDrucker)
        gsPSDruckerPort = fsDruckerPort_ermitteln(sPSDrucker)
    End If
    If gsPSDruckerName <> sLEER _
    And fsRedmon_ermitteln(gsPSDruckerName) = True Then
        gbDateiumleitungsFlagIstAenderbar = True
    Else
        gbDateiumleitungsFlag = False
        gbDateiumleitungsFlagIstAenderbar = False
    End If
    If gsGSProgrammName = sLEER Then 'Default ermitteln
        gbKonfigurationGespeichert = False
        gsGSProgrammName = fsGhostscriptProgramm_ermitteln()
    End If
    If gsKonfigProgrammName = sLEER Then 'Default ermitteln
        gbKonfigurationGespeichert = False
    End If
    If gsPDFProgrammName = sLEER Then 'Default ermitteln
        gbKonfigurationGespeichert = False
        gsPDFProgrammName = fsVerknuepfung_ermitteln(sPDF, sLEER)
    End If
    If gsMailtoProgrammName = sLEER Then 'Default ermitteln
        gsMailtoProgrammName = fsMailtoProgramm_ermitteln()
        gsMailtoParameter = fsMailtoParameter_ermitteln(gsMailtoProgrammName)
    End If
    
    fbKonfiguration_ausRegistryFuellen = True
    
End Function

Function fbKonfiguration_mitTechnikDefaultsBelegen() As Boolean
    'Die Funktion belegt die globalen g*-Variablen zur Technik aus der Registry mit ihren Defaults.
    'Diese Werte sind fr alle Gs4Word-Add-Ins gleich
    'Nur gsKonfigProgrammname wird nicht neu belegt. Diese Variable muss immer gefllt bleiben.
    'Argumente:
    'Global:
    '   g*-Variable werden ggf. gendert
    '   gbKonfigurationGespeichert wird auf False gesetzt
    'Rckgabewert:
    '   True = Die g*-Variablen wurden mit ihren Defaults belegt
    'Effekt
    
    Dim sPSDrucker As String
    
    gbKonfigurationGespeichert = False
    
    sPSDrucker = fsPostscriptDrucker_ermitteln()
    gsPSDruckerName = fsDruckerName_ermitteln(sPSDrucker)
    gsPSDruckerPort = fsDruckerPort_ermitteln(sPSDrucker)
    If gsPSDruckerName <> sLEER _
    And fsRedmon_ermitteln(gsPSDruckerName) = True Then
        gbDateiumleitungsFlag = True
        gbDateiumleitungsFlagIstAenderbar = True
    Else
        gbDateiumleitungsFlag = False
        gbDateiumleitungsFlagIstAenderbar = False
    End If
    gsDokuAufruf = fsDokuAufruf_ermitteln()
    gsGSProgrammName = fsGhostscriptProgramm_ermitteln()
    gsPDFProgrammName = fsVerknuepfung_ermitteln(sPDF, sLEER)
    giMaxRechnerWartezeit = fiMaxRechnerWartezeit_ermitteln
    gsMailtoProgrammName = fsMailtoProgramm_ermitteln()
    gsMailtoParameter = fsMailtoParameter_ermitteln(gsMailtoProgrammName)
    
    fbKonfiguration_mitTechnikDefaultsBelegen = True
        
End Function

Function fbKonfiguration_mitAnwendungsDefaultsBelegen(sTaskName As String, bVorlageIstAenderbar As Boolean)
    'Die Funktion belegt die globalen g*-Variablen zur Anwendung aus der Registry mit ihren Defaults.
    'Diese Werte sind fr je Gs4Word-Add-In unterschiedlich.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    '   bVorlageIstAenderbar Nur wenn das Flag gesetzt ist, wird auch gbButtonFlag und gsMailToSwitch
    '       mit den Defaultwerten belegt
    'Global:
    '   g*-Variable werden ggf. gendert
    '   gbKonfigurationGespeichert wird auf False gesetzt
    'Rckgabewert:
    '   True = Die g*-Variablen wurden mit ihren Defaults belegt
    'Effekt
    
    gbKonfigurationGespeichert = False
    
    If bVorlageIstAenderbar = True Then
        gbButtonFlag = fbFlag_pruefen(bDEFAULT_BUTTONFLAG, bDEFAULT_BUTTONFLAG)
        If gsMailtoParameter = sLEER Then
            gsMailToSwitch = fsMailToSwitch_konvertieren(sDEFAULT_MAILTOSWITCH_NEIN)
        Else
            gsMailToSwitch = fsMailToSwitch_konvertieren(sDEFAULT_MAILTOSWITCH_JA)
        End If
    End If
    gbDialogFlag = fbFlag_pruefen(bDEFAULT_DIALOGFLAG, bDEFAULT_DIALOGFLAG)
    gbPdfmarkFlag = fbFlag_pruefen(bDEFAULT_PDFMARKFLAG, bDEFAULT_PDFMARKFLAG)
    gsPdfOutSwitch = fsPDFOutSwitch_konvertieren(sDEFAULT_PDFOUTSWITCH, sTaskName)
    gsPdfPageLayoutSwitch = fsPDFPageLayoutSwitch_konvertieren(sDEFAULT_PDFPAGELAYOUTSWITCH)
    If sTaskName = sTASKNAME_WORD Then
        gsPdfPageModeSwitch = fsPDFPageModeSwitch_konvertieren(sDEFAULT_PDFPAGEMODESWITCH_WORD, sTaskName)
    Else
        gsPdfPageModeSwitch = fsPDFPageModeSwitch_konvertieren(sDEFAULT_PDFPAGEMODESWITCH, sTaskName)
    End If
    gsPdfViewSwitch = fsPDFViewSwitch_konvertieren(sDEFAULT_PDFVIEWSWITCH)
    gsPrintSwitch = fsPrintSwitch_konvertieren(sDEFAULT_PRINTSWITCH, sTaskName)
    gsTypeSwitch = fsTypeSwitch_konvertieren(sDEFAULT_TYPESWITCH, sTaskName)
    gbPDFBetrachterFlag = fbFlag_pruefen(sDEFAULT_PDFBETRACHTERFLAG, sDEFAULT_PDFBETRACHTERFLAG)
    gbPSDateiLoeschenFlag = fbFlag_pruefen(sDEFAULT_PSDATEILOESCHENFLAG, _
        sDEFAULT_PSDATEILOESCHENFLAG)
    gsAusgabeMedium = fsAusgabeMedienListe_konvertieren(sDEFAULT_AUSGABEMEDIUM)
    gsSymbDateiName = sDEFAULT_SYMBDATEINAME
    
    fbKonfiguration_mitAnwendungsDefaultsBelegen = True
    
End Function

Function fsPostscriptDrucker_ermitteln() As String
    'Die Funktion gibt einen Postscript-Drucker mit Port oder sLEER zurck. Dazu prft sie, ob einer
    'der Namen in sDruckerName ein vorhandener Drucker ist.
    'Rckgabewert:
    '   sLEER = Es konnte kein Postsscript-Drucker ermittelt werden.
    '   xx..xx = Name und Port des Postsscript-Druckers.
    'Effekt
    '   keiner
    '----------------------------------------------------------------
    'Diese Funktion wird in der nchsten Version von Gs4Word umgestellt. Die vorhandenen
    'Drucker werden aus der Registry gelesen.
    '----------------------------------------------------------------
    Dim sStandardDruckerName As String 'Name des aktuell eingesteller Druckers mit on-Klausel
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    Dim sEinDrucker As Variant
    Dim sDruckerName(5) As String 'Tabelle mit Druckernamen, die passen knnten.
    
    'Namen der geprften Drucker
    sDruckerName(0) = "Generic PostScript Printer CMYK"
    sDruckerName(1) = "Generic Colour PostScript"
    sDruckerName(2) = "Gs4Word PostScript Printer"
    sDruckerName(3) = "Adobe PostScript Printer"
    sDruckerName(4) = "Generic PostScript Printer"
    sDruckerName(5) = "HP Color LaserJet PS"
    
    fsPostscriptDrucker_ermitteln = sLEER
    sStandardDruckerName = ActivePrinter
    
    For Each sEinDrucker In sDruckerName
        On Error Resume Next ' falls der Drucker nicht existiert
        ActivePrinter = sEinDrucker
        iFehlerNummer = Err.Number
        On Error GoTo 0
        If iFehlerNummer = 0 Then
            fsPostscriptDrucker_ermitteln = ActivePrinter
            Exit For
        End If
        'Unter Windows 2000 und Office 2000 SR1 kann sporadisch folgende Fehlermeldung vorkommen:
        '"Excel.exe hat Fehler verursacht und wird geschlossen ..."
        'Wenn man ein bisschen wartet, geschieht der Fehler nicht.
        If sEinDrucker = sDruckerName(2) Then
            fbWarten (1)
        End If
    Next sEinDrucker
    
    If sStandardDruckerName <> ActivePrinter Then
        On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (na ja)
        ActivePrinter = sStandardDruckerName
        On Error GoTo 0
    End If
    
End Function

Function fsRedmon_ermitteln(sPSDruckerName As String) As String
    'Die Funktion prft, ob RedMon fr den Gs4Word-Drucker konfiguriert ist. Das ist der Fall, wenn
    'in der Registry ein RedMon-Drucker-Monitor eingetragen ist, dessen Port und Drucker-Name passt.
    'Da der Name des RedMon-Registry-Key abhngig von der Sprache ist, in der RedMon installiert
    'wurde, habe ich die vier verschiedenen Namen aus der Source von RedMon, Version 1.7 genommen.
    'Diese Version ist in vier Spachen lieferbar. Getestet wurde nur in Deutsch.
    'Der Port wird aus dem Registry-Eintrag des Druckers ermittelt.
    'Argumente:
    '   sPSDruckerName ist der Druckername
    '   sPSDruckerPort ist der Drucker-Port
    'Rckgabewert:
    '   True = RedMon ist fr den Drucker aus sPSDruckerName installiert
    '   True = RedMon ist nicht fr den Drucker aus sPSDruckerName iinstalliert
    'Effekt
    '   keiner
    
    Const sREDFILE As String = "\redfile.exe"
    Const sIDS_MONITORNAME_de As String = "Umgeleiteter Anschlu"
    Const sIDS_MONITORNAME_en As String = "Redirected Port"
    Const sIDS_MONITORNAME_fr As String = "Port redirig"
    Const sIDS_MONITORNAME_se As String = "Omdirigerad port"
    Const sBASISKEY_1 As String = _
        "HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Print\Monitors\"
    Const sBASISKEY_2 As String = "\Ports\"
    Const sSCHLUESSEL_PORT As String = "Port"
    Const sSCHLUESSEL_COMMAND As String = "Command"
    Const sDRUCKERKEY As String = _
        "HKEY_LOCAL_MACHINE\System\CurrentControlSet\Control\Print\Printers\"

    Dim sRedMonKeys(3) As String
    Dim iZaehler As Integer
    Dim sPortWert As String
    Dim sCommandWert As String
    Dim sProgramm As String
    
    sPortWert = System.PrivateProfileString(sLEER, sDRUCKERKEY & Trim(sPSDruckerName), _
        sSCHLUESSEL_PORT)
        
    If sPortWert <> sLEER Then
        sRedMonKeys(0) = sBASISKEY_1 & sIDS_MONITORNAME_de & sBASISKEY_2 & sPortWert
        sRedMonKeys(1) = sBASISKEY_1 & sIDS_MONITORNAME_en & sBASISKEY_2 & sPortWert
        sRedMonKeys(2) = sBASISKEY_1 & sIDS_MONITORNAME_fr & sBASISKEY_2 & sPortWert
        sRedMonKeys(3) = sBASISKEY_1 & sIDS_MONITORNAME_se & sBASISKEY_2 & sPortWert

        For iZaehler = LBound(sRedMonKeys) To UBound(sRedMonKeys)
            sCommandWert = System.PrivateProfileString(sLEER, sRedMonKeys(iZaehler) _
                , sSCHLUESSEL_COMMAND)
            If LCase(Right(sCommandWert, Len(sREDFILE))) = sREDFILE Then
                fsRedmon_ermitteln = True
                Exit Function
            End If
        Next iZaehler
    End If
    
    fsRedmon_ermitteln = False
    
End Function

Function fsVerknuepfung_ermitteln(sVerknuepfung As String, sName As String) As String
    'Die Funktion gibt den Namen des Programms zurck, mit dem sVerknpfung verknpft ist. Dabei
    'wird die Environment-Variable SYSTEMROOT aufgelst, wenn sie an Anfang steht. Das Programm
    'muss vorhanden sein.
    'Wenn sName nicht leer ist, wird sName fr den hinter dem Programmnamen stehenden Parameter
    '   %1 (z.B. %1 oder /r "%1") eingesetzt. Die Anfhrungszeichen werden nicht ersetzt.
    'Wenn sName leer ist, wird nur der Programmname ohne Anfhrungszeichen zurckgegeben.
    'Argumente:
    '   sVerknpfung = Name der Verknpfung. Der Name beginnt mit einem Punkt
    '   sName = leer oder Dateiname mit Pfad
    'Rckgabewert:
    '   sLEER = Es konnte kein zugeordnetes Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms und ggf. der aufzurufenfen Datei.
    'Effekt
    '   keiner
       
    Dim sWert As String
    Dim sRegistryWert As String
    Dim sProgramm As String
    Dim lPosition As Long

    fsVerknuepfung_ermitteln = sLEER
    
    sWert = System.PrivateProfileString(sLEER, "HKEY_LOCAL_MACHINE\SOFTWARE\classes\" _
        & sVerknuepfung, sLEER)
    sRegistryWert = System.PrivateProfileString(sLEER, _
        "HKEY_LOCAL_MACHINE\SOFTWARE\classes\" & sWert & "\shell\open\command", sLEER)
    'Der Dateiname darf in Anfhrungszeichen (") stehen.
    'entweder 'xxx.exe %1' oder '"xxx" "%1"' oder '%systemroot%\xxx %1' oder eine Kombination
    sRegistryWert = Trim(sRegistryWert)
    If LCase(Left(sRegistryWert, 12)) = LCase("%systemroot%") Then
        sRegistryWert = Environ("systemroot") & gsPathSeparator & Mid(sRegistryWert, 13)
    ElseIf LCase(Left(sRegistryWert, 13)) = Chr(34) & LCase("%systemroot%") Then
        sRegistryWert = Chr(34) & Environ("systemroot") & gsPathSeparator & Mid(sRegistryWert, 14)
    End If
    sProgramm = sRegistryWert & sSPACE

    If Left(sProgramm, 1) = Chr(34) Then 'Programmname ist in Anfhrungszeichen eingeschossen
        sProgramm = Mid(sProgramm, 2) 'erstes Anfhrungszeichen entfernen
        lPosition = InStr(sProgramm, Chr(34)) 'zweites Anfhrungszeichen suchen
    Else
        lPosition = InStr(sProgramm, sSPACE)  'erstes Leerzeichen suchen
    End If
    If lPosition > 0 Then
        sProgramm = Left(sProgramm, lPosition - 1)
        If Dir(sProgramm, vbNormal) <> sLEER Then
            If sName = sLEER Then
                fsVerknuepfung_ermitteln = sProgramm
            Else
                lPosition = flLetztesVorkommen_suchen(sRegistryWert, "%1")
                If lPosition > 0 Then
                    fsVerknuepfung_ermitteln = Left(sRegistryWert, lPosition - 1) _
                        & sName & Mid(sRegistryWert & sSPACE, lPosition + 2)
                Else
                    fsVerknuepfung_ermitteln = sRegistryWert & sSPACE & sName
                End If
            End If
        End If
    End If

End Function

Function fsDokuAufruf_ermitteln() As String
    'Die Funktion gibt den Aufruf der HTML-Dokumentation mit dem Browser zurck.
    'Global:
    '   gsKonfigProgrammName wird gelesen
    'Rckgabewert:
    '   sLEER = Es konnte kein Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms.
    'Effekt
    '   keiner
    
    Dim sDokuDatei As String
    Dim lPosition As Long
    
    fsDokuAufruf_ermitteln = sLEER
    
    lPosition = flLetztesVorkommen_suchen(gsKonfigProgrammName, gsPathSeparator)
    If lPosition > 0 Then
        sDokuDatei = Left(gsKonfigProgrammName, lPosition) & sDOKUMENTATION
        If Dir(sDokuDatei, vbNormal) <> sLEER Then
            fsDokuAufruf_ermitteln = fsVerknuepfung_ermitteln(sHTML, sDokuDatei)
        End If
    End If

End Function

Function fsGhostscriptProgramm_ermitteln() As String
    'Die Funktion gibt den Namen des Ghostscript-Programms zurck ist. Dazu prft sie drei Verfahren
    'fr mehrere Versionen von Ghostscript.
    'Rckgabewert:
    '   sLEER = Es konnte kein Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms.
    'Effekt
    '   keiner
    
    Dim sEineVersion As Variant
    Dim sWert As String
    Dim sProgramm As String
    Dim lPosition As Long
    Dim sVersionName(2) As String 'Tabelle mit Versionsnummern von Ghostscript, die passen knnten.
      
    'Nummern der geprften Versionen von Ghostscript
    sVersionName(0) = "7.04"
    sVersionName(1) = "7.03"
    sVersionName(2) = "7.00"

    fsGhostscriptProgramm_ermitteln = sLEER
    
    For Each sEineVersion In sVersionName
        'erster Versuch: Ghostscript-DLL in der Registry suchen und prfen, ob dort auch das
        'Programm steht.
        sProgramm = System.PrivateProfileString(sLEER, _
            "HKEY_LOCAL_MACHINE\SOFTWARE\AFPL Ghostscript\" & sEineVersion, "GS_DLL")
            'z.B. "HKEY_LOCAL_MACHINE\SOFTWARE\AFPL Ghostscript\7.00"
        If sProgramm <> sLEER Then 'Hier steht die DLL von Ghostscript
            lPosition = flLetztesVorkommen_suchen(sProgramm, gsPathSeparator)
            If lPosition > 0 Then
                sProgramm = Left(sProgramm, lPosition) & "gswin32c.exe"
                'z.B. "C:\Programme\gs\gs7.00\bin\gswin32c.exe"
                If Dir(sProgramm, vbNormal) <> sLEER Then
                    fsGhostscriptProgramm_ermitteln = sProgramm
                    Exit Function
                End If
            End If
         End If
        
        'zweiter Versuch: Wurde Ghostscript in "C:\gs" installiert?
        'Dieses Verzeichnis wird bei der Installation vorgeschlagen.
        sProgramm = "C:\gs\gs" & sEineVersion & "\bin\gswin32c.exe"
            'z.B. "C:\gs\gs7.00\bin\gswin32c.exe"
        If Dir(sProgramm, vbNormal) <> sLEER Then
            fsGhostscriptProgramm_ermitteln = sProgramm
            Exit Function
        End If
            
        'dritter Versuch: Wurde Ghostscript im Standard-Programmverzeichnis installiert?
        sProgramm = System.PrivateProfileString(sLEER, _
            "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion", "ProgramFilesDir")
        If sProgramm <> sLEER Then
            sProgramm = sProgramm & "\gs\gs" & sEineVersion & "\bin\gswin32c.exe"
            'z.B. "\gs\gs7.00\bin\gswin32c.exe"
            If Dir(sProgramm, vbNormal) <> sLEER Then
                fsGhostscriptProgramm_ermitteln = sProgramm
                Exit Function
            End If
        End If
    Next sEineVersion
        
    'Das war wohl nichts

End Function

Function fsMailtoProgramm_ermitteln() As String
    'Die Funktion gibt den Namen des Programms zurck, mit dem mailto verknpft ist. Dabei wird die
    'Environment-Variable SYSTEMROOT aufgelst, wenn sie an Anfang steht. Hinter dem Programmnamen
    'stehende Parameter (z.B. %1 oder /r "%1") werden entfernt. Das Programm muss vorhanden sein.
    'Rckgabewert:
    '   sLEER = Es konnte kein zugeordnetes Programm ermittelt werden.
    '   xx..xx = Name des zugeordneten Programms.
    'Effekt
    '   keiner
       
    Dim sWert As String
    Dim sProgramm As String
    Dim lPosition As Long

    fsMailtoProgramm_ermitteln = sLEER
    
    sProgramm = System.PrivateProfileString(sLEER, _
        "HKEY_LOCAL_MACHINE\SOFTWARE\classes\mailto\shell\open\command", sLEER)
    'Der Dateiname darf in Anfhrungszeichen (") stehen.
    'entweder 'xxx.exe %1' oder '"xxx" "%1"' oder '%systemroot%\xxx %1' oder eine Kombination
    sProgramm = Trim(sProgramm) & sSPACE
    If Left(sProgramm, 1) = Chr(34) Then 'Programmname ist in Anfhrungszeichen eingeschossen
        sProgramm = Mid(sProgramm, 2) 'erstes Anfhrungszeichen entfernen
        lPosition = InStr(sProgramm, Chr(34)) 'zweites Anfhrungszeichen suchen
    Else
        lPosition = InStr(sProgramm, sSPACE)  'erstes Leerzeichen suchen
    End If
    If lPosition > 0 Then
        sProgramm = Left(sProgramm, lPosition - 1)
        If LCase(Left(sProgramm, 12)) = LCase("%systemroot%") Then
            sProgramm = Environ("systemroot") & gsPathSeparator & Mid(sProgramm, 13)
        End If
        If Dir(sProgramm, vbNormal) <> sLEER Then
            fsMailtoProgramm_ermitteln = sProgramm
        End If
    End If

End Function

Function fsMailtoParameter_ermitteln(sMailtoProgrammName As String) As String
    'Die Funktion gibt den Default-Parameter zum Mailto-Programm zurck.
    'Argumente:
    '   sMailtoProgrammName = Name des Mailto-Programms mit Pfad. Zwei Programme werden erkannt:
    '       netscape.exe ist der 'Netscape Communicator 4.xx
    '       outlook.exe ist Outlook 97/98/2000
    'Rckgabewert:
    '   sLEER = Es konnte kein zugeordnetes Mailto-Programm ermittelt werden.
    '   xx..xx = Default-Parameter.
    'Effekt
    '   keiner
    
    Select Case UCase(Mid(gsMailtoProgrammName, _
        flLetztesVorkommen_suchen(gsMailtoProgrammName, gsPathSeparator) + 1))
    Case "OUTLOOK.EXE" 'Outlook 97/98/2000
        fsMailtoParameter_ermitteln = "/c ipm.note /a " & Chr(34) & "%" & Chr(34)
    Case "NETSCAPE.EXE" 'Netscape Communicator 4.xx
        fsMailtoParameter_ermitteln = "-compose " & Chr(34) & "-%" & Chr(34)
    Case Else
        fsMailtoParameter_ermitteln = sLEER
    End Select

End Function

Function fiMaxRechnerWartezeit_ermitteln() As Integer
    'Die Funktion gibt eine Anzahl Sekunden zurck, die auf diesem Rechner MAXIMAL gewartet werden
    'muss, um einen Prozess zu starten und die Verarbeitung zu beginnen.
    'Wenn auf einem Rechner keine anderen, zeitaufwendigen Prozesse laufen, reichen folgende
    'Werte aus:
    '   Prozessortakt ..... in MHZ ....  >=533 >=266 >=200  ansonsten
    '   MaxRechnerWartezeit in Sekunden    6    12    18    24
    'Wenn gleichzeitig rechenintensive Anwendungen laufen, muss dieser Wert hher gesetzt werden.
    'Der einzige Grund, ihn niedrig zu setzen, ist der Anwender, der zu lange auf die Ausgabe der
    'Fehlermeldung(!) warten muss.
    'Ab Version 2.41 wird die ganze aufwendige Verarbeitung in die Tonne getreten und immer genau
    '3 0 Sekunden zurckgegeben.
    'Global:
    '   iMAXRECHNERWARTEZEITFAKTOR wird gelesen
    'Rckgabewert:
    '   30  Sekunden. Der Rckgabewert muss durch iMAXRECHNERWARTEZEITFAKTOR teilbar sein.
    'Effekt
    '   keiner
    
'    Dim sDoubleWord As String 'String mit dem DoubleWord in ein oder 2 Bytes aus der Registry
'    'Es handelt sich um 32-Bit-Ganzzahl ohne Vorzeichen mit einem Wert von 0 bis 4.294.967.296.
'    'Wenn die Zahl kleiner als 256 ist, liefert System.PrivateProfileString das Ergebnis
'    'als String in einem Byte, sonst in 2 Bytes.
'    'In Office XP handelt es sich nicht um ein DoubleWord sondern um die echten Mhz.
'    'Unter Windows 95, Windows 98 und Me fehlt dieser Eintrag
'    Dim iLinkesByteWert As Integer 'Wert im linken Byte von sDoubleWord
'    Dim iRechtesByteWert As Integer 'Wert im rechten Byte von sDoubleWord
'    Dim iMHZ As Integer 'MHZ des ersten Prozessors auf diesem Rechner

     fiMaxRechnerWartezeit_ermitteln = 3 * iMAXRECHNERWARTEZEITFAKTOR 'Defaultwert
    
'    On Error Resume Next 'Auf keinen  Fall abstrzen, auch dann nicht, wenn der Eintrag in der
'    'Registry manipuliert ist!
'
'    sDoubleWord = System.PrivateProfileString(sLEER, _
'        "HKEY_LOCAL_MACHINE\HARDWARE\DESCRIPTION\System\CentralProcessor\0", "~MHZ")
'
'    Select Case Len(sDoubleWord)
'    Case 0 'Kein Eintrag in der Registry vorhanden (Win 95/98/Me)
'        iMHZ = 0
'    Case 1 'Double Word in einem Byte
'        iMHZ = Asc(Left(sDoubleWord, 1))
'    Case 2 'Double Word in zwei Bytes
'        iLinkesByteWert = Asc(Left(sDoubleWord, 1)) 'Linkes Byte
'        iRechtesByteWert = AscB(Right(sDoubleWord, 1)) 'Rechtes Byte
'        iMHZ = iRechtesByteWert * 256 + iLinkesByteWert
'        'Im rechten Byte steht der hherwertige Wert
'    Case Else 'Unter Office XP wird der Eintrag aus der Registry schon umgerechnet
'        iMHZ = sDoubleWord
'    End Select
'
'    Select Case iMHZ 'Defaultwert fiMaxRechnerWartezeit_ermitteln = 24 ggf. verringern
'    Case Is >= 533
'        fiMaxRechnerWartezeit_ermitteln = 6
'    Case Is >= 266
'        fiMaxRechnerWartezeit_ermitteln = 12
'    Case Is >= 200
'        fiMaxRechnerWartezeit_ermitteln = 18
'    End Select
'
'    On Error GoTo 0
    
End Function

'===================================================================================================
'Ende.
'===================================================================================================


