Attribute VB_Name = "TestDerKomponenten"
Option Explicit
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   PDF_TestDerKomponenten
' Effekt:
'   Das Modul dient zum reproduzierbaren Test einzelner Funktionen
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten PDF_Erzeugen_xxx muss vorhanden sein.
' Entwicklung und Test:
'   Siehe Modul PDF_Erzeugen
' Copyright:
'   Siehe Modul PDF_Erzeugen
' Historie:
'   Siehe Modul PDF_Erzeugen
' OFFEN
' neue Registry-Eintrge gsPSDruckerPort einbauen

#Const ERWARTETE_ERGEBNISSE_ANZEIGEN = False 'Wertebereich True oder False

#If True Then 'Wertebereich True oder False

'===================================================================================================================
'Anfang der Deklarationen, Funktionen und Prozeduren
'===================================================================================================================

Const sERWARTETTEXT = "Erwartetes Ergebnis eingetreten:" & vbCr
Const lOKBUTTONS = vbOKCancel
Const sUNERWTEXT = "Unerwartetes Ergebnis eingetreten:" & vbCr
Const lFEHLERBUTTONS = vbOKCancel + vbCritical

Sub ALLE_TESTS()
    Call TEST_von_AusgabeMedienListe_konvertieren
    Call TEST_von_Dateiname_kuerzen
    Call TEST_von_SymbDateiName_umsetzen
    Call TEST_von_Flag_pruefen
    Call TEST_von_Konfiguration_lesen
    Call TEST_von_Konfiguration_loeschen
    Call TEST_von_Konfiguration_schreiben
    Call TEST_von_Konfiguration_testen
    Call TEST_von_LetztesVorkommen_suchen
    Call TEST_von_DruckerNameUndPort_ermitteln
End Sub

Sub TEST_von_AusgabeMedienListe_konvertieren()
    Const sSUBNAME As String = "TEST_von_AusgabeMedienListe_konvertieren"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Dim sTitel As String
    Dim lEffekt As Long
    Dim sArg1 As String
    Dim sOutput As String
    Dim i, j, iTestreihe As Integer
    Dim sEinString As Variant
    Dim sTabelle1(3) As String
    Dim sTabelle2(3) As String
    
    'OK Fall testen
    i = 0
    sTabelle1(i) = "0"
    sTabelle2(i) = "Standardeinstellung"
    i = i + 1
    sTabelle1(i) = "1"
    sTabelle2(i) = "fr den Bildschirm"
    i = i + 1
    sTabelle1(i) = "2"
    sTabelle2(i) = "fr einen Drucker"
    i = i + 1
    sTabelle1(i) = "3"
    sTabelle2(i) = "fr eine Publikation"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 2
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle1
            Select Case iTestreihe
                Case 1
                    sArg1 = sTabelle1(j)
                    sOutput = sTabelle2(j)
                Case 2
                    sArg1 = sTabelle2(j)
                    sOutput = sTabelle1(j)
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            
            If sOutput = AusgabeMedienListe_konvertieren(sArg1) Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & vbCr & sOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1 & vbCr & sOutput, lFEHLERBUTTONS, sTitel)
                Stop
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
    'Fehler Fall testen
    i = 0
    sTabelle1(i) = ""
    sTabelle2(i) = ""
    i = i + 1
    sTabelle1(i) = "4"
    sTabelle2(i) = ""
    i = i + 1
    sTabelle1(i) = "x"
    sTabelle2(i) = ""

    sTitel = "FEHLER-Test " & sSUBNAME

    For iTestreihe = 1 To 1
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle1
            sArg1 = sTabelle1(j)
            sOutput = sTabelle2(j)
            If sOutput = AusgabeMedienListe_konvertieren(sArg1) Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & vbCr & sOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1 & vbCr & sOutput, lFEHLERBUTTONS, sTitel)
                Stop
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe

End Sub

Sub TEST_von_Dateiname_kuerzen()
    Const sSUBNAME As String = "TEST_vonDateiname_kuerzen"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Dim sTitel As String
    Dim lEffekt As Long
    Dim sArg1 As String
    Dim lArg2 As Long
    Dim sOutput As String
    Dim sErgebnis As String
    Dim i, j, iTestreihe As Integer
    Dim sEinString As Variant
    Dim sTabelle(10) As String
    
    'OK Fall testen
    i = 0
    sTabelle(i) = "a.abc"
    i = i + 1
    sTabelle(i) = "a:\bcde\fghi\jklm\nop\qrs\tuvw\xyz\12345.678"
    i = i + 1
    sTabelle(i) = "c:12345678901234567890.abc"
    i = i + 1
    sTabelle(i) = "12345678901234567890"
    i = i + 1
    sTabelle(i) = ""
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 1
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg1 = sTabelle(j)
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            sErgebnis = ""
            For lArg2 = Len(sArg1) + 1 To 0 Step -1
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                If Len(sErgebnis) > 200 Then
                    lEffekt = MsgBox(sERWARTETTEXT & vbCr & "Name " & sArg1 & vbCr & "Lnge " & Len(sArg1) _
                        & vbCr & sErgebnis, lOKBUTTONS, sTitel)
                    If lEffekt = vbCancel Then Exit Sub
                    sErgebnis = ""
                End If
                #End If
                sOutput = Dateiname_kuerzen(sArg1, lArg2)
                If Len(sOutput) > lArg2 Then
                    lEffekt = MsgBox(sUNERWTEXT & sArg1 & vbCr & lArg2 & vbCr & sOutput, lFEHLERBUTTONS, sTitel)
                    Stop
                End If
                sErgebnis = sErgebnis & vbCr & lArg2 & "=" & sOutput
            Next lArg2
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            If Len(sErgebnis) > 0 Then
                lEffekt = MsgBox(sERWARTETTEXT & vbCr & "Name " & sArg1 & vbCr & "Lnge " & Len(sArg1) _
                    & vbCr & sErgebnis, lOKBUTTONS, sTitel)
                If lEffekt = vbCancel Then Exit Sub
                sOutput = ""
            End If
            #End If
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
End Sub

Sub TEST_von_SymbDateiName_umsetzen()
    Const sSUBNAME As String = "TEST_von_SymbDateiName_umsetzen"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Const sSPACE  As String = "    "
    Dim sTitel As String
    Dim lEffekt As Long
    Dim sArg1 As String
    Dim sArg2 As String
    Dim sOutput As String
    Dim i, j, iTestreihe As Integer
    Dim sEinString As Variant
    Dim sTabelle(200) As String
    
    Call Konfiguration_lesen(sTASKNAME_WORD) ' wegen gsPathSeparator
    
    'OK Fall testen
    i = 0
    sTabelle(i) = "x"
    i = i + 1
    sTabelle(i) = "\x"
    i = i + 1
    sTabelle(i) = "c:x"
    i = i + 1
    sTabelle(i) = "c:\x"
    i = i + 1
    sTabelle(i) = "\\rechnerastrid\netzlaufwerk\x"
    i = i + 1
    sTabelle(i) = "<name> ist der Name des Dokuments"
    i = i + 1
    sTabelle(i) = "<d> <dd> <ddd> <dddd> ist der Tag (1-31, 01-31, So-Sa, Sonntag-Samstag)."
    i = i + 1
    sTabelle(i) = "<h> <hh> ist die Stunde (0-23, 00-23)."
    i = i + 1
    sTabelle(i) = "<m> <mm> <mmm> <mmmm> ist der Monat (1-12, 01-12, Jan-Dez, Januar-Dezember)."
    i = i + 1
    sTabelle(i) = "<n> <nn> ist die Minute (0-59, 00-59)."
    i = i + 1
    sTabelle(i) = "<q> ist das Quartal (1-4)."
    i = i + 1
    sTabelle(i) = "<s> <ss> ist die Sekunde (0-59, 00-59)."
    i = i + 1
    sTabelle(i) = "<w> ist der Wochentag (1-7)."
    i = i + 1
    sTabelle(i) = "<ww> ist die Kalenderwoche (1-54)."
    i = i + 1
    sTabelle(i) = "<y> ist der Kalendertag (1-366)."
    i = i + 1
    sTabelle(i) = "<yy> <yyyy> ist das Jahr (00-99, 100-9999)."
    i = i + 1
    sTabelle(i) = "<name> <name> <name> <name> <name> <name>"
    i = i + 1
    sTabelle(i) = "<d> <dd> <ddd> <dddd> <d> <dd> <ddd> <dddd> <d> <dd> <ddd> <dddd>"
    i = i + 1
    sTabelle(i) = "<h> <hh> <h> <hh>"
    i = i + 1
    sTabelle(i) = "<m> <mm> <mmm> <mmmm> <m> <mm> <mmm> <mmmm> <m> <mm> <mmm> <mmmm> )."
    i = i + 1
    sTabelle(i) = "<n> <nn> <n> <nn>  <n> <nn>"
    i = i + 1
    sTabelle(i) = "<q> <q> <q> <q> <q>"
    i = i + 1
    sTabelle(i) = "<s> <ss> <s> <ss>  <s> <ss>"
    i = i + 1
    sTabelle(i) = "<w> <w> <w>"
    i = i + 1
    sTabelle(i) = "<ww> <ww> <ww>"
    i = i + 1
    sTabelle(i) = "<y> ist der Kalendertag (1-366)."
    i = i + 1
    sTabelle(i) = "<yy> <yyyy> <yy> <yyyy>  <yy> <yyyy>"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 4
        
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg1 = sEinString
                Case 2
                    sArg1 = sSPACE & sEinString
                Case 3
                    sArg1 = sEinString & sSPACE
                Case 4
                    sArg1 = sSPACE & sEinString
            End Select
            sArg2 = "@@@@"
            sOutput = SymbDateiName_umsetzen(sArg1, sArg2, "")
            If sOutput <> "" Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sEinString & vbCr & sOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sEinString, lFEHLERBUTTONS, sTitel)
                Stop
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
    'FEHLER Fall testen
    i = 0
    sTabelle(i) = ""
    i = i + 1
    sTabelle(i) = "\"
    i = i + 1
    sTabelle(i) = "c:"
    i = i + 1
    sTabelle(i) = "c:\"
    i = i + 1
    sTabelle(i) = "\\"
    i = i + 1
    sTabelle(i) = "\\server"
    i = i + 1
    sTabelle(i) = "Z:"
    i = i + 1
    sTabelle(i) = """"
    i = i + 1
    sTabelle(i) = "\"
    i = i + 1
    sTabelle(i) = ":"
    i = i + 1
    sTabelle(i) = "?"
    i = i + 1
    sTabelle(i) = "*"
    i = i + 1
    sTabelle(i) = "<"
    i = i + 1
    sTabelle(i) = ">"
    i = i + 1
    sTabelle(i) = "|"
    i = i + 1
    sTabelle(i) = "%"
    i = i + 1
    sTabelle(i) = """" & """"
    i = i + 1
    sTabelle(i) = "\" & "\"
    i = i + 1
    sTabelle(i) = ":" & ":"
    i = i + 1
    sTabelle(i) = "?" & "?"
    i = i + 1
    sTabelle(i) = "*" & "*"
    i = i + 1
    sTabelle(i) = "<" & "<"
    i = i + 1
    sTabelle(i) = ">" & ">"
    i = i + 1
    sTabelle(i) = "|" & "|"
    i = i + 1
    sTabelle(i) = "%" & "%"
    i = i + 1
    sTabelle(i) = """" & "   " & """"
    i = i + 1
    sTabelle(i) = "\" & "   " & "\"
    i = i + 1
    sTabelle(i) = ":" & "   " & ":"
    i = i + 1
    sTabelle(i) = "?" & "   " & "?"
    i = i + 1
    sTabelle(i) = "*" & "   " & "*"
    i = i + 1
    sTabelle(i) = "<" & "   " & "<"
    i = i + 1
    sTabelle(i) = ">" & "   " & ">"
    i = i + 1
    sTabelle(i) = "|" & "   " & "|"
    i = i + 1
    sTabelle(i) = "%" & "   " & "%"
    
    sTitel = "FEHLER-Test " & sSUBNAME
   
    For iTestreihe = 1 To 4
        
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg1 = sEinString
                Case 2
                    sArg1 = sSPACE & sEinString
                Case 3
                    sArg1 = sEinString & sSPACE
                Case 4
                    sArg1 = sSPACE & sEinString
            End Select
            sArg2 = "@@@@"
            sOutput = SymbDateiName_umsetzen(sArg1, sArg2, "")
            If sOutput = "" Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1 & vbCr & sOutput, lFEHLERBUTTONS, sTitel)
                Stop
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe

End Sub

Sub TEST_von_Flag_pruefen()
    Const sSUBNAME As String = "TEST_von_Flag_pruefen"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Dim sTitel As String
    Dim lEffekt As Long
    Dim sArg1 As String
    Dim bArg2 As Boolean
    Dim lOutput As Long
    Dim i, j, iTestreihe As Integer
    Dim sEinString As Variant
    Dim sTabelle(5) As String
    
    'OK und Fehler Fall testen
    i = 0
    sTabelle(i) = ""
    i = i + 1
    sTabelle(i) = "a"
    i = i + 1
    sTabelle(i) = "0"
    i = i + 1
    sTabelle(i) = "1"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 2
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    bArg2 = False
                Case 2
                    bArg2 = True
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            
            sArg1 = sEinString
            lOutput = Flag_pruefen(sArg1, bArg2)
            If lOutput = 0 _
            Or lOutput = 1 Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & "," & bArg2 & vbCr & lOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1, lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
End Sub
   
Sub TEST_von_Konfiguration_lesen()
    
    Call Konfiguration_lesen(sTASKNAME_WORD)
    'Die Funktion liest die Konfiguration fr Word aus der Registry und fllt die globalen Variablen g...
    'Fehlende Werte werden durch 1 (bei Flags) oder "" (bei allen anderen) ersetzt.
    'Global:
    '   Alle g... aus PDF_Public werden gefllt
    'Rckgabewert:
    '   True = Die Konfiguration wurde gelesen.

End Sub
   
Sub TEST_von_Konfiguration_loeschen()
    
    Call Konfiguration_loeschen(sTASKNAME_WORD)
    'Die Funktion lscht die Konfiguration aus der Registry.
    'Rckgabewert:
    '   True = Die  Konfiguration wurde gelscht.

End Sub
   
Sub TEST_von_Konfiguration_schreiben()
    
    Call Konfiguration_schreiben(sTASKNAME_WORD)
    'Die Funktion schreibt die Konfiguration aus den globalen Variablen g... in die Registry.
    'Global:
    '   g... aus PDF_Public werden gelesen
    '   gsAusgabeMedienListe() wird immer gefllt
    'Rckgabewert:
    '   True = Die Konfiguration wurde in die Registry geschrieben.

End Sub
   
Sub TEST_von_Konfiguration_testen()
    Const sSUBNAME As String = "TEST_von_Konfiguration_testen"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Dim bEffekt As Boolean
    Dim lEffekt As Long
    Dim sTitel As String
    Dim iTestreihe As Integer
    
    'OK Fall testen
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 2
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
    
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gbButtonFlag = True 'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gsAusgabeMedium = "1" '"0", "1", "2" oder "3"
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gsAusgabeMedium = "2" '"0", "1", "2" oder "3"
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gsAusgabeMedium = "3" '"0", "1", "2" oder "3"
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub

        gbEinTeilobjektFlag = True  'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gbDialogFlag = True  'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gbDateiumleitungsFlag = True  'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gbMailtoFlag = True  'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gsMailtoProgrammName = "x" '"x" oder ""
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gsMailtoParameter = "x" '"x" oder ""
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gbPDFBetrachterFlag = True  'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gsPDFProgrammName = "x" '"x" oder ""
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        gbPDFBetrachterFlag = False  'False oder True
        If Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
    Next iTestreihe
   
    'Fehler Fall testen
    sTitel = "FEHLER-Test " & sSUBNAME
    
    For iTestreihe = 1 To 2
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
          
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsSymbDateiName = ""
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsAusgabeMedium = "a" '"0", "1", "2" oder "3"
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsAusgabeMedium = "4" '"0", "1", "2" oder "3"
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sERWARTETTEXT, lOKBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
           
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsPSDruckerName = ""
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsPSDruckerPort = ""
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsGSProgrammName = "" '"x" oder ""
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsPDFProgrammName = "" '"x" oder ""
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
        
        Call TEST_von_Konfiguration_testen_OK(iTestreihe)
        gsPathSeparator = "" 'immer "\"
        If Not Konfiguration_testen Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & TEST_von_Konfiguration_testen_DISPLAY, lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT, lFEHLERBUTTONS, sTitel)
            Stop
        End If
        If lEffekt = vbCancel Then Exit Sub
    Next iTestreihe
        
End Sub

Private Function TEST_von_Konfiguration_testen_OK(iTestreihe)
    Const sSUBNAME As String = "TEST_von_Konfiguration_testen_OK"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Select Case iTestreihe
    
        Case 1
            gsAusgabeMedium = "0" '"0", "1", "2" oder "3"
            gbButtonFlag = False 'False oder True
            gsSymbDateiName = "x"
            gbEinTeilobjektFlag = False 'False oder True
            gbDialogFlag = False  'False oder True
            gsPSDruckerName = "x"
            gsPSDruckerPort = "x"
            gbDateiumleitungsFlag = False  'False oder True
            gsGSProgrammName = "x"
            gsMailtoParameter = "x"
            gsMailtoProgrammName = "x"
            gbMailtoFlag = False  'False oder True
            gbPDFBetrachterFlag = False  'False oder True
            gsPDFProgrammName = "x" '"x" oder ""
            giMaxRechnerWartezeit = 1 '1 bis 32
            gsPathSeparator = "\" 'immer "\"
        Case 2
            gsAusgabeMedium = "0" '"0", "1", "2" oder "3"
            gbButtonFlag = True 'False oder True
            gsSymbDateiName = "x"
            gbEinTeilobjektFlag = True 'False oder True
            gbDialogFlag = True  'False oder True
            gsPSDruckerName = "x"
            gsPSDruckerPort = "x"
            gbDateiumleitungsFlag = True  'False oder True
            gsGSProgrammName = "x"
            gsMailtoParameter = "x"
            gsMailtoProgrammName = "x"
            gbMailtoFlag = True  'False oder True
            gsPDFProgrammName = "x" '"x" oder ""
            giMaxRechnerWartezeit = 32 '0 bis 32
            gsPathSeparator = "\" 'immer "\"
        Case Else
            MsgBox sABBRUCH, vbCritical, sSUBNAME
            Stop
    End Select
End Function

Private Function TEST_von_Konfiguration_testen_DISPLAY()
    TEST_von_Konfiguration_testen_DISPLAY = _
              vbCr & "gbButtonFlag = " & gbButtonFlag _
            & vbCr & "gsSymbDateiName = " & gsSymbDateiName _
            & vbCr & "gsAusgabeMedium = " & gsAusgabeMedium _
            & vbCr & "gbDialogFlag = " & gbDialogFlag _
            & vbCr & "gbEinTeilobjektFlag = " & gbEinTeilobjektFlag _
            & vbCr & "gsPSDruckerName = " & gsPSDruckerName _
            & vbCr & "gsPSDruckerPort = " & gsPSDruckerPort _
            & vbCr & "gbDateiumleitungsFlag = " & gbDateiumleitungsFlag _
            & vbCr & "gsGSProgrammName = " & gsGSProgrammName _
            & vbCr & "gbMailtoFlag = " & gbMailtoFlag _
            & vbCr & "gsMailtoProgrammName = " & gsMailtoProgrammName _
            & vbCr & "gsMailtoParameter = " & gsMailtoParameter _
            & vbCr & "gbPDFBetrachterFlag = " & gbPDFBetrachterFlag _
            & vbCr & "gsPDFProgrammName = " & gsPDFProgrammName _
            & vbCr & "giMaxRechnerWartezeit = " & giMaxRechnerWartezeit _
            & vbCr & "gsPathSeparator = " & gsPathSeparator
            gsPathSeparator = "\" 'immer "\"

End Function

Sub TEST_von_LetztesVorkommen_suchen()
    Const sSUBNAME As String = "TEST_von_LetztesVorkommen_suchen"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Dim sTitel As String
    Dim lEffekt As Long
    Dim sArg1 As String
    Dim sArg2 As String
    Dim lOutput As Long
    Dim i, j, iTestreihe As Integer
    Dim sEinString As Variant
    Dim sTabelle(200) As String
    
    'OK Fall testen
    i = 0
    sTabelle(i) = "abcdef%ghij"
    i = i + 1
    sTabelle(i) = "%abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij%"
    i = i + 1
    sTabelle(i) = "%abcdefghij%"
    i = i + 1
    sTabelle(i) = "a%bcdefghi%j"
    i = i + 1
    sTabelle(i) = "abcdef%%ghij"
    i = i + 1
    sTabelle(i) = "%%abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij%%"
    i = i + 1
    sTabelle(i) = "abcdef%%%ghij"
    i = i + 1
    sTabelle(i) = "%%%abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij%%%"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 1
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg2 = "%"
            End Select
            sArg1 = sEinString
            lOutput = LetztesVorkommen_suchen(sArg1, sArg2)
            If lOutput <> 0 Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & vbCr & Left(sArg1, lOutput - 1) & vbCr & lOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1, lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
    'OK Fall testen
    i = 0
    sTabelle(i) = "abcdef%1%ghij"
    i = i + 1
    sTabelle(i) = "%1%abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij%1%"
    i = i + 1
    sTabelle(i) = "%1%abcdefghij%1%"
    i = i + 1
    sTabelle(i) = "a%1%bcdefghi%1%j"
    i = i + 1
    sTabelle(i) = "abcdef%1%%1%ghij"
    i = i + 1
    sTabelle(i) = "%1%%1%abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij%1%%1%"
    i = i + 1
    sTabelle(i) = "abcdef%1%%1%%1%ghij"
    i = i + 1
    sTabelle(i) = "%1%%1%%1%abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij%1%%1%%1%"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 2 To 2
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 2
                    sArg2 = "%1%"
            End Select
            sArg1 = sEinString
            lOutput = LetztesVorkommen_suchen(sArg1, sArg2)
            If lOutput <> 0 Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & vbCr & Left(sArg1, lOutput - 1) & vbCr & lOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1, lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
    'OK Fall testen
    i = 0
    sTabelle(i) = "abcdef<1>ghij"
    i = i + 1
    sTabelle(i) = "<1>abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij<1>"
    i = i + 1
    sTabelle(i) = "<1>abcdefghij<1>"
    i = i + 1
    sTabelle(i) = "a<1>bcdefghi<1>j"
    i = i + 1
    sTabelle(i) = "abcdef<1><1>ghij"
    i = i + 1
    sTabelle(i) = "<1><1>abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij<1><1>"
    i = i + 1
    sTabelle(i) = "abcdef<1><1><1>ghij"
    i = i + 1
    sTabelle(i) = "<1><1><1>abcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij<1><1><1>"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 3 To 3
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 3
                    sArg2 = "<1>"
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            sArg1 = sEinString
            lOutput = LetztesVorkommen_suchen(sArg1, sArg2)
            If lOutput <> 0 Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & vbCr & Left(sArg1, lOutput - 1) & vbCr & lOutput, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1, lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
    'FEHLER Fall testen
    i = 0
    sTabelle(i) = ""
    i = i + 1
    sTabelle(i) = "<abcdefghij>"
    i = i + 1
    sTabelle(i) = "a<b>cdefghij"
    i = i + 1
    sTabelle(i) = "a>bcdefghij"
    i = i + 1
    sTabelle(i) = "abcdefghij>"
    i = i + 1
    sTabelle(i) = "abcdefghij<a"
    i = i + 1
    sTabelle(i) = "a<b>cdefghij"
    
    sTitel = "FEHLER-Test " & sSUBNAME

    For iTestreihe = 1 To 1
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg2 = "<a>"
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            sArg1 = sEinString
            lOutput = LetztesVorkommen_suchen(sArg1, sArg2 & vbCr & lOutput)
            If lOutput = 0 Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & sArg1 & vbCr & sArg2, lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & sArg1 & vbCr & Left(sArg1, lOutput - 1) & vbCr & lOutput, lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
End Sub

Sub TEST_von_DruckerNameUndPort_ermitteln()
    Const sSUBNAME As String = "TEST_von_DruckerNameUndPort_ermitteln"
    Const sABBRUCH As String = "Abbruch in Testscript " & sSUBNAME
    Dim sTitel As String
    Dim lEffekt As Long
    Dim sArg As String
    Dim sDruckerName As String
    Dim sDruckerPort As String
    Dim sBindewort As String
    Dim lLeerzeichen As Long
    Dim i, j, iTestreihe As Integer
    Dim sEinString As Variant
    Dim sTabelle(20) As String
    
    Call Konfiguration_lesen(sTASKNAME_WORD) ' wegen gsPathSeparator
    
    'OK Fall testen
    i = 0
    sTabelle(i) = "Drucker auf LPT1:"
    i = i + 1
    sTabelle(i) = "a b c d e:"
    i = i + 1
    sTabelle(i) = "a  b  c  d  e:"
    i = i + 1
    sTabelle(i) = "aa bb cc dd ee:"
    i = i + 1
    sTabelle(i) = "aa  bb  cc  dd  ee:"
    i = i + 1
    sTabelle(i) = "Drucker auf \\rechner\freigabe\name"
    i = i + 1
    sTabelle(i) = "a b c d \\e"
    i = i + 1
    sTabelle(i) = "a  b  c  d  \\e"
    i = i + 1
    sTabelle(i) = "aa bb cc dd \\ee"
    i = i + 1
    sTabelle(i) = "aa  bb  cc  dd  \\ee"
    i = i + 1
    sTabelle(i) = "Drucker auf C:\XXX\*.PDF"
    i = i + 1
    sTabelle(i) = "a b c d e:\"
    i = i + 1
    sTabelle(i) = "a  b  c  d  e:\"
    i = i + 1
    sTabelle(i) = "aa bb cc dd e:\"
    i = i + 1
    sTabelle(i) = "aa  bb  cc  dd  e:\"
    
    sTitel = "OK-Test " & sSUBNAME

    For iTestreihe = 1 To 4
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg = sEinString
                Case 2
                    sArg = "   " & sEinString
                Case 3
                    sArg = sEinString & "   "
                Case 4
                    sArg = "   " & sEinString & "   "
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            
            sDruckerName = DruckerName_ermitteln(sArg)
            sDruckerPort = DruckerPort_ermitteln(sArg)
            sBindewort = Left(sDruckerPort, InStr(sDruckerPort, " "))
            lLeerzeichen = Len(Trim(sArg)) - Len(sDruckerName) - Len(sDruckerPort)
            If lLeerzeichen > 0 _
            And Trim(sDruckerName) = sDruckerName _
            And Trim(sDruckerPort) = sDruckerPort _
            And Left(LTrim(sArg), Len(sDruckerName)) = sDruckerName _
            And Right(RTrim(sArg), Len(sDruckerPort)) = sDruckerPort _
            And Mid(Trim(sArg), Len(sDruckerName) + 1, lLeerzeichen) = Space(lLeerzeichen) Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & "<" & sArg & ">" _
                    & vbCr & "<" & sDruckerName & Space(lLeerzeichen) & sDruckerPort & ">" _
                    & vbCr & "DruckerName:" & vbTab & "<" & sDruckerName & ">" _
                    & vbCr & "DruckerPort:" & vbTab & "<" & sDruckerPort & ">" _
                    & vbCr & "Bindewort:" & vbTab & "<" & sBindewort & ">" _
                    , lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & "<" & sArg & ">" _
                    & vbCr & "<" & sDruckerName & Space(lLeerzeichen) & sDruckerPort & ">" _
                    & vbCr & "DruckerName:" & vbTab & "<" & sDruckerName & ">" _
                    & vbCr & "DruckerPort:" & vbTab & "<" & sDruckerPort & ">" _
                    & vbCr & "Bindewort:" & vbTab & "<" & sBindewort & ">" _
                    , lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
 
    'FEHLER Fall DruckerName testen
    i = 0
    sTabelle(i) = ""
    i = i + 1
    sTabelle(i) = "   "
    
    sTitel = "FEHLER-Test " & sSUBNAME

    lEffekt = MsgBox("Testreihe 0", vbOKCancel, sTitel)
    If lEffekt = vbCancel Then Exit Sub
    j = 0
    For Each sEinString In sTabelle
        sDruckerName = DruckerName_ermitteln(sEinString)
        If sDruckerName = "" Then
            #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
            lEffekt = MsgBox(sERWARTETTEXT & "<" & sEinString & ">" _
                & vbCr & "<" & sDruckerName & ">" _
                , lOKBUTTONS, sTitel)
            #End If
        Else
            lEffekt = MsgBox(sUNERWTEXT & "<" & sEinString & ">" _
                & vbCr & "<" & sDruckerName & ">" _
                , lFEHLERBUTTONS, sTitel)
        End If
        If lEffekt = vbCancel Then Exit Sub
        j = j + 1
        If j > i Then Exit For
    Next sEinString
    
    'FEHLER Fall DruckerPort testen
    i = 0
    sTabelle(i) = ""
    i = i + 1
    sTabelle(i) = " "
    i = i + 1
    sTabelle(i) = "d"
    i = i + 1
    sTabelle(i) = "a b"
    i = i + 1
    sTabelle(i) = "a b c"
    i = i + 1
    sTabelle(i) = "d:"
    i = i + 1
    sTabelle(i) = "a b:"
    i = i + 1
    sTabelle(i) = "\\a\b"
    i = i + 1
    sTabelle(i) = "a \\b\c"
    i = i + 1
    sTabelle(i) = "a:\"
    i = i + 1
    sTabelle(i) = "a b:\"
    
    sTitel = "FEHLER-Test " & sSUBNAME
    
    For iTestreihe = 1 To 4
    
        lEffekt = MsgBox("Testreihe " & iTestreihe, vbOKCancel, sTitel)
        If lEffekt = vbCancel Then Exit Sub
        j = 0
        For Each sEinString In sTabelle
            Select Case iTestreihe
                Case 1
                    sArg = sEinString
                Case 2
                    sArg = "   " & sEinString
                Case 3
                    sArg = sEinString & "   "
                Case 4
                    sArg = "   " & sEinString & "   "
                Case Else
                    MsgBox sABBRUCH, vbCritical, sTitel
                    Stop
            End Select
            
            sDruckerPort = DruckerPort_ermitteln(sArg)
            sBindewort = Left(sDruckerPort, InStr(sDruckerPort, " "))
            If sDruckerPort = "" Then
                #If ERWARTETE_ERGEBNISSE_ANZEIGEN Then
                lEffekt = MsgBox(sERWARTETTEXT & "<" & sArg & ">" _
                    & vbCr & "DruckerPort:" & vbTab & "<" & sDruckerPort & ">" _
                    , lOKBUTTONS, sTitel)
                #End If
            Else
                lEffekt = MsgBox(sUNERWTEXT & "<" & sArg & ">" _
                    & vbCr & "DruckerPort:" & vbTab & "<" & sDruckerPort & ">" _
                    & vbCr & "Bindewort:" & vbTab & "<" & sBindewort & ">" _
                    , lFEHLERBUTTONS, sTitel)
            End If
            If lEffekt = vbCancel Then Exit Sub
            j = j + 1
            If j > i Then Exit For
        Next sEinString
    Next iTestreihe
    
End Sub

Sub BisherigeRechnerWartezeit()
    'Die Funktion zeigt die MaxRechnerWartezeit und die lngste echte WechnerWartezeit in Sekunden.
    'Sie wird nur fr Debug-Zwecke verwendet und muss mit Alt + F11 aufgerufen werden.
    'Effekt
    '   Eine Meldung wurde angezeigt.
    
    MsgBox "MaxRechnerWartezeit = " & giMaxRechnerWartezeit & " s" _
        & vbCr & "giGsWartezeit = " & giGsWartezeit & " s" _
        , vbExclamation, sTITEL_ERZEUGEN

End Sub

'===================================================================================================================
'Ende der Deklarationen, Funktionen und Prozeduren
'===================================================================================================================

#End If
