Attribute VB_Name = "XLS_Prozeduren"
Option Explicit
'........1.........2.........3.........4.........5.........6.........7.........8.........9.........0
' Projekt:
'   Gs4Word - Ghostscript fr Microsoft Word, Excel und Powerpoint
' Modul:
'   XLS_Prozeduren
' Effekt beim Start von Excel:
'   Das Modul erstellt in dieser Vorlage beim Aufruf von Excel ...
'       1. in der aktiven Menleiste ein Men "PDF".
'       2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration vorgesehen ist.
' Effekt beim Aufruf von PDF > Erzeugen:
'   Das Modul erstellt aus der aktuellen Excel-Arbeitsmappe eine PDF-Datei. Dazu erzeugt es eine
'   gleichnamige Postscript-Datei mit der Endung .ps und eine gleichnamige PDF-Datei mit der Endung
'   .pdf. Die Postscript-Datei wird wieder gelscht.
' Effekt beim Aufruf von "PDF > Info":
'   Das Modul zeigt Informationen ber sich an.
' Restriktionen:
'   Das Modul mit den sprachabhngigen Texten XLS_sss muss vorhanden sein. Dabei ist sss die
'   Sprache. Die Module GLOB_Prozeduren und GLOB_sss und die UserForm GLOB_UserForm mssen vorhanden
'   sein.
'   Microsoft Office 9.0 Object Library ist erforderlich fr fbVorlageAnpassen()
'   Dieses Add-In darf nicht schreibgeschtzt sein. Es muss "Gs4Wordxxx_vvvsss.dot" heissen.
'   Dabei ist xxx ein beliebiger, optionaler Zusatz ohne Unterstrich "_". vvv ist die Versionsnummer und sss die Sprache.
' Entwicklung und Test:
'   siehe Dokumentation
' Copyright:
'   Das Copyright (C) 2001 an diesem Programm liegt beim Autor J.W.Schmitz-Hbsch. Sie knnen das
'   Programm unter den Bedingungen der GNU General Public License, wie von der Free Software
'   Foundation herausgegeben, weitergeben und/oder modifizieren, entweder unter Version 2 der Lizenz
'   oder (wenn Sie es wnschen) jeder spteren Version. Die Verffentlichung dieses Programms
'   erfolgt in der Hoffnung, dass es Ihnen von Nutzen sein wird, aber OHNE JEDE GEWHRLEISTUNG
'   - sogar ohne die implizite Gewhrleistung der MARKTREIFE oder der EIGNUNG FR EINEN BESTIMMTEN
'   ZWECK. Details finden Sie in der GNU General Public License auf der Gnu-Homepage unter
'   "http://org.gnu.de/copyleft/gpl.html".
' Historie:
'   30.12.2001 J.W.Schmitz-Hbsch erstellt
'   06.01.2002 Erweitert fr Powerpoint
'              PathSeparator steht jetzt als path_separator in der Registry (fehlt in Powerpoint)
'   23.01.2002 von allen drei Add-Ins genutzte Funktionen nach PDF_Global.bas ausgelagert
'   16.02.2002 umbenannt in XLS_Erzeugen
'   09.05.2002 Erweitert um Lschen der PS-Datei wenn gbPSDateiLoeschenFlag gesetzt ist
'   09.05.2002 Nur fr eine Tabelle eine PDF-Datei erzeugen, wenn gbEinTeilobjektFlag gesetzt ist
'   17.05.2002 Die Zeichen {}+^%~()[] knnen jetzt auch in Daten-und Tabellennamen von Excel
'              vorkommen. Das Prozentzeichen % wird ausgeschlossen
'   18.05.2002 Dialoge umgestellt auf UserForm, Parametersteuerung je AddIn
'   02.07.2002 Erweitert um Dokumenteigenschaften und Lesezeichen
'   19.07.2002  Komplett umgebaut

'===================================================================================================
' Portierung von Word nach Excel und Powerpoint
'===================================================================================================
' Kommentare:
'   Word -> Excel -> Powerpoint
'   Word-Dokument -> Excel-Arbeitsmappe Powerpoint-Prsentation
'   Dokument -> Arbeitsmappe -> Prsentation
' Schlselworte:
'   Documents.Count -> Workbooks.Count -> Presentations.Count
'   ActiveDocument -> ActiveWorkbook -> ActivePresentation
'   ThisDocument -> ThisWorkbook -> For Each cbEinAddin In AddIns
'   ActivePrinter -> ActivePrinter -> ActivePresentation.PrintOptions.ActivePrinter

'===================================================================================================================
'Deklarationen
'===================================================================================================================

' Die folgenden Konstanen steuern die Verarbeitung in der Prozedur fbVorlageAnpassen
'-----------------------------------------------------------------------------------
Private Const sVORLAGE_ACTION_ERZEUGEN As String = "XLS_Prozeduren.ERZEUGEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const sVORLAGE_ACTION_INFO As String = "XLS_Prozeduren.INFO"
    'Modul- und Prozedurname fr die Anzeige der Informationen ber das Add-In.
Private Const sVORLAGE_ACTION_KONFIGURIEREN As String = "GLOB_Prozeduren.KONFIGURIEREN"
    'Modul- und Prozedurname fr das Konfigurieren des Add-In.
Private Const sVORLAGE_ACTION_DOKUMENTATION As String = "GLOB_Prozeduren.DOKUMENTATION"
    'Modul- und Prozedurname fr die Anzeige der Dokumentation des Add-In.
Private Const sVORLAGE_ACTION_MAILTO As String = "GLOB_Prozeduren.MAILEN"
    'Modul- und Prozedurname fr das Erzeugen einer PDF-Datei.
Private Const lVORLAGE_BUTTON_FACEID As Long = 2144
    'Symbol-ID fr den PDF-Button: 481=Herz, 276=Trauriger Smilie, 2144 = Zahnrder
Private Const lVORLAGE_BUTTON_BEFOREID As Long = 21
    'ID eines Buttons in der Symboleiste Standard. Vor diesem Button wird der PDF-Button eingefgt.
    '2520=Neu, 23=ffnen, 3 = Speichern, 2521=Drucken, 109=Seitenansicht, 2566=Rechtscheibung und Grammatik,
    '21=Ausschneiden,, ..., 984=Hilfe
    'Wenn die Nummer ungltig oder 0 ist, wird der PDF-Button vor den letzten Button eingefgt.

'===================================================================================================================
'Vorlage anpassen beim Start von Excel
'===================================================================================================================
    
Sub Auto_Open()

    On Error GoTo Fehler_aufgetreten:
    
    Call fbVorlageAnpassen(False)
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisWorkbook.Name & " - Auto_Open" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER

End Sub

Function fbVorlageAnpassen(bUnbedingtSpeichernFlag As Boolean) As Boolean
    'Die Prozedur erstellt in dieser Vorlage beim Aufruf ...
    '    1. in der aktiven Menleiste ein Men "PDF".
    '    2. in der Symbolleiste "Standard" einen Button "PDF", wenn dies in der Konfiguration vorgesehen ist.
    'Wenn all das schon richtig eingestellt war, und bUnbedingterUpdateFlag = False ist, dann geschieht nichts.
    'Argumente:
    '   bUnbedingterUpdateFlag
    '       Thrue = Die Vorlage wird unbedingt gespeichert.
    '       False = Die Vorlage wird nur dann gespeichert, wenn das Menue oder die Buttons verndert wurde.
    'Rckgabewert:
    '   True = das Men und ggf. die Symbolleiste "Standard" wurden angepasst.
    'Effekt
    '   ggf. wurde Menleiste und ggf. Symbolleiste verndert.
    
    Const sVORLAGE_TAG As String = "Gs4WordXLS20011229"
        'Identifikation der PDF-Mens und -Buttons. Dieser Tag-String darf nie gendert werden.
    
    Dim cbAktiveMenueLeiste As CommandBar
    Dim cbEinControl As CommandBarControl
    Dim cbEinButton As CommandBarButton
    Dim iPosition As Integer
    Dim iZaehler As Integer
    Dim lAnzahlPDFMenues As Long
    Dim lAnzahlPDFButtons As Long
    
    ' (1) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_EXCEL) 'um gbButtonFlag zu fllen. Die Konfiguration muss nicht in der Registry stehen.
        
    ' (2) CustomizationContext setzen
    '--------------------------------
    ' Entfllt in Excel

    Set cbAktiveMenueLeiste = CommandBars.ActiveMenuBar
    
    ' (3) Prfen, ob Menu oder Button verndert werden muss
    '------------------------------------------------------
    'Prfen ob das PDF-Men schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Mens vorhanden sind!
    lAnzahlPDFMenues = 0
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'ein PDF-Menu gefunden
            lAnzahlPDFMenues = lAnzahlPDFMenues + 1
        End If
    Next cbEinControl
    
    'Prfen ob der PDF-Button schon vorhanden ist.
    'Die Routine muss auch dann fehlerfrei arbeiten, wenn mehrere PDF-Buttons vorhanden sind!
    lAnzahlPDFButtons = 0
    For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then 'einen PDF-Button gefunden
            lAnzahlPDFButtons = lAnzahlPDFButtons + 1
        End If
    Next cbEinControl
    
    'Fertig wenn nicht unbedingt gespeichert werden muss und das PDF-Men schon vorhanden ist und der PDF-Button richtig an oder aus ist.
    If bUnbedingtSpeichernFlag = False _
    And lAnzahlPDFMenues = 1 _
    And ((gbButtonFlag = False And lAnzahlPDFButtons = 0) Or (gbButtonFlag = True And lAnzahlPDFButtons = 1)) Then
        Exit Function 'Sollzustand erreicht -> fertig
    End If
    'Es kann nur dann weitergehen, wenn die Vorlage nicht schreibgeschtzt ist.
    ' Entfllt in Excel
    
    ' (4) Aktive Menleiste um das PDF-Men erweitern
    '------------------------------------------------
    'Alle ggf. vorhandenen PDF-Mens lschen
    For Each cbEinControl In cbAktiveMenueLeiste.Controls
        If cbEinControl.Tag = sVORLAGE_TAG Then
            cbEinControl.Delete
        End If
    Next cbEinControl
   
    'Men "PDF" einfgen
    Set cbEinControl = cbAktiveMenueLeiste.Controls.Add(Type:=msoControlPopup, _
        Before:=cbAktiveMenueLeiste.Controls.Count, Temporary:=True)
    With cbEinControl
        .Caption = sVORLAGE_MENU_CAPTION
        .Tag = sVORLAGE_TAG
    End With

    'Befehl "Erzeugen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_ERZEUGEN_CAPTION
        .OnAction = sVORLAGE_ACTION_ERZEUGEN
    End With
    
    'Befehl "Mailen" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_MAILTO_CAPTION
        .OnAction = sVORLAGE_ACTION_MAILTO
        If gsMailToSwitch = sMAILTOSWITCH_AUS Then
            .Enabled = False
        End If
    End With
    
    'Befehl "Konfigurieren" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_KONFIGURIEREN_CAPTION
        .OnAction = sVORLAGE_ACTION_KONFIGURIEREN
    End With
        
    'Befehl "Dokumentation" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_DOKUMENTATION_CAPTION
        .OnAction = sVORLAGE_ACTION_DOKUMENTATION
        If gsDokuAufruf = sLEER Then
            .Enabled = False
        End If
    End With
        
    'Befehl "Info" im PDF-Men
    Set cbEinButton = cbEinControl.Controls.Add(Type:=msoControlButton, Temporary:=True)
    With cbEinButton
        .Caption = sVORLAGE_MENU_INFO_CAPTION
        .OnAction = sVORLAGE_ACTION_INFO
    End With
        
    ' (5) Symbolleiste "Standard" um den PDF-Button erweitern
    '--------------------------------------------------------
    If lAnzahlPDFButtons > 0 Then
        'Alle vorhandenen PDF-Buttons lschen
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            If cbEinControl.Tag = sVORLAGE_TAG Then
                cbEinControl.Delete
            End If
        Next cbEinControl
    End If
    
    If gbButtonFlag = True Then
        'Einen PDF-Button einfgen.
        'Zuerst nach der Position des Buttons suchen, vor dem der PDF-Button stehen soll
        iZaehler = 0
        iPosition = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Count
        For Each cbEinControl In CommandBars(sVORLAGE_SYMBOLLEISTE).Controls
            iZaehler = iZaehler + 1
            If cbEinControl.Id = lVORLAGE_BUTTON_BEFOREID Then
                iPosition = iZaehler
                Exit For
            End If
        Next cbEinControl
        Set cbEinControl = CommandBars(sVORLAGE_SYMBOLLEISTE).Controls.Add(Type:=msoControlButton, Id:=1, _
            Before:=iPosition, Temporary:=True)
        With cbEinControl
            .FaceId = lVORLAGE_BUTTON_FACEID
            '.BeginGroup = True 'wanns scheee maacht
            .Caption = sVORLAGE_BUTTON_CAPTION
            .Style = msoButtonAutomatic
            .Tag = sVORLAGE_TAG
            .TooltipText = sVORLAGE_BUTTON_TOOLTIPTEXT
            .OnAction = sVORLAGE_ACTION_ERZEUGEN
        End With
    End If
    
    ' (6) Vorlage speichern
    '----------------------
    ' Entfllt in Excel
    
    fbVorlageAnpassen = True
    
End Function
    
'===================================================================================================================
'Men "PDF > Info"
'===================================================================================================================
    
Private Sub INFO()
    'Die Prozedur zeigt eine Box mit Informationen ber das Add-In an.
    'Effekt
    '   Die Info-Box wurde angezeigt.
    
    Call fbInfo_anzeigen(ThisWorkbook.FullName)
    
End Sub
    
'===================================================================================================
'Men "PDF > Erzeugen..."
'===================================================================================================

Sub ERZEUGEN()
Attribute ERZEUGEN.VB_Description = "pdf"
Attribute ERZEUGEN.VB_ProcData.VB_Invoke_Func = "p\n14"
    'Effekt
    '   Ggf. wurden ein oder zwei Dialoge gefhrt oder eine Fehlermeldung angezeigt.
    '   Ggf. wurde eine Postscript-Datei gelscht.
    '   Ggf. wurde  eine PDF-Datei erzeugt.
    
    On Error GoTo Fehler_aufgetreten:
 
    Dim sPDFDateiName As String 'Name der PDF-Datei mit absolutem Pfad
    Dim sPSDateiName As String 'Name der Postscript-Datei mit absolutem Pfad
       
    gsMailtoDateiName = sLEER
    
    ' (1) Office-Datei prfen
    '------------------------
    If fbOfficeDatei_gespeichert() = False Then
       Exit Sub
    End If
       
    ' (2) Konfiguration lesen und prfen
    '-----------------------------------
    Call fbKonfiguration_lesen(sTASKNAME_EXCEL) 'Dabei auch gsAusgabeMedienListe() fllen
    If fbKonfiguration_testen(sTASKNAME_EXCEL) = False Then
        MsgBox sMSG_KONFIGUNVOLLSTAENDIG, vbExclamation, sTITEL_ERZEUGEN
        Exit Sub
    End If
    
    ' (3) Name der Postscript- und PDF-Datei ermitteln
    '-------------------------------------------------
    gsBasisDateiName = fsBasisDateiName_ermitteln(gsSymbDateiName)
    If gsBasisDateiName = sLEER Then
        Exit Sub
    End If
    
    ' (4) Einstellungen_waehlen
    '--------------------------
    If fbEinstellungen_waehlen(sTASKNAME_EXCEL) = False Then
       Exit Sub
    End If
            
    ' (5) Namen der Postscript- und PDF-Dateien prfen und Dateien lschen, wenn vorhanden
    '-------------------------------------------------------------------------------------
    sPSDateiName = gsBasisDateiName & sPS
    sPDFDateiName = gsBasisDateiName & sPDF
    If fbDatei_pruefen_loeschen(sPSDateiName) = False Then
        Exit Sub
    End If
    If fbDatei_pruefen_loeschen(sPDFDateiName) = False Then
        Exit Sub
    End If
                        
    ' (6) Postscript-Datei erzeugen
    '------------------------------
    If fbPSDatei_erzeugen(ActiveWorkbook.FullName, sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (7) Postscript-Datei ergaenzen
    '-------------------------------
    If fbPSDatei_ergaenzen(sPSDateiName) = False Then
        Exit Sub
    End If
    
    ' (8) PDF-Datei erzeugen
    '-----------------------
    If fbPDFDatei_erzeugen(sPSDateiName, sPDFDateiName, gsAusgabeMedium) = False Then
        Exit Sub
    End If
    
    ' (9) Postscript-Datei wieder lschen
    '------------------------------------
    If gbPSDateiLoeschenFlag = True Then
        If fbDatei_loeschen(sPSDateiName) = False Then
            Exit Sub
        End If
    End If
    
    ' (10) PDF-Datei anzeigen
    '------------------------
    Call fbPDFDatei_anzeigen(sPDFDateiName)
    
    ' (11) PDF-Datei zum mailen merken
    '---------------------------------
    gsMailtoDateiName = sPDFDateiName
    
    Exit Sub
    
Fehler_aufgetreten:
    'Dies ist die einzige "aktivierte" Fehlerbehandlungsroutine in dieser Prozedur.
    'In allen aufgerufenen Prozeduren wird immer "On Error GoTo 0" kodiert.
    MsgBox sMSG_LAUFZEITFEHLER _
        & vbCr & Application.Name & sSPACE & Application.VBE.Version & " - " _
        & ThisWorkbook.Name & " - ERZEUGEN" _
        & vbCr & "# " & Str(Err.Number) & sSPACE & Err.Description _
        , vbExclamation, sTITEL_FEHLER
    
End Sub

'===================================================================================================
'Alle Private Funktionen und Subroutinen, die nur von der Subroutine ERZEUGEN verwendet werden.
'===================================================================================================

Private Function fbOfficeDatei_gespeichert() As Boolean
    'Die Funktion prft, ob eine Office-Datei geffnent ist und ob es jemals gespeichert wurde.
    'Zustzlich wird be Excel geprft, ob die aktuelle Tabelle nicht leer ist
    'Global:
    '   ActiveWorkbook.Path
    '   ActiveWorkbook.Name
    '   Workbooks.Count
    '   gsPathSeparator wird gelesen
    'Rckgabewert:
    '   False = Office-Datei ist nicht gespeichert
    '   True = Office-Datei ist gespeichert und hat eine Pfad
    'Effekt
    '   Ggf. wurde eine Fehlermeldung angezeigt.
    
    Dim iTabelleLeerFlag As Integer
    Dim iAntwort
    Dim oAktuelleZelle, oLetzteZelle As Object
    
    fbOfficeDatei_gespeichert = False
    
    If Workbooks.Count < 1 Then  'Es ist keine Office-Datei geffnet
        MsgBox sMSG_KEINEOFFICEDATEI, vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
    
    If ActiveWorkbook.Name = sLEER _
    Or ActiveWorkbook.Path = sLEER _
    Or flLetztesVorkommen_suchen(ActiveWorkbook.Name, ".") <= 0 Then
        'Die geffnete Office-Datei ist nicht gespeichert
        MsgBox sMSG_OFFICEDATEINICHTGESPEICHERT _
            & vbCr & "(" & CurDir & gsPathSeparator & ActiveWorkbook.Name & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        Exit Function
    End If
   
    iTabelleLeerFlag = 99
    
    On Error Resume Next
    'Falls keine Tabelle sondern ein Diagramm aktiv ist, bleibt iTabelleLeerFlag unverndert auf 99
    iTabelleLeerFlag = IsEmpty(Cells(1, 1).Value)
    On Error GoTo 0
    
    ' Bei iTabelleLeerFlag = 99 ist ActiveSheet keine Tabelle.
    ' Bei iTabelleLeerFlag = 0 ist ActiveSheet eine Tabelle, deren Zelle A1 nicht leer ist.
    ' Bei iTabelleLeerFlag = -1 ist ActiveSheet eine Tabelle, deren Zelle A1 leer ist. Desbalb wird
    ' hier noch einmal geprft, ob die Tabelle wirklich leer ist. Da das bei grossen, sehr leeren
    ' Tabellen lange dauert, werden nur die ersten 256 Zeilen berprft.
    If iTabelleLeerFlag = -1 Then
        Set oLetzteZelle = Cells.SpecialCells(xlCellTypeLastCell)
        'Falls die letzte Spalte oder Zeile verborgen ist, wird sie nur bercksichtigt, wenn die
        'nchste Spalte oder Zeile ebenfalls berprft wird.
        If oLetzteZelle.Column < 256 Then 'Maximal 256
            Set oLetzteZelle = oLetzteZelle.Offset(0, 1)
        End If
        If oLetzteZelle.Row < 255 Then ' Maximal 65536
            Set oLetzteZelle = oLetzteZelle.Offset(1, 0) 'auf 255 setzen
        Else ' Maximal 256 Zeilen berprfen sonst dauert es zu lange
            Set oLetzteZelle = Cells(256, oLetzteZelle.Column)
        End If
        For Each oAktuelleZelle In Worksheets(ActiveSheet.Name).Range(Cells(1, 1), _
        oLetzteZelle.Address)
            If Not IsEmpty(oAktuelleZelle.Value) _
            Or Not oAktuelleZelle.Value = "" Then
               fbOfficeDatei_gespeichert = True
               Exit Function
            End If
        Next oAktuelleZelle
                
        If oLetzteZelle.Row < 256 Then
            MsgBox sMSG_EXCELTABELLEISTLEER _
                , vbExclamation, sTITEL_ERZEUGEN
        Else
            If MsgBox(sMSG_EXCELTABELLEWAHRSCHEINLICHLEER _
                , vbYesNo, sTITEL_ERZEUGEN) = vbYes Then
                fbOfficeDatei_gespeichert = True
            End If
        End If
    Else
        fbOfficeDatei_gespeichert = True
    End If
    

End Function

Private Function fbEinstellungen_waehlen(sTaskName As String) As Boolean
    'Die Funktion zeigt die UserForm fr die nderbaren Einstellungen an.
    'Die genderten Werte werden in den globalen Variablen gespeichert.
    'Falls der BasisDateiName verndert wurde, wird er neu erzeugt und geprft.
    'Argumente:
    '   sTaskName ist der Taskname in Grossbuchstaben. Der Wert muss einer der Konstanten
    '       sTASKNAME_XXXX aus GLOB_Prozeduren entsprechen.
    'Global:
    '   gbDialogFlag wird gelesen
    '   gbEinTeilobjektFlag wird ggf. verndert
    '   gsAusgabeMedium wird ggf. verndert
    '   gsBasisDateiName wird ggf. verndert
    '   giDialogEffekt wird gesetzt
    'Rckgabewert:
    '   False = Die Auswahl der Einstellungen wurde abgebrochen oder der genderte BasisDateiName
    '           ist fehlerhaft
    '   True = Die Einstellungen wurden ausgewhlt
    'Effekt
    
    If gbDialogFlag = True Then 'Einstellungen im Dialog ndern
        GLOB_UserForm.Show
        fbEinstellungen_waehlen = giDialogEffekt
        
        If giDialogEffekt = True Then
            gsBasisDateiName = fsBasisDateiName_ermitteln(gsBasisDateiName)
            If gsBasisDateiName = sLEER Then 'genderter BasisDateiName ist fehlerhaft
                fbEinstellungen_waehlen = False
            End If
        End If
    Else
        fbEinstellungen_waehlen = True
    End If

End Function

Private Function fbPSDatei_erzeugen(sOfficeDateiName As String, sPSDateiName As String) As Boolean
    'Erzeugt aus sOfficeDateiName die Postscriptdatei sPSDateiName. Wenn das nicht mglich ist, wird
    'eine Meldung angezeigt.
    'Argumente:
    '   sOfficeDateiName = Dateiname der aktiven Office-Datei
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Global:
    '   gbEinTeilobjektFlag wird gelesen
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht erzeugt werden.
    '   True = Postscript-Datei sPSDateiName wurde erzeugt.
    'Effekt
    '   Entweder wurde eine Postscript-Datei erzeugt
    '   oder eine Fehlermeldung angezeigt.
    
    Dim bPSDateiLocked As Boolean
    Dim sStandardDruckerName As String 'Name des aktuell eingesteller Druckers mit on-Klausel
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    
    sStandardDruckerName = ActivePrinter
    If fbActivePrinterAuf_gsDruckerName_setzen() = False Then
        MsgBox sMSG_PSDRUCKERUNBEKANNT _
            & vbCr & "(" & gsPSDruckerName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
        Exit Function
    End If
        
    'Jetzt drucken. In Word und Powerpoint wird erzwungen, dass das Add-In erst dann weiterluft,
    'wenn die Postscript-Datei vollstndig erzeugt wurde. Das ist in Excel nicht mglich!
    
    SendKeys fsSendKeysString_erzeugen(sPSDateiName) & "{ENTER}"
    
    Select Case gsPrintSwitch
    Case sPRINTSWITCH_EXCEL_ARBEITSMAPPE 'Die ganze Arbeitsmappe ausgeben
        ActiveWorkbook.PrintOut , PrintToFile:=True, Collate:=True
    Case sPRINTSWITCH_EXCEL_TABELLE 'Nur die aktuelle Tabelle ausgeben
        ActiveSheet.PrintOut , PrintToFile:=True, Collate:=True
    Case sPRINTSWITCH_EXCEL_TABELLENAUSWAHL ' Nur markierten Tabellen ausgeben
        ActiveWorkbook.Windows(1).SelectedSheets.PrintOut , PrintToFile:=True, Collate:=True
        'Window(1) ist immer das aktuelle Fenster
    Case Else
        MsgBox sMSG_CASEELSE & vbCr & "(fbPSDatei_erzeugen)" _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
        
    'In Excel ist im Druckdialog der Schalter "Ausgabe in Datei umleiten" jetzt unverndert
    
    'Standard-Drucker wieder setzen
    If sStandardDruckerName <> ActivePrinter Then
        On Error Resume Next ' falls der Drucker in der Zwischenzeit gelscht wurde (na ja)
        ActivePrinter = sStandardDruckerName
        On Error GoTo 0
    End If
    
    If Dir(sPSDateiName, vbNormal) <> sLEER Then
        'Dir liefert den ersten gefundenden Dateinamen oder sLEER
        If FileLen(sPSDateiName) > 0 Then
            'Die PS-Datei muss auch einen Inhalt haben
            fbPSDatei_erzeugen = True
            Exit Function
        End If
    End If
    
    'Ab hier nur noch Fehlerhandling
    If InStr(sPSDateiName, ",") > 0 Then
        MsgBox sMSG_PSDATEIMITKOMMA _
            & vbCr & "(" & gsPSDruckerName & ") - (" & sPSDateiName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    Else
        MsgBox sMSG_PSDATEINICHTERZEUGT _
            & vbCr & "(" & gsPSDruckerName & ") - (" & sPSDateiName & ")" _
            , vbExclamation, sTITEL_ERZEUGEN
        fbPSDatei_erzeugen = False
    End If

End Function
    
Private Function fbPSDatei_ergaenzen(sPSDateiName As String) As Boolean
    'Die Funktion ergnzt die Postscriptdatei sPSDateiName um Dokumenteigenschaften und Lesezeichen
    'Global:
    '   gbPdfmarkFlag wird gelesen
    'Argumente:
    '   sPSDateiName = Dateiname der Postscript-Datei
    'Rckgabewert:
    '   False = Postscript-Datei sPSDateiName konnte nicht ergnzt werden.
    '   True = Postscript-Datei sPSDateiName wurde ergnzt.
    'Effekt
    '   Ggf. wurde die Postscript-Datei verndert
    '   oder eine Fehlermeldung angezeigt.
    
    Dim sAuthor As String
    Dim sCreationDate As String
    Dim sCreator As String
    Dim sTitle As String
    Dim sSubject As String
    Dim sKeywords As String
    Dim sModDate As String
    Dim lTablesOfContents As Long
    Dim bUeberschriften As Boolean
    Dim sPageHeight As Single
    Dim sPageWidth As Single
    Dim lPaperSize As Long
    Dim lOrientation As Long 'xlLandscape oder xlPortrait
    
    If gbPdfmarkFlag = False Then 'Keine pdfmarks verwenden
        fbPSDatei_ergaenzen = True
        Exit Function
    End If
    
    On Error Resume Next ' falls ein Element nicht definiert ist
    sAuthor = ActiveWorkbook.BuiltinDocumentProperties("Author")
    sCreationDate = Format(ActiveWorkbook.BuiltinDocumentProperties("Creation date"), "yyyymmDdhhnnss")
    sCreator = ActiveWorkbook.BuiltinDocumentProperties("Application name")
    sTitle = ActiveWorkbook.BuiltinDocumentProperties("Title")
    sSubject = ActiveWorkbook.BuiltinDocumentProperties("Subject")
    sKeywords = ActiveWorkbook.BuiltinDocumentProperties("Keywords")
    sModDate = Format(ActiveWorkbook.BuiltinDocumentProperties("Last save time"), "yyyymmDdhhnnss")
    lTablesOfContents = 0
    bUeberschriften = False
    lPaperSize = ActiveSheet.PageSetup.PaperSize
    lOrientation = ActiveSheet.PageSetup.Orientation
    On Error GoTo 0
    
    sPageHeight = 0
    sPageWidth = 0
    ' 1 Punkt = 0.35 mm
    ' 1 Zoll = 72 Punkte = 25,4 mm
    Select Case lOrientation
    Case xlPortrait  'Hochformat
        Select Case lPaperSize
        Case xlPaperLetter   'US-Letter (8-1/2 x 11 Zoll)
            sPageHeight = 11 * 72
            sPageWidth = 8.5 * 72
        Case xlPaperLegal    'US-Legal (8 1/2 x 14 Zoll)
            sPageHeight = 14 * 72
            sPageWidth = 8.5 * 72
        Case xlPaperExecutive    'US-Executive (7 1/2 x 10 1/2 Zoll)
            sPageHeight = 10.5 * 72
            sPageWidth = 7.5 * 72
        Case xlPaperA3   'A3 (297 x 420 mm)
            sPageHeight = 420 / 0.35
            sPageWidth = 297 / 0.35
        Case xlPaperA4   'A4 (210 x 297 mm)
            sPageHeight = 297 / 0.35
            sPageWidth = 210 / 0.35
        Case xlPaperA5   'A5 (148 x 210 mm)
            sPageHeight = 210 / 0.35
            sPageWidth = 148 / 0.35
        Case xlPaperB4   'B4 (250 x 354 mm)
            sPageHeight = 354 / 0.35
            sPageWidth = 250 / 0.35
        Case xlPaperB5   'B5 (182 x 257 mm)
            sPageHeight = 257 / 0.35
            sPageWidth = 182 / 0.35
        End Select
    Case xlLandscape  'Querformat
        Select Case lPaperSize
        Case xlPaperLetter   'US-Letter (8-1/2 x 11 Zoll)
            sPageHeight = 8.5 * 72
            sPageWidth = 11 * 72
        Case xlPaperLegal    'US-Legal (8 1/2 x 14 Zoll)
            sPageHeight = 8.5 * 72
            sPageWidth = 14 * 72
        Case xlPaperExecutive    'US-Executive (7 1/2 x 10 1/2 Zoll)
            sPageHeight = 7.5
            sPageWidth = 10.5
        Case xlPaperA3   'A3 (297 x 420 mm)
            sPageHeight = 297 / 0.35
            sPageWidth = 420 / 0.35
        Case xlPaperA4   'A4 (210 x 297 mm)
            sPageHeight = 210 / 0.35
            sPageWidth = 297 / 0.35
        Case xlPaperA5   'A5 (148 x 210 mm)
            sPageHeight = 148 / 0.35
            sPageWidth = 210 / 0.35
        Case xlPaperB4   'B4 (250 x 354 mm)
            sPageHeight = 250 / 0.35
            sPageWidth = 354 / 0.35
        Case xlPaperB5   'B5 (182 x 257 mm)
            sPageHeight = 182 / 0.35
            sPageWidth = 257 / 0.35
        End Select
    End Select
        
    fbPSDatei_ergaenzen = fbPSDateiPdfmark_ergaenzen(sPSDateiName, _
    sAuthor, sCreationDate, sCreator, sTitle, _
    sSubject, sKeywords, sModDate, lTablesOfContents, bUeberschriften, _
    sPageHeight, sPageWidth)
    
End Function

Private Function fbActivePrinterAuf_gsDruckerName_setzen() As Boolean
    'Die Funktion setzt ActivePrinter auf gsDruckerName.
    'In VBA fr Excel muss dabei auch der Port angegeben werden.
    'Die Funktion setzt in Excel nur dann den ActivePrinter, wenn der Port einen der folgenden Namen
    'hat:
    '   Port aus gsDruckerPort, Port des aktiven Druckers,
    '   FILE:, RTP1: ... RPT9:, LPT1: ... LPT9:, COM1: ... COM9:, NE01: ... NE09:, FPR1 ... FPR9
    'Global:
    '   gsPSDruckerName wird gelesen
    '   gsPSDruckerPort wird gelesen und verndert
    'Rckgabewert:
    '   True = Der Drucker aus gsDruckerName ist der ActivePrinter.
    '   False = Der Drucker aus gsDruckerName konnte nicht zum ActivePrinter
    '           gemacht werden. Der ActivePronter ist unverndert.
    'Effekt
    '   ActivePrinter verndert
    
    Dim sDruckerPortmitBindewort As String 'xxx XXXX:
    Dim sDruckerPort As String
    Dim sBindewort '"on " oder "auf "
    Dim iFehlerNummer As Integer 'Fehlernumer aus ActivePrinter
    Dim bZaehler As Byte
    Dim sEinAnschlussTyp As Variant
    Dim sAnschlussTyp(4) As String 'Tabelle mit Anschlusstypen, die passen knnten.
    'Namen aller Anschlusstypen
    sAnschlussTyp(0) = "RPT"
    sAnschlussTyp(1) = "LPT"
    sAnschlussTyp(2) = "COM"
    sAnschlussTyp(3) = "NE0" 'Netgear Printserver
    sAnschlussTyp(4) = "FPR" 'FinePrint

    'Der Drucker gsDruckerName schon aktiv?
    If gsPSDruckerName = fsDruckerName_ermitteln(ActivePrinter) Then ' das war's
        fbActivePrinterAuf_gsDruckerName_setzen = True
        Exit Function
    End If
    
    'Zuerst einmal mit dem Anschluss gsDruckerPort versuchen
    sDruckerPortmitBindewort = fsDruckerPort_ermitteln(ActivePrinter)
    sBindewort = Left(sDruckerPortmitBindewort, InStr(sDruckerPortmitBindewort, sSPACE))
    sDruckerPort = Mid(gsPSDruckerPort, InStr(gsPSDruckerPort, sSPACE) + 1)
    sDruckerPortmitBindewort = sBindewort & sDruckerPort
    On Error Resume Next ' falls es nicht der richtige Anschluss ist
    ActivePrinter = gsPSDruckerName & sSPACE & sDruckerPortmitBindewort
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then ' das war's
        gsPSDruckerPort = sDruckerPortmitBindewort
        fbActivePrinterAuf_gsDruckerName_setzen = True
        Exit Function
    End If
    
    'Danach mit dem Anschluss des aktiven Druckers versuchen
    sDruckerPortmitBindewort = fsDruckerPort_ermitteln(ActivePrinter)
    On Error Resume Next ' falls es nicht der richtige Anschluss ist
    ActivePrinter = gsPSDruckerName & sSPACE & sDruckerPortmitBindewort
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then ' das war's
        gsPSDruckerPort = sDruckerPortmitBindewort
        fbActivePrinterAuf_gsDruckerName_setzen = True
        Exit Function
    End If
    
    'Jetzt mit dem Anschluss FILE: versuchen
    sDruckerPortmitBindewort = sBindewort & "FILE:"
    On Error Resume Next ' falls es nicht der richtige Anschluss ist
    ActivePrinter = gsPSDruckerName & sSPACE & sDruckerPortmitBindewort
    iFehlerNummer = Err.Number
    On Error GoTo 0
    If iFehlerNummer = 0 Then ' das war's
        gsPSDruckerPort = sDruckerPortmitBindewort
        fbActivePrinterAuf_gsDruckerName_setzen = True
        Exit Function
    End If
    
    'Jetzt mit allen Anschlusstypen aus der Tabelle sAnschluss versuchen
    For bZaehler = 1 To 9 Step 1
        For Each sEinAnschlussTyp In sAnschlussTyp
            sDruckerPortmitBindewort = sBindewort & sEinAnschlussTyp & bZaehler & ":"
            On Error Resume Next ' falls es nicht der richtige Anschluss ist
            ActivePrinter = gsPSDruckerName & sSPACE & sDruckerPortmitBindewort
            iFehlerNummer = Err.Number
            On Error GoTo 0
            If iFehlerNummer = 0 Then ' das war's
                gsPSDruckerPort = sDruckerPortmitBindewort
                fbActivePrinterAuf_gsDruckerName_setzen = True
                Exit Function
            End If
        Next sEinAnschlussTyp
    Next bZaehler
        
    'Das war wohl nichts
    fbActivePrinterAuf_gsDruckerName_setzen = False

End Function

Private Function fsSendKeysString_erzeugen(sString As String) As String
    'Die Funktion erzeugt aus sName einen gltigen SendKey-String.
    'Das Pluszeichen (+), Caret-Zeichen (^), Prozentzeichen (%), die Tilde (~), die Klammern ( ),
    'die Eckige Klammern ([ ]) und die geschweiften Klammern ({ }) mssen bei der SendKeys-Anweisung
    'in geschweifte Klammern eingeschlossen werden.
    'Argumente:
    '   sString = String der mittels SendKey gesendet werden soll
    'Rckgabewert:
    '   xx..xx = erweiterter String, der von SendKey verarbeitet werden kann
    'Effekt
    '   keiner

    Dim lStringPos, lUmzZeichenPos As Long 'Zhler
    Dim sEinZeichen As String
    Dim sUmzusetzendeZeichen As String 'String mit Zeichen, die in {}eingeschlossen werden mssen.
    sUmzusetzendeZeichen = "{}+^%~()[]"
           
    fsSendKeysString_erzeugen = sLEER

    For lStringPos = 1 To Len(sString)
        sEinZeichen = Mid(sString, lStringPos, 1)
        lUmzZeichenPos = InStr(1, sUmzusetzendeZeichen, sEinZeichen, vbTextCompare)
        If lUmzZeichenPos > 0 Then
            fsSendKeysString_erzeugen = fsSendKeysString_erzeugen & "{" & sEinZeichen & "}"
        Else
            fsSendKeysString_erzeugen = fsSendKeysString_erzeugen & sEinZeichen
        End If
    Next lStringPos

End Function

'===================================================================================================
'Alle Funktionen und Subroutinen, die von der Subroutine ERZEUGEN
'und von ComboBoxEinTeilobjektFlag_Change verwendet werden.
'===================================================================================================

Function fsBasisDateiName_ermitteln(sSymbDateiName As String) As String
    'Die Funktion ermittelt aus sSymbDateiName den BasisDateinamen mit Pfad fr die PS- und
    'PDF-Datei. Dabei werden auch Namenszustze bercksichtigt.
    'Argumente
    '   sSymbDateiName = Symbolischer Dateiname
    'Global:
    '   ActiveWorkbook.Path = Pfad des aktiven Office-Dokuments
    '   ActiveWorkbook.Name = Dateiname des aktiven Office-Dokuments
    '   gsPathSeparator wird gelesen
    '   gbEinTeilobjektFlag wird gelesen
    'Rckgabewert:
    '   sLEER = Es konnte kein Dateiname erzeugt werden
    '   "xxx...xxx" = BasisDateiname der Datei.
    'Effekt
        
    Dim sErweitererSymbDateiName As String 'Vollstndiger symbolischer Dateiname
    Dim sBasisName As String 'Name des aktiven Office-Dokuments ohne Pfad und Extension
    Dim lLaenge As Long
    Dim sPfadName As String
    Dim sNamenszusatz As String
    Dim vEinSheet As Variant
    
    If Left(sSymbDateiName, 2) = "\\" _
    Or (Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" _
    And Mid(sSymbDateiName, 3, 1) = gsPathSeparator) Then '"\\XXX" und "C:\XXX" unverndert lassen
        sErweitererSymbDateiName = sSymbDateiName
    ElseIf Asc(LCase(Left(sSymbDateiName, 1))) >= 97 _
    And Asc(LCase(Left(sSymbDateiName, 1))) <= 122 _
    And Mid(sSymbDateiName, 2, 1) = ":" Then '"C:XXX" wird zu "C:\aaa\XXX"
        sPfadName = CurDir(Left(sSymbDateiName, 2))
        If Right(sPfadName, 1) = gsPathSeparator Then
            sErweitererSymbDateiName = sPfadName & Mid(sSymbDateiName, 3)
        Else
            sErweitererSymbDateiName = sPfadName & gsPathSeparator & Mid(sSymbDateiName, 3)
        End If
    ElseIf Left(sSymbDateiName, 1) = gsPathSeparator Then
        '"\XXX" wird zu "D:\XXX" oder \\server\freigabe\XXX
        If Left(ActiveWorkbook.Path, 2) = "\\" Then '\\freigabe\server\
            lLaenge = InStr(InStr(3, ActiveWorkbook.Path, gsPathSeparator) + 1, _
                ActiveWorkbook.Path, gsPathSeparator) - 1
            If lLaenge < 3 Then 'Auch bei einem Fehler geht es weiter
                lLaenge = 0
            End If
        Else
            lLaenge = 2
        End If
        sErweitererSymbDateiName = Left(ActiveWorkbook.Path, lLaenge) & sSymbDateiName
    Else '"XXX" wird zu "D:\aaa\XXX"
        sErweitererSymbDateiName = ActiveWorkbook.Path & gsPathSeparator & sSymbDateiName
    End If
    
    Select Case gsPrintSwitch
    Case sPRINTSWITCH_EXCEL_ARBEITSMAPPE 'Die ganze Arbeitsmappe ausgeben
        sNamenszusatz = sLEER
    Case sPRINTSWITCH_EXCEL_TABELLE 'Nur die aktuelle Tabelle ausgeben
        sNamenszusatz = sBasisName & "_" & ActiveSheet.Name
    Case sPRINTSWITCH_EXCEL_TABELLENAUSWAHL ' Nur markierte Tabellen ausgeben
        For Each vEinSheet In ActiveWorkbook.Windows(1).SelectedSheets
            sNamenszusatz = sBasisName & "_" & vEinSheet.Name
        Next vEinSheet
    Case Else
        MsgBox sMSG_CASEELSE & vbCr & "(fsBasisDateiName_ermitteln)" _
            , vbExclamation, sTITEL_ERZEUGEN
        Error 51
    End Select
        
    sBasisName = Left(ActiveWorkbook.Name, _
        flLetztesVorkommen_suchen(ActiveWorkbook.Name, ".") - 1) & sNamenszusatz
    fsBasisDateiName_ermitteln = fsSymbDateiName_umsetzen(sErweitererSymbDateiName, sBasisName, sLEER)
    
End Function

'===================================================================================================
'DUMMY-Prozeduren fr GLOB_Prozeduren
'===================================================================================================

Function fbVorlageIstAenderbar() As Boolean
    'Dummy-Funktion fr GLOB_Prozeduren
    fbVorlageIstAenderbar = True
End Function

'===================================================================================================
'Ende.
'===================================================================================================

